"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var accordion_group_component_1 = require("./accordion-group.component");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var AccordionComponent = (function (_super) {
    __extends(AccordionComponent, _super);
    function AccordionComponent(_translateService, _http, _sharedService, elRef) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.elRef = elRef;
        _this._columns = 'col l12 m12 s12 sbm-panel-group';
        _this.id = '';
        _this.securityId = '';
        _this._items = [];
        _this.randomClass = 0;
        sbmAccordionComponent.push(_this);
        return _this;
    }
    Object.defineProperty(AccordionComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12 sbm-panel-group";
        },
        enumerable: true,
        configurable: true
    });
    AccordionComponent.prototype.ngOnInit = function () {
        this.randomClass = Math.floor((Math.random() * 1000) + 1);
        _super.prototype.validar.call(this, this.securityId);
    };
    AccordionComponent.prototype.setHtml = function (tab) {
        var me = this;
        var _data = [];
        $(me.elAccordions.nativeElement).find('sbm-accordion-group').each(function (i, a) {
            _data.push({ label: $(a).attr('label'), html: $(a).html(), id: "" + me.randomClass + i });
        });
        _data.map(function (a) {
            if (a.id == tab.id) {
                $("#sbm-content-" + a.id).html(a.html);
            }
        });
        // document.getElementById(`sbm-content-${tab.id}`).innerHTML = tab.html;
    };
    AccordionComponent.prototype.ngAfterViewInit = function () {
        var me = this;
        var _data = [];
        $(me.elAccordions.nativeElement).find('sbm-accordion-group').each(function (i, a) {
            _data.push({ label: $(a).attr('label'), html: $(a).html(), id: "" + me.randomClass + i });
        });
        this._items = _data;
        $(document).ready(function () {
            $(me.accordion.nativeElement).collapsible();
            me._items.map(function (a) {
                $("#sbm-content-" + a.id).html(a.html);
            });
        });
    };
    return AccordionComponent;
}(abstract_ngmodel_1.AbstractNgModel));
AccordionComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-accordion',
                template: "\n        <ul #accordion class=\"collapsible\" data-collapsible=\"accordion\">\n            <li *ngFor=\"let item of accordions\">\n              <div class=\"collapsible-header {{item.active ? 'active' : ''}} smb-accordion-collapsible-header\">\n                <i *ngIf=\"item.icon != ''\" class=\"material-icons\">{{item.icon}}</i>{{item._text}}\n              </div>\n              <div class=\"collapsible-body\">\n              <ng-template [ngTemplateOutlet]=\"item.columnTemplate\" [ngOutletContext]=\"{ item: item }\"></ng-template>\n                <!--<ng-content [select]=\"item.idAccordion\"></ng-content>-->\n              </div>\n            </li>\n        </ul>\n        \n        <div #elAccordions [hidden]=\"true\">\n            <!--<ng-content select=\".teste1\"></ng-content>-->\n            <!--<ng-content></ng-content>-->\n            <!--<ng-content select=\".textedeboxta\"></ng-content>-->\n        </div>\n    ",
                host: {
                    '[class]': 'columns'
                }
            },] },
];
/** @nocollapse */
AccordionComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
    { type: sharedService_1.SharedService, },
    { type: core_1.ElementRef, },
]; };
AccordionComponent.propDecorators = {
    'accordions': [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return accordion_group_component_1.AccordionGroupComponent; }),] },],
    'columns': [{ type: core_1.Input },],
    'accordion': [{ type: core_1.ViewChild, args: ['accordion',] },],
    'elAccordions': [{ type: core_1.ViewChild, args: ['elAccordions',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
};
exports.AccordionComponent = AccordionComponent;
