"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var sweetalert2_1 = require("sweetalert2");
var AlertComponent = (function () {
    function AlertComponent() {
    }
    AlertComponent.prototype.close = function () {
        try {
            sweetalert2_1.default.close();
        }
        catch (e) {
        }
    };
    AlertComponent.prototype.show = function (title, ConfirmTextButton, text, type, buttonCancel, CancelTextButton) {
        if (ConfirmTextButton === void 0) { ConfirmTextButton = 'OK'; }
        if (text === void 0) { text = ''; }
        if (type === void 0) { type = AlertEnumType[AlertEnumType.success]; }
        if (buttonCancel === void 0) { buttonCancel = false; }
        if (CancelTextButton === void 0) { CancelTextButton = 'Cancelar'; }
        return sweetalert2_1.default({
            title: title,
            text: text,
            type: type,
            showCancelButton: buttonCancel,
            confirmButtonText: ConfirmTextButton,
            cancelButtonText: CancelTextButton
        }).then(function (success) {
            return success;
        }, function () {
            return false;
        });
    };
    return AlertComponent;
}());
AlertComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-alert',
                template: "<!--no-template-->",
                styles: ["\n    .swal2-container {\n        z-index: 2000 !important;\n    }\n    "]
            },] },
];
/** @nocollapse */
AlertComponent.ctorParameters = function () { return []; };
exports.AlertComponent = AlertComponent;
var AlertEnumType;
(function (AlertEnumType) {
    AlertEnumType[AlertEnumType["success"] = 0] = "success";
    AlertEnumType[AlertEnumType["warning"] = 1] = "warning";
    AlertEnumType[AlertEnumType["error"] = 2] = "error";
    AlertEnumType[AlertEnumType["info"] = 3] = "info";
    AlertEnumType[AlertEnumType["question"] = 4] = "question";
})(AlertEnumType = exports.AlertEnumType || (exports.AlertEnumType = {}));
