"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var http_1 = require("@angular/http");
var req_http_service_1 = require("../../services/req-http.service");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var AutocompleteComponent = (function (_super) {
    __extends(AutocompleteComponent, _super);
    function AutocompleteComponent(_req, _el, _translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._req = _req;
        _this._el = _el;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.dataSource = '';
        _this.css = 'sbm-input';
        _this.notnull = false;
        _this.styleCss = '';
        _this.placeholder = 'Digite aqui';
        _this.text = ['text'];
        _this.textSeparator = '-';
        _this.reqIndexKey = 'data';
        _this.disabled = false;
        _this.readonly = false;
        _this.onClick = 'data';
        _this.onBlur = 'data';
        _this.onKeyup = 'data';
        _this._onClick = new core_1.EventEmitter();
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this._attribute = '';
        _this._label = '';
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this._dataSource = [];
        _this.dataAutocomplete = [];
        _this.randomId = '';
        _this.labelWidth = '';
        _this.isNotMasterDetail = true;
        sbmAutocompleteComponent.push(_this);
        return _this;
    }
    Object.defineProperty(AutocompleteComponent.prototype, "attribute", {
        get: function () {
            return this._attribute;
        },
        set: function (val) {
            this._attribute = val;
            this.name = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AutocompleteComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AutocompleteComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " s12 m12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    AutocompleteComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    AutocompleteComponent.prototype.ngAfterViewInit = function () {
        var me = this;
        $(this.autocomplete.nativeElement).attr('style', this.styleCss);
        $(this.autocomplete.nativeElement).focusin(function () {
            me.reqService();
        });
    };
    AutocompleteComponent.prototype.ngAfterViewChecked = function () {
        if ($(this._el.nativeElement).attr('dataSource') != this.dataSource) {
            this.dataSource = $(this._el.nativeElement).attr('dataSource');
            this.reqService();
        }
    };
    AutocompleteComponent.prototype.reqService = function () {
        var _this = this;
        if (this.dataSource != '') {
            if (this._dataSource.length == 0) {
                this._req.xhrGet(this.dataSource).subscribe(function (ret) {
                    _this._dataSource = ret.res[_this.reqIndexKey];
                });
            }
        }
    };
    AutocompleteComponent.prototype.itemClicado = function (event) {
        this._onClick.emit(event);
        this.value = event[this.text[0]];
        $(this.listautocomplete.nativeElement).css('display', 'none');
    };
    AutocompleteComponent.prototype.blur = function ($event) {
        var _this = this;
        this._onBlur.emit($event);
        setTimeout(function () {
            $(_this.listautocomplete.nativeElement).css('display', 'none');
        }, 500);
    };
    AutocompleteComponent.prototype.keyup = function ($event) {
        var _this = this;
        var me = this;
        var value = $event.target.value;
        this.dataAutocomplete = [];
        if (value != '') {
            this._dataSource.filter(function (v, i, a) {
                for (var _i = 0, _a = _this.text; _i < _a.length; _i++) {
                    var item = _a[_i];
                    if (v[item].indexOf(value) > -1) {
                        me.dataAutocomplete.push(v);
                        $(_this.listautocomplete.nativeElement).css('display', 'block');
                    }
                }
            });
        }
        this._onKeyup.emit($event);
    };
    return AutocompleteComponent;
}(abstract_ngmodel_1.AbstractNgModel));
AutocompleteComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-autocomplete',
                template: "\n        <input \n            #autocomplete \n            #component=\"ngModel\" \n            id=\"{{randomId}}\" \n            [name]=\"name\"\n            type=\"text\" class=\"{{css}}\" \n            [hidden]=\"!exibirComponente\" \n            [style]='styleCss' \n            [attr.data-source]=\"dataSource\" \n            [disabled]=\"disabled\"\n            [readonly]=\"readonly\"\n            [required]=\"notnull\"\n            (blur)=\"blur($event)\"\n            (keyup)='keyup($event)' \n            [(ngModel)]=\"value\" \n        >\n\n        <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n\n        <span *ngIf=\"!component.valid\" class=\"msgError\">\n        <p class=\"msgError\" *ngIf=\"component['errors']['required'] && component.touched\">\n            Campo Obrigat\u00F3rio\n        </p>\n        </span>\n\n        <ul style=\"display: none; margin-top: 0px;\" #listautocomplete class=\"autocomplete-content dropdown-content\">\n            <li *ngFor=\"let item of dataAutocomplete\" (click)=\"itemClicado(item)\">\n            <span class=\"list-autocomplete\" *ngFor=\"let a of text, let i = index\"> {{item[a]}} <a *ngIf=\"i+1 != text.length\">{{textSeparator}}</a></span>\n            </li>\n        </ul>\n    ",
                styles: ["\n        .list-autocomplete {\n            display: inline-block;\n            padding: 10px 5px 10px 5px;\n        }\n        .ng-invalid:not(.ng-untouched) {\n            border-bottom: 1px solid #F44336 !important;\n            box-shadow: 0 1px 0 0 #F44336 !important;\n        }\n    "],
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(AutocompleteComponent)]
            },] },
];
/** @nocollapse */
AutocompleteComponent.ctorParameters = function () { return [
    { type: req_http_service_1.ReqHttpService, },
    { type: core_1.ElementRef, },
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
    { type: sharedService_1.SharedService, },
]; };
AutocompleteComponent.propDecorators = {
    'autocomplete': [{ type: core_1.ViewChild, args: ['autocomplete',] },],
    'component': [{ type: core_1.ViewChild, args: ['component',] },],
    'listautocomplete': [{ type: core_1.ViewChild, args: ['listautocomplete',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input, args: ['securityid',] },],
    'name': [{ type: core_1.Input },],
    'dataSource': [{ type: core_1.Input, args: ['datasource',] },],
    'css': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'styleCss': [{ type: core_1.Input, args: ['stylecss',] },],
    'placeholder': [{ type: core_1.Input },],
    'text': [{ type: core_1.Input },],
    'textSeparator': [{ type: core_1.Input, args: ['textseparator',] },],
    'reqIndexKey': [{ type: core_1.Input },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'onClick': [{ type: core_1.Input, args: ['onclick',] },],
    'onBlur': [{ type: core_1.Input, args: ['onblur',] },],
    'onKeyup': [{ type: core_1.Input, args: ['onkeyup',] },],
    '_onClick': [{ type: core_1.Output },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    'attribute': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.AutocompleteComponent = AutocompleteComponent;
