"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var crud2_component_1 = require("../crud2/crud2.component");
var BreadcrumbCrudComponent = (function () {
    function BreadcrumbCrudComponent(_router) {
        this._router = _router;
        this.breadcrumbs = [];
        this.css = 'sbm-breadcrumb';
    }
    BreadcrumbCrudComponent.prototype.navegar = function (breadcrumb) {
        BreadcrumbCrudComponent.breadcrumbAlterado.emit(breadcrumb);
        this._router.navigate([breadcrumb.url]);
    };
    BreadcrumbCrudComponent.prototype.ngOnInit = function () {
        var _this = this;
        crud2_component_1.Crud2Component.breadcrumbAlterado.subscribe(function () {
            _this.breadcrumbs = [];
            _this.parseRoute(_this._router.routerState.snapshot.root);
        });
        this._router.events.subscribe(function (ret) {
            _this.breadcrumbs = [];
            _this.parseRoute(_this._router.routerState.snapshot.root);
        });
    };
    BreadcrumbCrudComponent.prototype.parseRoute = function (node) {
        var me = this;
        if (node.data['breadcrumbCrud']) {
            node.data['breadcrumbCrud'].map(function (o) {
                var bc = {
                    localStogare: (o['localStogare']) ? o['localStogare'] : '',
                    name: o['name'],
                    url: o['url']
                };
                me.breadcrumbs.push(bc);
            });
        }
        if (node.firstChild) {
            this.parseRoute(node.firstChild);
        }
    };
    return BreadcrumbCrudComponent;
}());
BreadcrumbCrudComponent.breadcrumbAlterado = new core_1.EventEmitter();
BreadcrumbCrudComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-breadcrumb-crud',
                template: "\n        <div class=\"{{css}}\" [hidden]=\"breadcrumbs.length == 0\">\n            <span *ngFor=\"let breadcrumb of breadcrumbs, let i = index;\">\n                <a [hidden]=\"i == (breadcrumbs.length - 1)\" (click)=\"navegar(breadcrumb)\">{{breadcrumb.name}}</a>\n                <span class=\"lastItemBreadcrumb\" *ngIf=\"breadcrumbs.length == i\" [hidden]=\"i != (breadcrumbs.length - 1)\">{{breadcrumb.name}}</span>\n            </span>\n        </div>\n    ",
                host: {
                    'class': 'col s12'
                }
            },] },
];
/** @nocollapse */
BreadcrumbCrudComponent.ctorParameters = function () { return [
    { type: router_1.Router, },
]; };
BreadcrumbCrudComponent.propDecorators = {
    'css': [{ type: core_1.Input },],
};
exports.BreadcrumbCrudComponent = BreadcrumbCrudComponent;
