"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var BreadcrumbComponent = (function (_super) {
    __extends(BreadcrumbComponent, _super);
    function BreadcrumbComponent(_router, _http, _translateService, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._router = _router;
        _this._http = _http;
        _this._translateService = _translateService;
        _this._sharedService = _sharedService;
        _this.breadcrumbs = [];
        _this.id = '';
        _this.securityId = 'breadcrumb';
        _this.css = 'sbm-breadcrumb';
        return _this;
    }
    BreadcrumbComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.validar.call(this, this.securityId);
        this._router.events.subscribe(function (event) {
            _this.breadcrumbs = [];
            _this.parseRoute(_this._router.routerState.snapshot.root);
        });
    };
    BreadcrumbComponent.prototype.navegar = function (breadcrumb) {
        this._router.navigate([breadcrumb.url]);
    };
    BreadcrumbComponent.prototype.parseRoute = function (node) {
        if (node['data']['breadcrumb']) {
            var urlSegments_1 = [];
            node.pathFromRoot.forEach(function (routeState) {
                urlSegments_1 = urlSegments_1.concat(routeState.url);
            });
            var url = urlSegments_1.map(function (urlSegment) {
                return urlSegment.path;
            }).join('/');
            var bc = {
                name: node['data']['breadcrumb'],
                url: '/' + url
            };
            this.breadcrumbs.push(bc);
        }
        if (node.firstChild) {
            this.parseRoute(node.firstChild);
        }
    };
    return BreadcrumbComponent;
}(abstract_ngmodel_1.AbstractNgModel));
BreadcrumbComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-breadcrumb',
                template: "        \n        <div class=\"{{css}}\" [hidden]=\"breadcrumbs.length == 0\">\n            <span *ngFor=\"let breadcrumb of breadcrumbs, let i = index;\">\n                <a [hidden]=\"i == (breadcrumbs.length - 1)\" (click)=\"navegar(breadcrumb)\">{{breadcrumb.name}}</a>\n                <span class=\"lastItemBreadcrumb\" [hidden]=\"i != (breadcrumbs.length - 1)\">{{breadcrumb.name}}</span>\n            </span>\n        </div>\n    ",
            },] },
];
/** @nocollapse */
BreadcrumbComponent.ctorParameters = function () { return [
    { type: router_1.Router, },
    { type: http_1.Http, },
    { type: core_2.TranslateService, },
    { type: sharedService_1.SharedService, },
]; };
BreadcrumbComponent.propDecorators = {
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
};
exports.BreadcrumbComponent = BreadcrumbComponent;
