"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var ButtonComponent = (function (_super) {
    __extends(ButtonComponent, _super);
    function ButtonComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.css = ''; //sbm-btn-default
        _this.styleCss = '';
        _this.color = '';
        _this.icon = '';
        _this.design = '';
        _this.title = '';
        _this.disabled = false;
        _this.type = ButtonEnumType[ButtonEnumType.normal];
        _this._columns = 'col l12 m12 s12';
        _this._onClick = new core_1.EventEmitter();
        _this.onClick = '';
        _this._text = null;
        sbmButtonComponent.push(_this);
        return _this;
    }
    Object.defineProperty(ButtonComponent.prototype, "text", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._text = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._text = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._text = val;
                }
            }
            else {
                this._text = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ButtonComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " m" + value + " s" + value;
        },
        enumerable: true,
        configurable: true
    });
    ButtonComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    ButtonComponent.prototype.itemClicado = function ($event) {
        this._onClick.emit($event);
        if (this.onClick != '') {
            window[this.onClick](true);
        }
    };
    return ButtonComponent;
}(abstract_ngmodel_1.AbstractNgModel));
ButtonComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-button',
                template: "\n        <a #button class=\"{{design != '' ? 'btn-'+design : 'btn'}} waves-effect {{css}} {{color}}\" (click)=\"itemClicado($event)\"\n            [attr.style]='styleCss' hidden=\"exibirComponente\"\n            [ngClass]=\"{'disabled': disabled}\" [attr.title]=\"title\">\n            {{_text}}\n            <i *ngIf=\"icon != ''\" class=\"material-icons left\">{{icon}}</i>\n        </a>  \n    ",
                host: {
                    '[class]': ''
                },
                providers: [abstract_ngmodel_1.MakeProvider(ButtonComponent)]
            },] },
];
/** @nocollapse */
ButtonComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
    { type: sharedService_1.SharedService, },
]; };
ButtonComponent.propDecorators = {
    'button': [{ type: core_1.ViewChild, args: ['button',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'text': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input },],
    'color': [{ type: core_1.Input },],
    'icon': [{ type: core_1.Input },],
    'design': [{ type: core_1.Input },],
    'title': [{ type: core_1.Input },],
    'disabled': [{ type: core_1.Input },],
    'type': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
    '_onClick': [{ type: core_1.Output },],
    'onClick': [{ type: core_1.Input },],
};
exports.ButtonComponent = ButtonComponent;
var ButtonEnumType;
(function (ButtonEnumType) {
    ButtonEnumType[ButtonEnumType["default"] = 0] = "default";
    ButtonEnumType[ButtonEnumType["normal"] = 1] = "normal";
    ButtonEnumType[ButtonEnumType["success"] = 2] = "success";
    ButtonEnumType[ButtonEnumType["danger"] = 3] = "danger";
    ButtonEnumType[ButtonEnumType["back"] = 4] = "back";
})(ButtonEnumType = exports.ButtonEnumType || (exports.ButtonEnumType = {}));
