"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var CheckboxComponent = (function (_super) {
    __extends(CheckboxComponent, _super);
    function CheckboxComponent(_el, _http, _translateService, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._el = _el;
        _this._http = _http;
        _this._translateService = _translateService;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.checked = false;
        _this.css = 'sbm-checkbox';
        _this.styleCss = '';
        _this.isNotMasterDetail = true;
        _this._columns = 'col l12 m12 s12 crud-form-dynamic';
        _this.onClick = '';
        _this._onClick = new core_1.EventEmitter();
        _this.randomClass = 0;
        _this.inputValid = true;
        _this._label = '';
        sbmCheckComponent.push(_this);
        return _this;
    }
    Object.defineProperty(CheckboxComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CheckboxComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    CheckboxComponent.prototype.ngOnInit = function () {
        this.randomClass = Math.floor((Math.random() * 1000) + 1);
        _super.prototype.validar.call(this, this.securityId);
    };
    CheckboxComponent.prototype.ngAfterViewInit = function () {
        var me = this;
        $(document).ready(function () {
            me.value = me.checked;
        });
    };
    CheckboxComponent.prototype.itemClicado = function () {
        this._onClick.emit(!this.value);
        if (this.value) {
            if (this.notnull && !this.value) {
                this.inputValid = false;
            }
            else {
                this.inputValid = true;
            }
        }
        else {
            this.inputValid = false;
        }
        if (this.onClick != '') {
            window[this.onClick](this.value);
        }
    };
    CheckboxComponent.prototype.validRadio = function ($value) {
        if (this.value) {
            if (this.notnull && !$value) {
                this.inputValid = false;
            }
            else {
                this.inputValid = true;
            }
        }
        else {
            this.inputValid = false;
        }
    };
    return CheckboxComponent;
}(abstract_ngmodel_1.AbstractNgModel));
CheckboxComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-checkbox',
                template: "\n        <p>\n          <input type=\"checkbox\" id=\"sbm-checkbox{{randomClass}}\" #checkbox class=\"filled-in sbm-text-field {{css}}\" (click)=\"itemClicado(checkbox.value)\" \n          [ngStyle]=\"styleCss\" [(ngModel)]=\"value\" [attr.data-checked]=\"value\"/>\n          <label for=\"sbm-checkbox{{randomClass}}\">{{_label}}</label>\n        </p>\n    ",
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(CheckboxComponent)]
            },] },
];
/** @nocollapse */
CheckboxComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: http_1.Http, },
    { type: core_2.TranslateService, },
    { type: sharedService_1.SharedService, },
]; };
CheckboxComponent.propDecorators = {
    'checkbox': [{ type: core_1.ViewChild, args: ['checkbox',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'checked': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'columns': [{ type: core_1.Input },],
    'onClick': [{ type: core_1.Input },],
    '_onClick': [{ type: core_1.Output },],
};
exports.CheckboxComponent = CheckboxComponent;
