import { ElementRef, EventEmitter, OnInit, QueryList } from '@angular/core';
import { ReqHttpService } from '../../services/req-http.service';
import { ActivatedRoute, Router } from '@angular/router';
import { IBreadcrumbs } from '../../interfaces/IBreadcrumbs';
import { Subscription } from 'rxjs';
import { NotificationComponent } from '../notification/notification.component';
import { SelectComponent } from '../select/select.component';
import { MasterDetailComponent } from '../master-detail/master-detail.component';
import { InputTextComponent } from '../input/input-text/input-text.component';
import { InputTelefoneComponent } from '../input/input-telefone/input-telefone.component';
import { InputPasswordComponent } from '../input/input-password/input-password.component';
import { InputNumberComponent } from '../input/input-number/input-number.component';
import { InputMaskComponent } from '../input/input-mask/input-mask.component';
import { InputCepComponent } from '../input/input-cep/input-cep.component';
import { InputCnpjComponent } from '../input/input-cnpj/input-cnpj.component';
import { InputCpfComponent } from '../input/input-cpf/input-cpf.component';
import { InputEmailComponent } from '../input/input-email/input-email.component';
import { RadioComponent } from '../radio/radio.component';
import { ListViewComponent } from '../list-view/list-view.component';
import { DateboxComponent } from '../datebox/datebox.component';
import { UploadComponent } from '../upload/upload.component';
import { AutocompleteComponent } from '../autocomplete/autocomplete.component';
import { CheckboxComponent } from '../checkbox/checkbox.component';
import { MoneyComponent } from '../input/money/money.component';
import { TextareaComponent } from '../input/textarea/textarea.component';
import { MultiselectComponent } from '../multiselect/multiselect.component';
import { TranslateService } from '@ngx-translate/core';
import { DxDataGridComponent, DxPivotGridComponent } from 'devextreme-angular';
import { SharedService } from "../../models/sharedService";
import { Http } from '@angular/http';
export declare class CrudActionBarComponent {
}
export declare class CrudActionComplementaryBarComponent {
}
export declare class CrudFormComponent {
    constructor();
    elementRef: string;
    elementHidden: boolean;
    ngOnInit(): void;
}
export declare class Crud2Component implements OnInit {
    private _reqHttpService;
    private _sharedService;
    private _translateService;
    _http: Http;
    private _router;
    private _activatedRoute;
    private _el;
    constructor(_reqHttpService: ReqHttpService, _sharedService: SharedService, _translateService: TranslateService, _http: Http, _router: Router, _activatedRoute: ActivatedRoute, _el: ElementRef);
    masterDetailComp: QueryList<MasterDetailComponent>;
    inputTextComp: QueryList<InputTextComponent>;
    inputTelefoneComp: QueryList<InputTelefoneComponent>;
    inputPasswordComp: QueryList<InputPasswordComponent>;
    inputNumberComp: QueryList<InputNumberComponent>;
    inputMaskComp: QueryList<InputMaskComponent>;
    inputCepComp: QueryList<InputCepComponent>;
    inputCnpjComp: QueryList<InputCnpjComponent>;
    inputCpfComp: QueryList<InputCpfComponent>;
    inputEmailComp: QueryList<InputEmailComponent>;
    radioComp: QueryList<RadioComponent>;
    listViewComp: QueryList<ListViewComponent>;
    dateBoxComp: QueryList<DateboxComponent>;
    uploadComp: QueryList<UploadComponent>;
    autoCompleteComp: QueryList<AutocompleteComponent>;
    checkBoxComp: QueryList<CheckboxComponent>;
    moneyComp: QueryList<MoneyComponent>;
    textareaComp: QueryList<TextareaComponent>;
    multiSelectComp: QueryList<MultiselectComponent>;
    selectComp: QueryList<SelectComponent>;
    crudFormComponent: QueryList<CrudFormComponent>;
    _crudFrom: ElementRef;
    _buttonNext: ElementRef;
    _buttonAll: ElementRef;
    _loader: ElementRef;
    parametersEl: ElementRef;
    formCurdEl: ElementRef;
    _inputPerspec: ElementRef;
    gridResultCrud: DxDataGridComponent;
    sbmLayout: SelectComponent;
    sbmFiltroTabela: SelectComponent;
    sbmPivotGridChooser: any;
    pivotGridEl: DxPivotGridComponent;
    filtroTabelaList: any;
    layoutCurrent: any;
    entity: string;
    urlBase: string;
    pathFilter: string;
    table: string;
    masterDetail: boolean;
    perspective: boolean;
    selectItems: EventEmitter<{}>;
    clickedNew: EventEmitter<{}>;
    clickedEdit: EventEmitter<{}>;
    clickedCancel: EventEmitter<{}>;
    onModels: EventEmitter<{}>;
    static breadcrumbAlterado: EventEmitter<{}>;
    static emitChangeFilter: EventEmitter<{}>;
    static numero_registro_pagina: number;
    private _layoutDinamic;
    modelsForm: any;
    selectItem: any;
    parametersModels: any;
    models: any;
    dataSource: any;
    selectedFilter: boolean;
    url: string;
    retornoParametros: any;
    setGrid: any;
    colunas: any;
    showHideColumnValue: any;
    crudLayoutGrid: any;
    crudFormAtive: boolean;
    addFormControl: boolean;
    formControlHidden: boolean;
    saveButton: boolean;
    buttonDisable: boolean;
    executedParameters: boolean;
    noErrosForm: boolean;
    servicePending: boolean;
    iBreadcrumbActive: any;
    bc: IBreadcrumbs;
    breadC: Subscription;
    ActionButtons: Subscription;
    notification: NotificationComponent;
    update: any;
    countRegister: number;
    pageCurrent: number;
    valuePerspective: boolean;
    pivotGrid: any;
    showPivotConf: boolean;
    searchPanelColumn: boolean;
    buttonsActions: any;
    reloadBreadCrumb(): void;
    newBreadcrumb(): void;
    clickNew(): void;
    clickEdit($data: any): void;
    clickDelete($data: any): void;
    cancel(): void;
    childrenCrud(data: any): void;
    sendFormValid($data: any, saveAndContinue?: any, saveServer?: any): void;
    setFormControl($object: any, item: any): void;
    addFormControls($object: any, saveAndContinue?: any): void;
    sendForm($data: any, saveAndContinue?: any, saveServer?: any): void;
    selectFilter(event: any): void;
    retornoParametro(retorno: any): void;
    onContextMenuPreparing($event: any): void;
    pageNext($el: any): void;
    changeGrid($event: any): void;
    layoutDinamic(): {
        "linhasTabelaDinamica": any[];
        "colunasTabelaDinamica": any[];
        "filtrosTabelaDinamica": any[];
        "funcoesTabelaDinamica": any[];
    };
    saveLayout(form?: any, $event?: any): void;
    removeLayout($el: any): void;
    selectLayout($event: any): void;
    ClickShowColumn($event: any): void;
    ClickHideColumn($event: any): void;
    getAll(parameters?: any): void;
    changePerspective($data: any, pivotGirdEl?: any): void;
    filtroTabela(): void;
    exportExcell(): void;
    exportButtonGrid(): void;
    executarFiltro(parameters?: any): void;
    changeSearchPanelColumn(): void;
    showParameters(hidden?: any): void;
    selectionData(event: any): void;
    loadModels(): {};
    validModels(attr: any, error: any): void;
    crudSetValue(key: any, value: any): void;
    reloadModel(): void;
    returnEdit(): void;
    ngOnInit(): void;
    ngAfterViewChecked(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
