"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var req_http_service_1 = require("../../services/req-http.service");
var router_1 = require("@angular/router");
var breadcrumb_crud_component_1 = require("../breadcrumb-crud/breadcrumb-crud.component");
var notification_component_1 = require("../notification/notification.component");
var select_component_1 = require("../select/select.component");
var alert_component_1 = require("../alert/alert.component");
var master_detail_component_1 = require("../master-detail/master-detail.component");
var input_text_component_1 = require("../input/input-text/input-text.component");
var input_telefone_component_1 = require("../input/input-telefone/input-telefone.component");
var input_password_component_1 = require("../input/input-password/input-password.component");
var input_number_component_1 = require("../input/input-number/input-number.component");
var input_mask_component_1 = require("../input/input-mask/input-mask.component");
var input_cep_component_1 = require("../input/input-cep/input-cep.component");
var input_cnpj_component_1 = require("../input/input-cnpj/input-cnpj.component");
var input_cpf_component_1 = require("../input/input-cpf/input-cpf.component");
var input_email_component_1 = require("../input/input-email/input-email.component");
var radio_component_1 = require("../radio/radio.component");
var list_view_component_1 = require("../list-view/list-view.component");
var datebox_component_1 = require("../datebox/datebox.component");
var upload_component_1 = require("../upload/upload.component");
var autocomplete_component_1 = require("../autocomplete/autocomplete.component");
var checkbox_component_1 = require("../checkbox/checkbox.component");
var money_component_1 = require("../input/money/money.component");
var textarea_component_1 = require("../input/textarea/textarea.component");
var multiselect_component_1 = require("../multiselect/multiselect.component");
var data_source_1 = require("devextreme/ui/pivot_grid/data_source");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var CrudActionBarComponent = (function () {
    function CrudActionBarComponent() {
    }
    return CrudActionBarComponent;
}());
CrudActionBarComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-crud-action-bar',
                template: "<ng-content select='[sbm-crud-action]'></ng-content>"
            },] },
];
/** @nocollapse */
CrudActionBarComponent.ctorParameters = function () { return []; };
exports.CrudActionBarComponent = CrudActionBarComponent;
var CrudActionComplementaryBarComponent = (function () {
    function CrudActionComplementaryBarComponent() {
    }
    return CrudActionComplementaryBarComponent;
}());
CrudActionComplementaryBarComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-crud-complementary-action-bar',
                template: "<ng-content select='[sbm-crud-complementary]'></ng-content>"
            },] },
];
/** @nocollapse */
CrudActionComplementaryBarComponent.ctorParameters = function () { return []; };
exports.CrudActionComplementaryBarComponent = CrudActionComplementaryBarComponent;
var CrudFormComponent = (function () {
    function CrudFormComponent() {
        this.elementRef = '';
        this.elementHidden = false;
    }
    CrudFormComponent.prototype.ngOnInit = function () {
        this.elementRef = "sbm-reference-" + Math.floor((Math.random() * 100000) + 1);
    };
    return CrudFormComponent;
}());
CrudFormComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-crud-form',
                template: "\n        <ng-content></ng-content>\n    ",
                host: {
                    '[attr.elementRef]': 'elementRef',
                    '[hidden]': 'elementHidden'
                }
            },] },
];
/** @nocollapse */
CrudFormComponent.ctorParameters = function () { return []; };
exports.CrudFormComponent = CrudFormComponent;
var Crud2Component = (function () {
    function Crud2Component(_reqHttpService, _sharedService, _translateService, _http, _router, _activatedRoute, _el) {
        this._reqHttpService = _reqHttpService;
        this._sharedService = _sharedService;
        this._translateService = _translateService;
        this._http = _http;
        this._router = _router;
        this._activatedRoute = _activatedRoute;
        this._el = _el;
        this.entity = '';
        this.urlBase = 'http://10.10.10.115:8081';
        this.pathFilter = '/sabium-gerenciador/api/filtro/tabela/';
        this.table = '';
        this.masterDetail = false;
        this.perspective = false;
        this.selectItems = new core_1.EventEmitter();
        this.clickedNew = new core_1.EventEmitter();
        this.clickedEdit = new core_1.EventEmitter();
        this.clickedCancel = new core_1.EventEmitter();
        this.onModels = new core_1.EventEmitter();
        this._layoutDinamic = {
            "linhasTabelaDinamica": [],
            "colunasTabelaDinamica": [],
            "filtrosTabelaDinamica": [],
            "funcoesTabelaDinamica": []
        };
        this.selectItem = [];
        this.selectedFilter = false;
        this.setGrid = [];
        this.colunas = [];
        this.showHideColumnValue = [];
        this.crudLayoutGrid = [];
        this.crudFormAtive = false;
        this.addFormControl = true;
        this.formControlHidden = true;
        this.saveButton = false;
        this.buttonDisable = true;
        this.executedParameters = false;
        this.noErrosForm = true;
        this.servicePending = false; // desabilita os botões que fazem requisições assíncronas enquanto elas não terminam
        // breadcrunb-crud
        this.iBreadcrumbActive = this._activatedRoute.routeConfig.path;
        this.bc = {
            name: 'Novo',
            url: '/novo',
            localStogare: "__sbm__" + this.iBreadcrumbActive
        };
        this.notification = new notification_component_1.NotificationComponent();
        this.update = { update: false };
        this.countRegister = 0;
        this.pageCurrent = 1;
        this.valuePerspective = false;
        this.pivotGrid = new data_source_1.default({
            fields: [],
            store: this.setGrid
        });
        this.showPivotConf = false;
        this.searchPanelColumn = false;
        this.buttonsActions = {
            buttonEdit: {
                disabled: true
            },
            buttonRemove: {
                disabled: true
            },
            buttonSaveSearch: {
                disabled: true
            },
            buttonSaveSearchAll: {
                disabled: true
            },
            buttonRemoveSearch: {
                disabled: true
            },
            buttonSearchRow: {
                disabled: true
            },
            buttonHideShowColumns: {
                disabled: true
            },
            buttonExport: {
                disabled: true
            },
            buttonOpenCloseFilter: {
                disabled: false,
                icon: 'keyboard_arrow_left'
            },
            buttonNextPage: {
                disabled: true,
                icon: '&#xE314'
            },
            buttonGetAll: {
                disabled: true,
                icon: '&#xE314'
            }
        };
    }
    Object.defineProperty(Crud2Component.prototype, "models", {
        get: function () {
            return this.modelsForm;
        },
        set: function (val) {
            this.modelsForm = val;
        },
        enumerable: true,
        configurable: true
    });
    Crud2Component.prototype.reloadBreadCrumb = function () {
        var me = this;
        me._router.resetConfig(me._router.config);
        Crud2Component.breadcrumbAlterado.emit();
    };
    Crud2Component.prototype.newBreadcrumb = function () {
        var me = this;
        var jaExiste = false;
        me._activatedRoute.data['value']['breadcrumbCrud'].map(function (obj) {
            if (obj['url'] == me.bc['url']) {
                jaExiste = true;
            }
        });
        if (!jaExiste) {
            me._activatedRoute.data['value']['breadcrumbCrud'].push(me.bc);
        }
        localStorage.setItem(me.bc['localStogare'], 'true');
        this.reloadBreadCrumb();
    };
    Crud2Component.prototype.clickNew = function () {
        this.clickedNew.emit();
        this.bc.name = 'Novo';
        this.formControlHidden = false;
        this.crudFormAtive = true;
        this.newBreadcrumb();
        this.update.update = false;
    };
    Crud2Component.prototype.clickEdit = function ($data) {
        var _this = this;
        this.clickedEdit.emit($data);
        var me = this;
        this.update = {
            update: true,
            id: $data.selectedRowsData[0]['Identificador']
        };
        var _htmlElement = document.getElementsByClassName('crud-form-dynamic');
        if ($data.selectedRowsData.length == 1) {
            this._reqHttpService.xhrGet("/sabium/api/" + this.entity + "/" + $data.selectedRowsData[0]['Identificador']).subscribe(function (ret) {
                $(_this._crudFrom.nativeElement).find('.crud-form-dynamic').each(function (i, e) {
                    var attrsField = {
                        attribute: $(this).attr('attribute'),
                        tag: $(this).prop('tagName'),
                        value: ret.res[$(this).attr('attribute')]
                    };
                    me.crudSetValue(attrsField.attribute, attrsField.value);
                });
            });
        }
        this.bc.name = 'Editar';
        this.formControlHidden = false;
        this.crudFormAtive = true;
        this.newBreadcrumb();
    };
    Crud2Component.prototype.clickDelete = function ($data) {
        var _this = this;
        var _alert = new alert_component_1.AlertComponent();
        var _notification = new notification_component_1.NotificationComponent();
        _alert.show('Remover', 'Sim', 'DEseja realmente excluir este registro?', 'warning', true, 'Não').then(function (ret) {
            if (ret) {
                _this._reqHttpService.xhrDelete("/sabium/api/" + _this.entity + "/" + $data.selectedRowsData[0]['Identificador']).subscribe(function (ret) {
                    if (ret.res.sucesso) {
                        _notification.show("Sucesso ao remover o registro " + $data.selectedRowsData[0]['Identificador'], 2000);
                        _this.executarFiltro();
                    }
                });
            }
        });
    };
    Crud2Component.prototype.cancel = function () {
        var _this = this;
        var me = this;
        this.formControlHidden = true;
        this.clickedCancel.emit();
        this.crudFormAtive = false;
        if (localStorage.getItem(me.bc['localStogare'])) {
            me._activatedRoute.data['value']['breadcrumbCrud'].pop();
            localStorage.removeItem(me.bc['localStogare']);
        }
        var clearForm = Object.keys(this.loadModels());
        clearForm.map(function (a) {
            _this.crudSetValue(a, '');
        });
        localStorage.removeItem("__SBM-CRUD__" + this._router.url);
        this.reloadBreadCrumb();
        // $(this._buttonNext.nativeElement).show();
        // $(this._inputPerspec.nativeElement).removeAttr('disabled');
        this.executedParameters = true;
        $('#sbm-grid-result').removeClass('l7').addClass('l11');
        if (this._activatedRoute.routeConfig['data']) {
            if (this._activatedRoute.routeConfig.data['urlAfter'] && !(this._activatedRoute.routeConfig.data['filter'])) {
                this._router.navigateByUrl(this._activatedRoute.routeConfig.data['urlAfter']);
            }
        }
        this.servicePending = false;
    };
    Crud2Component.prototype.childrenCrud = function (data) {
        var _this = this;
        var _ischildrenCrud = false;
        if (this._activatedRoute.routeConfig.data !== undefined) {
            if (this._activatedRoute.routeConfig.data['isChildrenCrud'] !== undefined) {
                _ischildrenCrud = true;
            }
        }
        if (_ischildrenCrud) {
            if (this._activatedRoute.routeConfig['data']) {
                this._router.config.map(function (a, i) {
                    if (_this._activatedRoute.routeConfig.data['urlAfter'] == '/' + a.path) {
                        a.data['returnData'] = {
                            'data': data[0]
                        };
                        a.data['returnData']['id'] = _this._activatedRoute.routeConfig.data['id'];
                        if (_this._activatedRoute.routeConfig.data['masterDetailNew']) {
                            a.data['masterDetailNew'] = true;
                        }
                        if (_this._activatedRoute.routeConfig.data['masterDetailEdit']) {
                            a.data['masterDetailEdit'] = true;
                        }
                        if (_this._activatedRoute.routeConfig.data['rowIndex'] !== undefined) {
                            a.data['returnData']['rowIndex'] = _this._activatedRoute.routeConfig.data['rowIndex'];
                        }
                    }
                });
            }
            // localStorage.removeItem(`__SBM-CRUD__${this._router.url}`);
        }
    };
    Crud2Component.prototype.sendFormValid = function ($data, saveAndContinue, saveServer) {
        var _this = this;
        if (saveAndContinue) {
            var _notification_1 = new notification_component_1.NotificationComponent();
            var _data = [];
            _data.push($data.value);
            this.servicePending = true;
            this._reqHttpService.xhrPost("/sabium/api/" + this.entity, _data).subscribe(function (ret) {
                _notification_1.show("Sucesso ao salvar o registro", 2000);
                _this.childrenCrud(ret.res);
                $data.reset();
                _this.reloadModel();
                localStorage.removeItem("__SBM-CRUD__" + _this._router.url);
                _this.cancel();
                _this.executarFiltro();
            });
        }
        else {
            if (this.update.update) {
                $data.value['id'] = this.update.id;
            }
            var _notification_2 = new notification_component_1.NotificationComponent();
            var _data = [];
            _data.push($data.value);
            this.servicePending = true;
            this._reqHttpService.xhrPost("/sabium/api/" + this.entity, _data).subscribe(function (ret) {
                _notification_2.show("Sucesso ao salvar o registro", 2000);
                _this.childrenCrud(ret.res);
                $data.reset();
                _this.reloadModel();
                _this.executarFiltro();
                if (_this._activatedRoute.routeConfig.data !== undefined && _this._activatedRoute.routeConfig.data['urlAfter']) {
                    _this._router.navigateByUrl(_this._activatedRoute.routeConfig.data['urlAfter']);
                }
                localStorage.removeItem("__SBM-CRUD__" + _this._router.url);
                _this.cancel();
            });
        }
    };
    Crud2Component.prototype.setFormControl = function ($object, item) {
        var attrsField = {
            id: item.id,
            require: item.notnull,
            attribute: item.attribute,
            minLength: item.minLength || false,
            maxLength: item.maxLength || false,
            pattern: item.pattern || false,
            value: item.value
        };
        var validator = [];
        if (attrsField.require) {
            validator.push(forms_1.Validators.required);
        }
        if (attrsField.minLength) {
            validator.push(forms_1.Validators.minLength(parseInt(attrsField.minLength)));
        }
        if (attrsField.maxLength) {
            validator.push(forms_1.Validators.maxLength(parseInt(attrsField.maxLength)));
        }
        if (attrsField.pattern) {
            validator.push(forms_1.Validators.pattern(attrsField.pattern));
        }
        $object.control.addControl(attrsField.attribute, new forms_1.FormControl(null, validator));
        $object.controls[attrsField.attribute].setValue(attrsField.value);
    };
    Crud2Component.prototype.addFormControls = function ($object, saveAndContinue) {
        var _this = this;
        if (this.masterDetailComp.length > 0) {
            this.masterDetailComp.forEach(function (item, index) {
                _this.setFormControl($object, item);
            });
        }
        if (this.inputTextComp.length > 0) {
            this.inputTextComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.inputCepComp.length > 0) {
            this.inputCepComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.inputCnpjComp.length > 0) {
            this.inputCnpjComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.inputCpfComp.length > 0) {
            this.inputCpfComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.inputEmailComp.length > 0) {
            this.inputEmailComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.inputPasswordComp.length > 0) {
            this.inputPasswordComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.inputMaskComp.length > 0) {
            this.inputMaskComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.inputNumberComp.length > 0) {
            this.inputNumberComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.inputTelefoneComp.length > 0) {
            this.inputTelefoneComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.selectComp.length > 0) {
            this.selectComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.radioComp.length > 0) {
            this.radioComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.listViewComp.length > 0) {
            this.listViewComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.dateBoxComp.length > 0) {
            this.dateBoxComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.uploadComp.length > 0) {
            this.uploadComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.autoCompleteComp.length > 0) {
            this.autoCompleteComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.checkBoxComp.length > 0) {
            this.checkBoxComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.moneyComp.length > 0) {
            this.moneyComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.textareaComp.length > 0) {
            this.textareaComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        if (this.multiSelectComp.length > 0) {
            this.multiSelectComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    _this.setFormControl($object, item);
                }
            });
        }
        this.addFormControl = false;
        var _ischildrenCrud = false;
        if (this._activatedRoute.routeConfig['data'] !== undefined) {
            if (this._activatedRoute.routeConfig['data']['isChildrenCrud']) {
                _ischildrenCrud = true;
            }
        }
        if (saveAndContinue) {
            if (_ischildrenCrud && this._activatedRoute.routeConfig['data']['saveServer']) {
                this.sendForm($object, saveAndContinue, true);
            }
            else {
                this.sendForm($object, saveAndContinue);
            }
        }
        else {
            if (_ischildrenCrud && this._activatedRoute.routeConfig['data']['saveServer']) {
                this.sendForm($object, false, true);
            }
            else {
                this.sendForm($object);
            }
        }
    };
    Crud2Component.prototype.sendForm = function ($data, saveAndContinue, saveServer) {
        var _this = this;
        if ($data.valid) {
            this.noErrosForm = true;
            if (saveAndContinue) {
                this.sendFormValid($data, saveAndContinue);
            }
            else {
                this.sendFormValid($data);
            }
        }
        else {
            // this.noErrosForm = false;
            var objectKeys = [];
            if ($data.controls) {
                objectKeys = Object.keys($data.controls);
            }
            objectKeys.map(function (nomeCampo) {
                var errors = [];
                if ($data.controls[nomeCampo]._errors) {
                    errors = Object.keys($data.controls[nomeCampo]._errors);
                }
                errors.map(function (validationRule) {
                    _this.validModels(nomeCampo, validationRule);
                });
            });
        }
    };
    Crud2Component.prototype.selectFilter = function (event) {
        this.dataSource = event;
        this.url = event.url;
        this.selectedFilter = true;
        Crud2Component.emitChangeFilter.emit(true);
    };
    Crud2Component.prototype.retornoParametro = function (retorno) {
        console.log(retorno);
        this.retornoParametros = retorno.parameters;
        // Crud2Component.numero_registro_pagina = retorno.numero_registro_pagina;//parametro nao retorna mais essa prop
    };
    Crud2Component.prototype.onContextMenuPreparing = function ($event) {
        var me = this;
        console.log(me.gridResultCrud.instance.columnCount());
        me.gridResultCrud.columns.forEach(function (item) {
        });
        console.log(me.gridResultCrud);
        if ($event.target == 'header') {
            $event.items.push({
                text: 'Esconder',
                onItemClick: (function (params) {
                    me.gridResultCrud.instance.columnOption($event.column.index, 'visible', false);
                    // me.gridResultCrud.instance.deleteColumn($event.columnIndex)
                    // me.gridResultCrud.instance.refresh();
                })
            });
            // console.log($event.row.data);
            // $event.component.getTotalSummaryValue([$event.row.rowIndex], true) // this code will select a row
        }
        if ($event.target == 'content') {
            // $event.items = [];
            //
            // $event.items.push({text: "Teste"});
            // console.log($event.row.data);
            // $event.component.selectRows([$event.row.data], true) // this code will select a row
        }
    };
    Crud2Component.prototype.pageNext = function ($el) {
        var _this = this;
        if (this.setGrid.length == this.countRegister) {
            this.buttonsActions.buttonNextPage.disabled = true;
        }
        else {
            this.pageCurrent++;
            $(this._loader.nativeElement).show();
            var pagination = Crud2Component.numero_registro_pagina ? "?p=" + this.pageCurrent + "&l=" + Crud2Component.numero_registro_pagina : "";
            this._reqHttpService.xhrPost("/sabium/api/filtro/runner/" + pagination, this.retornoParametros).subscribe(function (ret) {
                var arrayGrid = [];
                for (var _i = 0, _a = ret.res.data; _i < _a.length; _i++) {
                    var item = _a[_i];
                    var dataGrid = {};
                    for (var i = 0; i < item.colunas.length; i++) {
                        dataGrid[item.colunas[i].rotulo] = item.colunas[i].valor;
                    }
                    _this.setGrid.push(dataGrid);
                    $(_this._loader.nativeElement).hide();
                }
                _this.countRegister = ret.res.size;
                if (_this.setGrid.length == _this.countRegister) {
                    _this.buttonsActions.buttonNextPage.disabled = true;
                }
            });
        }
    };
    Crud2Component.prototype.changeGrid = function ($event) {
        var isGrouped = !!$event.component.columnOption("groupIndex:0");
        if (isGrouped) {
            this.buttonsActions.buttonNextPage.disabled = true;
            // this.getAll();
        }
        else {
            this.buttonsActions.buttonNextPage.disabled = false;
        }
    };
    Crud2Component.prototype.layoutDinamic = function () {
        var layoutDinamic = {
            "linhasTabelaDinamica": [],
            "colunasTabelaDinamica": [],
            "filtrosTabelaDinamica": [],
            "funcoesTabelaDinamica": [],
        };
        console.log(this.pivotGrid);
        this.pivotGrid['_descriptions']['columns'].forEach(function (item) {
            layoutDinamic['colunasTabelaDinamica'].push(item["dataField"]);
        });
        this.pivotGrid['_descriptions']['rows'].forEach(function (item) {
            layoutDinamic['linhasTabelaDinamica'].push(item["dataField"]);
        });
        this.pivotGrid['_descriptions']['filters'].forEach(function (item) {
            layoutDinamic['filtrosTabelaDinamica'].push({
                coluna: item["dataField"],
                valores: item["filterValues"]
            });
        });
        this.pivotGrid['_descriptions']['values'].forEach(function (item) {
            layoutDinamic['funcoesTabelaDinamica'].push({
                coluna: item["dataField"],
                funcao: 'CONTAGEM'
            });
        });
        this._layoutDinamic = layoutDinamic;
        return layoutDinamic;
    };
    Crud2Component.prototype.saveLayout = function (form, $event) {
        var _this = this;
        var notification = new notification_component_1.NotificationComponent();
        var layoutCurrent;
        if (this.layoutCurrent) {
            layoutCurrent = this.layoutCurrent;
            var layoutDinamic = this.layoutDinamic();
            this.layoutCurrent['linhasTabelaDinamica'] = layoutDinamic['linhasTabelaDinamica'];
            this.layoutCurrent['colunasTabelaDinamica'] = layoutDinamic['colunasTabelaDinamica'];
            this.layoutCurrent['filtrosTabelaDinamica'] = layoutDinamic['filtrosTabelaDinamica'];
            this.layoutCurrent['funcoesTabelaDinamica'] = layoutDinamic['funcoesTabelaDinamica'];
        }
        else {
            layoutCurrent = {
                'nome': null,
                'codigoFiltro': null,
                'colunasTabelaSimples': [],
                "linhasTabelaDinamica": [],
                "colunasTabelaDinamica": [],
                "filtrosTabelaDinamica": [],
                "funcoesTabelaDinamica": [],
                "parametrosExecucao": []
            };
            var layoutDinamic = this.layoutDinamic();
            console.log(layoutDinamic);
            layoutCurrent['linhasTabelaDinamica'] = layoutDinamic['linhasTabelaDinamica'];
            layoutCurrent['colunasTabelaDinamica'] = layoutDinamic['colunasTabelaDinamica'];
            layoutCurrent['filtrosTabelaDinamica'] = layoutDinamic['filtrosTabelaDinamica'];
            layoutCurrent['funcoesTabelaDinamica'] = layoutDinamic['funcoesTabelaDinamica'];
        }
        this.colunas.forEach(function (col) {
            var dataColumn = _this.gridResultCrud.instance.columnOption(col['formItem']['index']);
            var newItem = layoutCurrent.colunasTabelaSimples.filter(function (item) { return item['campo'] == col['dataField']; });
            if (newItem.length > 0) {
                newItem[0]['campo'] = col['dataField'];
                newItem[0]['visivel'] = dataColumn['visible'];
                newItem[0]['largura'] = dataColumn['width'];
            }
            else {
                var newColumns = {};
                newColumns['campo'] = col['dataField'];
                newColumns['visivel'] = dataColumn['visible'];
                newColumns['largura'] = dataColumn['width'];
                layoutCurrent['colunasTabelaSimples'].push(newColumns);
            }
        });
        var parametersExecution = {
            'chave': null,
            'valores': []
        };
        this.retornoParametros['parametros'].map(function (item) {
            parametersExecution['chave'] = item['nome'];
            parametersExecution['valores'].push(item['valor']);
        });
        layoutCurrent['parametrosExecucao'] = [];
        layoutCurrent['parametrosExecucao'].push(parametersExecution);
        if (form) {
            layoutCurrent['nome'] = form['name_search'];
            layoutCurrent['padrao'] = form['default_search'];
            layoutCurrent['codigoFiltro'] = this.retornoParametros['codigo'];
            var arrayParameters = [];
            arrayParameters.push(layoutCurrent);
            this._reqHttpService.xhrPost("/sabium-gerenciador/pesquisa/salvar", arrayParameters).subscribe(function (ret) {
                console.log(ret);
                if (ret.success) {
                    notification.show(ret.res[0]['nome'] + " salva com sucesso!");
                    _this._reqHttpService.xhrGet("/sabium-gerenciador/pesquisa/tabela/" + _this.entity).subscribe(function (ret) {
                        _this.crudLayoutGrid = ret.res;
                    });
                }
            });
        }
        else {
            if (this.layoutCurrent) {
                var arrayParameters = [];
                var tabelaSimples_1 = [];
                layoutCurrent.colunasTabelaSimples.forEach(function (item) {
                    tabelaSimples_1.push({
                        campo: item.campo,
                        largura: item.largura,
                        visivel: item.visivel
                    });
                });
                arrayParameters.push({
                    'nome': layoutCurrent.nome,
                    'codigoFiltro': layoutCurrent.filtroVersao.filtro.codigo,
                    'colunasTabelaSimples': tabelaSimples_1,
                    "linhasTabelaDinamica": layoutCurrent.linhasTabelaDinamica,
                    "colunasTabelaDinamica": layoutCurrent.colunasTabelaDinamica,
                    "filtrosTabelaDinamica": layoutCurrent.filtrosTabelaDinamica,
                    "funcoesTabelaDinamica": layoutCurrent.funcoesTabelaDinamica,
                    "parametrosExecucao": layoutCurrent.parametrosExecucao,
                    "padrao": layoutCurrent.padrao
                });
                this._reqHttpService.xhrPut("/sabium-gerenciador/pesquisa/salvar", arrayParameters).subscribe(function (ret) {
                    console.log(ret);
                    if (ret.success) {
                        notification.show(_this.layoutCurrent['nome'] + " Atualizado com sucesso!");
                        _this._reqHttpService.xhrGet("/sabium-gerenciador/pesquisa/tabela/" + _this.entity).subscribe(function (ret) {
                            _this.crudLayoutGrid = ret.res;
                        });
                    }
                });
            }
        }
        console.log(layoutCurrent);
    };
    Crud2Component.prototype.removeLayout = function ($el) {
        var _this = this;
        var alert = new alert_component_1.AlertComponent();
        var notification = new notification_component_1.NotificationComponent();
        alert.show("Remover (" + $el['nome'] + ")", 'Sim', 'Deseja realmente remover esta pesquisa', 'info', true, 'Cancelar').then(function (ret) {
            if (ret) {
                _this._reqHttpService.xhrDelete("/sabium-gerenciador/pesquisa/" + $el.id).subscribe(function (ret) {
                    if (ret.res.sucesso) {
                        notification.show("Sucesso ao remover (" + $el['nome'] + ")");
                        _this._reqHttpService.xhrGet("/sabium-gerenciador/pesquisa/tabela/" + _this.entity).subscribe(function (ret) {
                            _this.crudLayoutGrid = ret.res;
                        });
                    }
                });
            }
        });
    };
    Crud2Component.prototype.selectLayout = function ($event) {
        var _this = this;
        console.log($event);
        this.filtroTabelaList.forEach(function (item) {
            if (item.codigo == $event.filtroVersao.filtro.codigo) {
                _this.selectFilter(item);
                _this.sbmFiltroTabela.setValue(item);
            }
        });
        var parameters = {
            'codigo': $event.filtroVersao.filtro.codigo,
            'parametros': [],
            'colunasTabelaSimples': $event['colunasTabelaSimples'],
            'linhasTabelaDinamica': $event['linhasTabelaDinamica'],
            'colunasTabelaDinamica': $event['colunasTabelaDinamica'],
            'filtrosTabelaDinamica': $event['filtrosTabelaDinamica'],
            'funcoesTabelaDinamica': $event['funcoesTabelaDinamica'],
        };
        $event.parametrosExecucao.forEach(function (item) {
            var values = '';
            item['valores'].map(function (value) {
                values = value;
            });
            console.log(item);
            parameters.parametros.push({
                nome: item['chave'],
                valor: values
            });
        });
        this.showHideColumnValue = $event['colunasTabelaSimples'].filter(function (column) { return (column['visivel']); });
        this.executarFiltro(parameters);
        this.layoutCurrent = $event;
    };
    Crud2Component.prototype.ClickShowColumn = function ($event) {
        this.gridResultCrud.instance.columnOption($event.value, 'visible', true);
    };
    Crud2Component.prototype.ClickHideColumn = function ($event) {
        this.gridResultCrud.instance.columnOption($event.value, 'visible', false);
    };
    Crud2Component.prototype.getAll = function (parameters) {
        var _this = this;
        this.setGrid = [];
        var columns = [];
        if (parameters) {
            parameters.parametrosExecucao.forEach(function (item) {
                var o = {
                    'nome': item.chave,
                    valor: null
                };
                item.valores.map(function (value) {
                    o.valor = value;
                });
                parameters.parametrosExecucao = [];
                parameters.parametrosExecucao.push(o);
            });
        }
        this._reqHttpService.xhrPost("/sabium/api/filtro/runner/", (parameters ? { 'codigo': parameters.filtroVersao.filtro.codigo, 'parametros': parameters.parametrosExecucao } : this.retornoParametros)).subscribe(function (ret) {
            var arrayGrid = [];
            arrayGrid = ret.res.data;
            _this.setGrid = arrayGrid;
            if (_this.layoutCurrent) {
                var fields_1 = [];
                _this.layoutCurrent['colunasTabelaDinamica'].forEach(function (item) {
                    fields_1.push({
                        dataField: item,
                        area: "column"
                    });
                });
                _this.layoutCurrent['linhasTabelaDinamica'].forEach(function (item) {
                    fields_1.push({
                        dataField: item,
                        area: "row"
                    });
                });
                /*this.layoutCurrent['leiauteTabelaDinamica']['filtros'].forEach((item) => {
                    fields.push({
                        dataField: item["campo"],
                        area: "filter",
                        dataType: item['tipo']
                    });
                })
                this.layoutCurrent['leiauteTabelaDinamica']['valor'].forEach((item) => {
                    fields.push({
                        dataField: item["campo"],
                        area: "data",
                        dataType: item['tipo'],
                        summaryType: 'sum'
                    });
                })*/
                _this.layoutCurrent['funcoesTabelaDinamica'].forEach(function (item) {
                    fields_1.push({
                        dataField: item['coluna'],
                        area: "data"
                    });
                });
                _this.pivotGrid = new data_source_1.default({
                    fields: fields_1,
                    store: _this.setGrid
                });
                console.log(fields_1);
            }
            else {
                _this.pivotGrid = new data_source_1.default({
                    fields: [],
                    store: _this.setGrid
                });
            }
            if (_this.setGrid.length == _this.countRegister) {
                _this.buttonsActions.buttonNextPage.disabled = true;
                _this.buttonsActions.buttonGetAll.disabled = true;
            }
            _this.countRegister = ret.res.size;
        });
    };
    Crud2Component.prototype.changePerspective = function ($data, pivotGirdEl) {
        var value = $($data).prop('checked');
        this.valuePerspective = value;
        console.log(this.valuePerspective);
        if (value) {
            if (this.layoutCurrent) {
                this.getAll(this.layoutCurrent);
            }
            else {
                this.getAll();
            }
            // this.pivotGridEl.instance;//.store = this.setGrid;
        }
        else {
            this.showPivotConf = false;
            this.gridResultCrud.instance.refresh();
        }
    };
    Crud2Component.prototype.filtroTabela = function () {
        var _this = this;
        this._reqHttpService.xhrGet("/sabium/api/filtro/tabela/" + this.entity).subscribe(function (ret) {
            _this.sbmFiltroTabela.setDataSource(ret.res['data']);
            _this.filtroTabelaList = ret.res['data'];
        });
        this._reqHttpService.xhrGet("/sabium-gerenciador/pesquisa/tabela/" + this.entity).subscribe(function (ret) {
            _this.crudLayoutGrid = ret.res;
        });
    };
    Crud2Component.prototype.exportExcell = function () {
        var _this = this;
        this._reqHttpService.xhrDownload("/sabium/api/filtro/runner/export", this.retornoParametros).subscribe(function (ret) {
            var file = new Blob([ret], { type: 'application/zip' });
            // let fileURL = URL.createObjectURL(file);
            // window.open(fileURL);
            saveAs(file, _this.entity + ".zip");
        });
    };
    Crud2Component.prototype.exportButtonGrid = function () {
        this.gridResultCrud.instance.exportToExcel(false);
    };
    Crud2Component.prototype.executarFiltro = function (parameters) {
        var _this = this;
        this.setGrid = [];
        this.colunas = [];
        var pagination = Crud2Component.numero_registro_pagina ? "?p=1&l=" + Crud2Component.numero_registro_pagina : '';
        this._reqHttpService.xhrPost("/sabium/api/filtro/runner/" + pagination, (parameters ? { 'codigo': parameters.codigo, 'parametros': parameters.parametros } : this.retornoParametros)).subscribe(function (ret) {
            var arrayGrid = [];
            var alert = new alert_component_1.AlertComponent();
            if (ret.res.data.length > 0) {
                if (typeof ret.res.data[0]['colunas'] != 'undefined') {
                    for (var i = 0; i < ret.res.data[0].colunas.length; i++) {
                        var colunas = {};
                        colunas['caption'] = ret.res.data[0].colunas[i].rotulo;
                        colunas['dataField'] = ret.res.data[0].colunas[i].rotulo;
                        colunas['formItem'] = {};
                        colunas['formItem']["visible"] = ret.res.data[0].colunas[i].visible;
                        colunas['formItem']["index"] = i;
                        colunas['formItem']["id"] = ret.res.data[0].colunas[i].id;
                        _this.colunas.push(colunas);
                        if (!(parameters)) {
                            _this.showHideColumnValue.push({
                                text: colunas['dataField'],
                                value: colunas['formItem']["index"]
                            });
                            _this.layoutCurrent = null;
                        }
                    }
                    for (var _i = 0, _a = ret.res.data; _i < _a.length; _i++) {
                        var item = _a[_i];
                        var dataGrid = {};
                        for (var i = 0; i < item.colunas.length; i++) {
                            dataGrid[item.colunas[i].rotulo] = item.colunas[i].valor;
                        }
                        arrayGrid.push(dataGrid);
                    }
                }
                else {
                    var keys = Object.keys(ret.res.data[0]);
                    for (var i = 0; i < keys.length; i++) {
                        var colunas = {};
                        colunas['caption'] = keys[i];
                        colunas['dataField'] = keys[i];
                        colunas['formItem'] = {};
                        colunas['formItem']["index"] = i;
                        _this.colunas.push(colunas);
                        if (!(parameters)) {
                            _this.showHideColumnValue.push({
                                text: colunas['dataField'],
                                value: colunas['formItem']["index"]
                            });
                            _this.layoutCurrent = null;
                        }
                    }
                    arrayGrid = ret.res.data;
                }
                _this.setGrid = arrayGrid;
                _this.executedParameters = true;
                _this.pageCurrent = 1;
                _this.countRegister = ret.res.size;
                _this.buttonsActions.buttonOpenCloseFilter.icon = 'keyboard_arrow_right';
                _this.buttonsActions.buttonNextPage.disabled = false;
                _this.buttonsActions.buttonGetAll.disabled = false;
                _this.buttonsActions.buttonSaveSearch.disabled = false;
                _this.buttonsActions.buttonSaveSearchAll.disabled = false;
                _this.buttonsActions.buttonRemoveSearch.disabled = false;
                _this.buttonsActions.buttonSearchRow.disabled = false;
                _this.buttonsActions.buttonHideShowColumns.disabled = false;
                _this.buttonsActions.buttonExport.disabled = false;
                $('#sbm-grid-result').removeClass('l8').addClass('l11');
                $(_this._inputPerspec.nativeElement).removeAttr('disabled');
                if (_this.perspective) {
                    $(".sbm-crud-perspective").show();
                }
                $(".sbm-select-layout-grid").show();
                if (_this.crudLayoutGrid.length > 0 /* caso tenha alguma confiuguração salva vinda do servicor*/) {
                    setTimeout(function () {
                        if (parameters) {
                            parameters['colunasTabelaSimples'].forEach(function (item) {
                                if (item['visivel'] == true) {
                                    _this.colunas.forEach(function (col) {
                                        if (col['dataField'] == item['campo']) {
                                            _this.gridResultCrud.instance.columnOption(col['formItem']["index"], 'visible', true);
                                            _this.gridResultCrud.instance.columnOption(col['formItem']["index"], 'width', item['largura']);
                                        }
                                    });
                                }
                                else {
                                    _this.colunas.forEach(function (col) {
                                        if (col['dataField'] == item['campo']) {
                                            _this.gridResultCrud.instance.columnOption(col['formItem']["index"], 'visible', false);
                                            _this.gridResultCrud.instance.columnOption(col['formItem']["index"], 'width', item['largura']);
                                        }
                                    });
                                }
                            });
                        }
                    }, 1000); //by Giuliano
                }
            }
            else {
                alert.show('Sua busca não retornou nehum resultado!', 'Ok', 'Por favor refaça sua busca para encontrar algum registro', 'warning');
            }
        });
    };
    Crud2Component.prototype.changeSearchPanelColumn = function () {
        this.searchPanelColumn = !this.searchPanelColumn;
    };
    Crud2Component.prototype.showParameters = function (hidden) {
        if (hidden) {
            this.buttonsActions.buttonOpenCloseFilter.icon = 'keyboard_arrow_left';
            $('#sbm-grid-result').removeClass('l11').removeClass('l8').addClass('l7');
            this.executedParameters = false;
            this.showPivotConf = false;
        }
        else {
            this.buttonsActions.buttonOpenCloseFilter.icon = 'keyboard_arrow_right';
            $('#sbm-grid-result').removeClass('l7').addClass('l11');
            this.executedParameters = true;
        }
    };
    Crud2Component.prototype.selectionData = function (event) {
        var _this = this;
        this.selectItems.emit(event);
        this.selectItem = event;
        if (event.selectedRowsData.length == 1) {
            this.buttonsActions.buttonRemove.disabled = false;
            this.buttonsActions.buttonEdit.disabled = false;
            localStorage.setItem('__SBM__dataGrid', JSON.stringify(event.selectedRowsData));
        }
        else {
            this.buttonsActions.buttonRemove.disabled = true;
            this.buttonsActions.buttonEdit.disabled = true;
            localStorage.setItem('__SBM__dataGrid', '');
        }
        var rowSelected = {};
        if (this._activatedRoute.routeConfig['data']) {
            if (this._activatedRoute.routeConfig.data['isChildrenCrud']) {
                this._router.config.map(function (a, i) {
                    if (_this._activatedRoute.routeConfig.data['urlAfter'] == '/' + a.path) {
                        event.selectedRowsData.map(function (i, index, a) {
                            var objKeys = Object.keys(i);
                            for (var _i = 0, objKeys_1 = objKeys; _i < objKeys_1.length; _i++) {
                                var obj = objKeys_1[_i];
                                rowSelected[obj.toLocaleLowerCase()] = i[obj];
                                rowSelected['id'] = parseInt(i['Identificador']);
                            }
                        });
                        a.data['returnData'] = {
                            'data': rowSelected,
                            'id': _this._activatedRoute.routeConfig.data['id'],
                        };
                    }
                });
                this._router.navigateByUrl(this._activatedRoute.routeConfig.data['urlAfter']);
            }
        }
    };
    Crud2Component.prototype.loadModels = function () {
        var retorno = {};
        if (this.masterDetailComp && this.masterDetailComp.length > 0) {
            this.masterDetailComp.forEach(function (item, index) {
                retorno[item.attribute] = item.value;
            });
        }
        if (this.inputTextComp && this.inputTextComp.length > 0) {
            this.inputTextComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.inputPasswordComp && this.inputPasswordComp.length > 0) {
            this.inputPasswordComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.inputCepComp && this.inputCepComp.length > 0) {
            this.inputCepComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.inputCnpjComp && this.inputCnpjComp.length > 0) {
            this.inputCnpjComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.inputCpfComp && this.inputCpfComp.length > 0) {
            this.inputCpfComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.inputEmailComp && this.inputEmailComp.length > 0) {
            this.inputEmailComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.inputMaskComp && this.inputMaskComp.length > 0) {
            this.inputMaskComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.inputNumberComp && this.inputNumberComp.length > 0) {
            this.inputNumberComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.inputTelefoneComp && this.inputTelefoneComp.length > 0) {
            this.inputTelefoneComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.selectComp && this.selectComp.length > 0) {
            this.selectComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.radioComp && this.radioComp.length > 0) {
            this.radioComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.listViewComp && this.listViewComp.length > 0) {
            this.listViewComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.dateBoxComp && this.dateBoxComp.length > 0) {
            this.dateBoxComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.uploadComp && this.uploadComp.length > 0) {
            this.uploadComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.autoCompleteComp && this.autoCompleteComp.length > 0) {
            this.autoCompleteComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.checkBoxComp && this.checkBoxComp.length > 0) {
            this.checkBoxComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.moneyComp && this.moneyComp.length > 0) {
            this.moneyComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.textareaComp && this.textareaComp.length > 0) {
            this.textareaComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        if (this.multiSelectComp && this.multiSelectComp.length > 0) {
            this.multiSelectComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value;
                }
            });
        }
        return retorno;
    };
    Crud2Component.prototype.validModels = function (attr, error) {
        if (this.masterDetailComp.length > 0) {
            this.masterDetailComp.forEach(function (item, index) {
                if (item.notnull && item.value.length == 0) {
                    item.inputValid = false;
                    item.msgError = item.validationsMsg['require'];
                }
            });
        }
        if (this.inputTextComp.length > 0) {
            this.inputTextComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    if (item.pattern.length > 0 && item.regex(item.value)) {
                        item.inputValid = false;
                        $(item.inputText.nativeElement).removeClass('valid');
                        $(item.inputText.nativeElement).addClass('invalid');
                        item.msgError = item.validationsMsg['pattern'];
                    }
                    if (item.minLength != '') {
                        if (item.value !== undefined && item.value.length < parseInt(item.minLength)) {
                            item.inputValid = false;
                            $(item.inputText.nativeElement).removeClass('valid');
                            $(item.inputText.nativeElement).addClass('invalid');
                            item.msgError = (item.validationsMsg['minLength'] ? item.validationsMsg['minLength'].replace("%", "" + item.minLength) : '');
                        }
                    }
                    if (item.notnull && item.value !== undefined && item.value.length == 0) {
                        item.inputValid = false;
                        $(item.inputText.nativeElement).removeClass('valid');
                        $(item.inputText.nativeElement).addClass('invalid');
                        item.msgError = item.validationsMsg['require'];
                    }
                }
            });
        }
        if (this.inputPasswordComp.length > 0) {
            this.inputPasswordComp.forEach(function (item) {
                if (item.notnull && item.value == undefined || item.value.length == 0) {
                    item.inputValid = false;
                    $(item.inputPassword.nativeElement).removeClass('valid');
                    $(item.inputPassword.nativeElement).addClass('invalid');
                    item.msgError = 'Campo Obrigatório';
                }
                else {
                    if (item.value !== undefined && item.value.length < parseInt(item.minLength)) {
                        item.msgError = 'O campo deve ter no mínimo ' + item.minLength + ' caracteres';
                        $(item.inputPassword.nativeElement).removeClass('valid');
                        $(item.inputPassword.nativeElement).addClass('invalid');
                    }
                    else {
                        $(item.inputPassword.nativeElement).removeClass('invalid');
                        $(item.inputPassword.nativeElement).addClass('valid');
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.inputCepComp.length > 0) {
            this.inputCepComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    if (item.notnull && item.value.length == 0) {
                        item.inputValid = false;
                        $(item.inputCep.nativeElement).removeClass('valid');
                        $(item.inputCep.nativeElement).addClass('invalid');
                        item.msgError = item.validationsMsg['require'];
                    }
                }
            });
        }
        /*if (this.inputCnpjComp.length > 0) {
            this.inputCnpjComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }
        if (this.inputCpfComp.length > 0) {
            this.inputCpfComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }
        if (this.inputEmailComp.length > 0) {
            this.inputEmailComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }
        if (this.inputMaskComp.length > 0) {
            this.inputMaskComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }
        if (this.inputNumberComp.length > 0) {
            this.inputNumberComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }
        if (this.inputTelefoneComp.length > 0) {
            this.inputTelefoneComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }*/
        if (this.selectComp.length > 0) {
            this.selectComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    if (item.notnull && !item.value) {
                        item.inputValid = false;
                        item.msgError = item.validationsMsg['require'];
                    }
                }
            });
        }
        if (this.uploadComp.length > 0) {
            this.uploadComp.forEach(function (item, index) {
                if (item.isNotMasterDetail) {
                    if (item.notnull && item.value.length == 0) {
                        item.inputValid = false;
                        item.msgError = item.validationsMsg['require'];
                    }
                    // item.attribute = item.value;
                }
            });
        }
        /*if (this.radioComp.length > 0) {
            this.radioComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }
        if (this.listViewComp.length > 0) {
            this.listViewComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }
        if (this.dateBoxComp.length > 0) {
            this.dateBoxComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }
        if (this.autoCompleteComp.length > 0) {
            this.autoCompleteComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }
        if (this.checkBoxComp.length > 0) {
            this.checkBoxComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }
        if (this.moneyComp.length > 0) {
            this.moneyComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }
        if (this.textareaComp.length > 0) {
            this.textareaComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }
        if (this.multiSelectComp.length > 0) {
            this.multiSelectComp.forEach((item, index) => {
                if (item.isNotMasterDetail) {
                    retorno[item.attribute] = item.value
                }
            })
        }*/
    };
    Crud2Component.prototype.crudSetValue = function (key, value) {
        if (this.masterDetailComp.length > 0) {
            this.masterDetailComp.forEach(function (item, index) {
                if (key == item.attribute) {
                    if ($.isArray(value)) {
                        for (var _i = 0, value_1 = value; _i < value_1.length; _i++) {
                            var l = value_1[_i];
                            item.value.push(l);
                        }
                        // item.dataSource = value
                    }
                    else {
                        if (value != '') {
                            item.value.push(value);
                        }
                        else {
                            item.value = [];
                            item.inputValid = true;
                        }
                    }
                    // item.dataSource = item.value;
                    /*item.loadedReq.subscribe((ret) => {
                        if (ret) {
                            console.log(ret, item.generatedEntity)
                            item.value.push(value)
                            item.dataSource.push(value)
                        }
                    })*/
                }
            });
        }
        if (this.inputTextComp.length > 0) {
            this.inputTextComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.inputPasswordComp.length > 0) {
            this.inputPasswordComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.inputCepComp.length > 0) {
            this.inputCepComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.inputCnpjComp.length > 0) {
            this.inputCnpjComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.inputCpfComp.length > 0) {
            this.inputCpfComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.inputEmailComp.length > 0) {
            this.inputEmailComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.inputMaskComp.length > 0) {
            this.inputMaskComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.inputNumberComp.length > 0) {
            this.inputNumberComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.inputTelefoneComp.length > 0) {
            this.inputTelefoneComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.selectComp.length > 0) {
            this.selectComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    // item.value = JSON.parse(value)
                    item.value = value;
                    item.setValue(value);
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.radioComp.length > 0) {
            this.radioComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.listViewComp.length > 0) {
            this.listViewComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.dateBoxComp.length > 0) {
            this.dateBoxComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.uploadComp.length > 0) {
            this.uploadComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.clearValue();
                    }
                }
            });
        }
        if (this.autoCompleteComp.length > 0) {
            this.autoCompleteComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.checkBoxComp.length > 0) {
            this.checkBoxComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.moneyComp.length > 0) {
            this.moneyComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.textareaComp.length > 0) {
            this.textareaComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.multiSelectComp.length > 0) {
            this.multiSelectComp.forEach(function (item, index) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                    if (value === undefined || value.length == 0) {
                        item.inputValid = true;
                    }
                }
            });
        }
    };
    Crud2Component.prototype.reloadModel = function () {
        var _this = this;
        if (localStorage.getItem("__SBM-CRUD__" + this._router.url)) {
            var clearForm = Object.keys(this.loadModels());
            var _getFormCrud = localStorage.getItem("__SBM-CRUD__" + this._router.url);
            var storageValues_1 = JSON.parse(_getFormCrud);
            this.onModels.emit(storageValues_1);
            clearForm.map(function (a) {
                _this.crudSetValue(a, storageValues_1[a]);
            });
        }
    };
    Crud2Component.prototype.returnEdit = function () {
        if (this._activatedRoute.routeConfig['data']) {
            if (this._activatedRoute.routeConfig.data['masterDetailEdit']) {
                if (this._activatedRoute.routeConfig.data['returnDataEdit']) {
                    this.onModels.emit(this._activatedRoute.routeConfig.data['returnDataEdit']);
                    // this.models = this._activatedRoute.routeConfig.data['returnDataEdit'];
                    localStorage.setItem("__SBM-CRUD__" + this._router.url, JSON.stringify(this._activatedRoute.routeConfig.data['returnDataEdit']));
                    this.update.update = true;
                    this.update.id = this._activatedRoute.routeConfig.data['returnDataEdit']['id'];
                    this.reloadModel();
                }
            }
        }
    };
    Crud2Component.prototype.ngOnInit = function () {
        var _this = this;
        localStorage.setItem("__SBM-CRUD__/init" + this._router.url, JSON.stringify(this.loadModels()));
        if (this.table == '') {
            this.table = this.entity;
        }
        this.breadC = breadcrumb_crud_component_1.BreadcrumbCrudComponent.breadcrumbAlterado.subscribe(function () {
            _this.crudFormAtive = false;
            _this.formControlHidden = true;
        });
        if (localStorage.getItem(this.bc['localStogare'])) {
            this.crudFormAtive = true;
            this.formControlHidden = false;
            this.newBreadcrumb();
        }
        if (this._activatedRoute.routeConfig['data']) {
            if (this._activatedRoute.routeConfig['data']['isChildrenCrud']) {
                if (this._activatedRoute.routeConfig.data['filter']) {
                    this.crudFormAtive = false;
                    this.formControlHidden = true;
                }
                else {
                    this.crudFormAtive = true;
                    this.formControlHidden = false;
                    this.newBreadcrumb();
                }
            }
        }
        this.ActionButtons = select_component_1.SelectComponent._onActionButtons.subscribe(function (ret) {
            _this._router.config.map(function (a) {
                if (a.path == ret.url) {
                    if (ret.filter) {
                        a.data['filter'] = ret.filter;
                        a.data['urlAfter'] = _this._router.url;
                        a.data['id'] = ret.id;
                        a.data['isChildrenCrud'] = true;
                    }
                    else {
                        a.data['filter'] = ret.filter;
                        a.data['urlAfter'] = _this._router.url;
                        a.data['id'] = ret.id;
                        a.data['isChildrenCrud'] = true;
                    }
                    // a.data['filter'] = false;
                    _this._router.navigateByUrl(ret.url);
                }
            });
        });
    };
    Crud2Component.prototype.ngAfterViewChecked = function () {
        var _this = this;
        $(document).ready(function () {
            localStorage.setItem("__SBM-CRUD__" + _this._router.url, JSON.stringify(_this.loadModels()));
        });
    };
    Crud2Component.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            _this.reloadModel();
            _this.returnEdit();
            if (_this._activatedRoute.routeConfig['data']) {
                if (_this._activatedRoute.routeConfig.data['returnData']) {
                    if (_this._activatedRoute.routeConfig.data['masterDetailEdit']) {
                        _this.crudSetValue(_this._activatedRoute.routeConfig.data['returnData']['id'], _this._activatedRoute.routeConfig.data['returnData']['data']);
                    }
                    else if (_this._activatedRoute.routeConfig.data['masterDetailNew']) {
                        _this.crudSetValue(_this._activatedRoute.routeConfig.data['returnData']['id'], _this._activatedRoute.routeConfig.data['returnData']['data']);
                    }
                    else {
                        _this.reloadModel();
                        _this.crudSetValue(_this._activatedRoute.routeConfig.data['returnData']['id'], _this._activatedRoute.routeConfig.data['returnData']['data']);
                    }
                }
            }
            WebuiPopovers.create('.showHideColumns', {
                url: '#showHideColumnsContent',
                placement: 'bottom-left',
                width: 400,
                height: 460,
                animation: 'pop',
                backdrop: true,
                closeable: true,
                dismissible: true,
            });
            WebuiPopovers.create('#sbmPivotConfig', {
                url: '#sbmPivotContentConfig',
                placement: 'bottom-left',
                width: 400,
                height: 500,
                animation: 'pop',
                backdrop: true,
                closeable: true,
                dismissible: false,
                onHide: function ($element) {
                    _this.layoutDinamic();
                },
            });
            WebuiPopovers.create('.saveLayout', {
                url: '#saveLayoutContent',
                placement: 'bottom-left',
                width: 300,
                height: 170,
                backdrop: true,
                animation: 'pop',
                closeable: true,
                dismissible: true,
            });
            _this.filtroTabela();
        });
        this.masterDetailComp.forEach(function (item) {
            item.newFormMasterDetail.subscribe(function (ret) {
                if (ret) {
                    _this.crudFormComponent.first.elementHidden = true;
                }
                else {
                    _this.crudFormComponent.first.elementHidden = false;
                }
            });
        });
    };
    Crud2Component.prototype.ngOnDestroy = function () {
        this.breadC.unsubscribe();
        this.ActionButtons.unsubscribe();
    };
    return Crud2Component;
}());
Crud2Component.breadcrumbAlterado = new core_1.EventEmitter();
Crud2Component.emitChangeFilter = new core_1.EventEmitter();
Crud2Component.numero_registro_pagina = null;
Crud2Component.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-crud-depreceated',
                template: "\n     <div class=\"row content-filter z-depth-1\" [hidden]='crudFormAtive'>\n    <!--<div class=\"col l4 m12 s12 z-depth-1 sbm-content-parameters\" [hidden]=\"executedParameters\">-->\n    <div style=\"float:left;margin:5px\">\n        <sbm-button design=\"floating\" [icon]=\"buttonsActions.buttonOpenCloseFilter.icon\"\n                    (_onClick)=\"showParameters(executedParameters)\" title=\"Open/Close\"></sbm-button>\n    </div>    \n    <sbm-accordion #parameters columns=\"4\" [hidden]=\"executedParameters\">\n        <sbm-accordion-group icon=\"&#xE8B6;\" index=\"layouts\" label='Pesquisas Salvas'>\n            <div class=\"row\">\n                <div class=\"search-saved\">\n                    <div class=\"collection\" *ngIf=\"crudLayoutGrid.length > 0; else elseBlock\">\n                        <a *ngFor=\"let layout of crudLayoutGrid\" (click)=\"selectLayout(layout)\" class=\"collection-item\">{{layout['nome']}}</a>\n                    </div>\n                    <ng-template #elseBlock>\n                        <div class=\"collection\">\n                            <a class=\"collection-item disabled\">Vazio</a>\n                        </div>\n                    </ng-template> \n                </div>\n            </div>\n        </sbm-accordion-group>\n        <sbm-accordion-group icon=\"&#xE152;\" index=\"filters\" label='Filtros' [active]=\"true\">\n            <div class=\"row\">\n                <div class=\"sbm-select\">\n                    <sbm-select #filtroTabela securityId=\"campo01\" id='campo13' placeholder='- Selecione -'\n                                [text]='[\"nome\"]' label=\"Filtro\"\n                                (_onClick)='selectFilter($event)'></sbm-select>\n                </div>\n                <div class=\"sbm-parameters\" *ngIf='selectedFilter'>\n                    <div class=\"filter-execution\">\n                        <sbm-parameters [dataSource]='dataSource' (onSave)='retornoParametro($event)' [(models)]=\"parametersModels\"></sbm-parameters>\n                    </div>\n                    <div class=\"col l12 s12 m12 xl12\">\n                        <sbm-button css=\"right\" design=\"floating\" color=\"black-text grey darken-2\" (_onClick)=\"executarFiltro()\" title=\"Executar\" icon=\"&#xE8B6;\"></sbm-button>\n                        <sbm-button css=\"right\" design=\"floating\" color=\"black-text grey darken-2\" (_onClick)=\"exportExcell()\" css='hide-on-med-and-down' title=\"Exportar Excel\" icon=\"&#xE2C4;\"></sbm-button>\n                    </div>\n                </div>\n            </div>\n        </sbm-accordion-group>\n    </sbm-accordion>\n    <!--</div>-->\n    <div id='sbm-grid-result' class=\"col l7 m12 s12 z-depth-1\">\n        <div class=\"col s12 action-bar\">\n            <div class=\"row\">\n                <div class=\"col l12 s12 m12 crud-padding-action\" style=\"border-bottom: 1px solid #cbcbcb;padding-bottom: 8px;\">\n                    <sbm-button color=\"green darken-4\" design=\"floating\" icon=\"&#xE145;\"\n                                (_onClick)=\"clickNew()\" title=\"Novo\"></sbm-button>\n                    <sbm-button color=\"light-blue darken-4\" [disabled]=\"buttonsActions.buttonEdit.disabled\" design=\"floating\" icon=\"&#xE254;\"\n                                (_onClick)=\"clickEdit(selectItem)\" title=\"Editar\"></sbm-button>\n                    <sbm-button color=\"red\" [disabled]=\"buttonsActions.buttonRemove.disabled\" design=\"floating\" icon=\"&#xE872;\"\n                                (_onClick)=\"clickDelete(selectItem)\" title=\"Excluir\"></sbm-button>\n\n                    <span class=\"font-bold grey-text\">{{layoutCurrent?.nome}}</span>\n\n                    <span class=\"sbm-select-layout-grid\">\n                                <sbm-button color=\"green darken-4\" [disabled]=\"buttonsActions.buttonSaveSearch.disabled\" design=\"floating\" icon=\"&#xE161;\"\n                                            (_onClick)=\"saveLayout(null, $event)\" title=\"Salvar Pesquisa\"></sbm-button>\n                                <sbm-button color=\"green light-4\" [disabled]=\"buttonsActions.buttonSaveSearchAll.disabled\" design=\"floating\" icon=\"&#xE02E;\"\n                                            (_onClick)=\"saveLayout(null, $event)\" title=\"Adicionar Pesquisa\" css=\"saveLayout\"></sbm-button>\n                                <sbm-button color=\"red\" [disabled]=\"buttonsActions.buttonRemoveSearch.disabled\" design=\"floating\" icon=\"&#xE15D;\"\n                                            (_onClick)=\"removeLayout(layoutCurrent)\" title=\"Apagar Pesquisa\"></sbm-button>\n                                <sbm-button color=\"light-blue darken-3\" [disabled]=\"buttonsActions.buttonSearchRow.disabled\" design=\"floating\" icon=\"&#xE91A;\"\n                                             (_onClick)=\"changeSearchPanelColumn()\" title=\"Mostrar Pesquisa por colunas\"></sbm-button>\n                                <sbm-button [hidden]=\"valuePerspective\" color=\"light-blue darken-3\" css=\"showHideColumns\" [disabled]=\"buttonsActions.buttonHideShowColumns.disabled\"\n                                            design=\"floating\" icon=\"&#xE8EC;\" title=\"Ocultar/Exibir colunas\"></sbm-button>\n                                <sbm-button [disabled]=\"buttonsActions.buttonExport.disabled\" [hidden]=\"valuePerspective\" color=\"blue darken-3\" design=\"floating\" icon=\"&#xE2C4;\"\n                                            (_onClick)=\"exportButtonGrid()\" title=\"Exportar Excel\" css=\"hide-on-med-and-down\"></sbm-button>\n\n                                <span class=\"sbm-crud-perspective\" style=\"display:none; line-height: 36px;\" title=\"Mudar Perspectiva\">\n                                     <div class=\"switch\">\n                                     <label>\n                                     <input type=\"checkbox\" disabled #inputPerspec [(ngModel)]=\"valuePerspective\" (click)='changePerspective(inputPerspec, pivotGirdEl)'/>\n                                     <span class=\"lever\"></span>\n                                     </label>\n                                     </div>\n                                </span>\n                            </span>\n                    <!--ng-content select='[action]'></ng-content-->\n                </div>\n            </div>\n        </div>\n        <div class='col l12 m12 s12 sbm-crud-grid-content'>\n            <div [hidden]=\"valuePerspective\">\n                <div #loader class=\"preloader-wrapper big active loader-sbm-crud\" style=\"display:none\">\n                    <div class=\"spinner-layer spinner-red-only\">\n                        <div class=\"circle-clipper left\">\n                            <div class=\"circle\"></div>\n                        </div><div class=\"gap-patch\">\n                        <div class=\"circle\"></div>\n                    </div><div class=\"circle-clipper right\">\n                        <div class=\"circle\"></div>\n                    </div>\n                    </div>\n                </div>\n\n                <dx-data-grid #gridResultCrud style=\"width:100%;height: 500px\" [hidden]='setGrid.length == 0' id=\"gridContainer\"\n                              [dataSource]='setGrid'\n                              [allowColumnReordering]=\"false\"\n                              [allowColumnResizing]=\"true\"\n                              [showRowLines]=\"true\"\n                              [showBorders]=\"true\"\n                              [rowAlternationEnabled]=\"true\"\n                              [columnAutoWidth]=\"false\"\n                              noDataText=\"Filtre para ver os registros\"\n                              [searchPanel]='{\n                         visible: true,\n                         width: 240,\n                         placeholder: \"Procurar...\"\n                         }'\n                              (onContentReady)=\"changeGrid($event)\"\n                              (onContextMenuPreparing)=\"onContextMenuPreparing($event)\"\n                              [paging]='{\n                         pageSize: 10\n                         }'\n                              [groupPanel]='{\n                         visible: true,\n                         emptyPanelText: \"Arraste uma coluna aqui para agrupar\"\n                         }'\n                              [selection]='{\n                         mode: \"multiple\"\n                         }' \n                              (onSelectionChanged)='selectionData($event)'\n                >\n                    <dxo-export [enabled]=\"false\" fileName=\"{{entity}}\" [allowExportSelectedData]=\"true\"\n                                [texts]=\"{'exportAll': 'Exportar Tudo', 'exportSelectedRows': 'Exportar selecionados', 'exportTo': 'Exportar excel'}\"></dxo-export>\n                    <dxo-scrolling mode=\"virtual\"></dxo-scrolling>\n                    <dxo-header-filter [visible]=\"true\"></dxo-header-filter>\n                    <dxo-filter-row [visible]=\"searchPanelColumn\"></dxo-filter-row>\n                    <dxi-column *ngFor=\"let item of colunas\" [dataField]=\"item.dataField\" [caption]=\"item.caption\" [formItem]=\"item.formItem\"\n                                [visible]=\"true\"></dxi-column>\n                    <dxo-summary>\n                        <dxi-group-item\n                                summaryType=\"count\"\n                                displayFormat=\"{0} registros\">\n                        </dxi-group-item>\n                    </dxo-summary>\n                </dx-data-grid>\n            </div>\n\n            <div [hidden]=\"!valuePerspective\">\n                <dx-pivot-grid\n                        style=\"width:100%;\"\n                        #pivotGridEl\n                        [allowColumnReordering]=\"true\"\n                        [allowColumnResizing]=\"false\"\n                        [columnAutoWidth]=\"false\"\n                        [allowSortingBySummary]=\"true\"\n                        [allowSorting]=\"true\"\n                        [allowFiltering]=\"true\"\n                        [allowExpandAll]=\"true\"\n                        [height]=\"440\"\n                        [showBorders]=\"true\"\n                        [dataSource]=\"pivotGrid\">\n                    <dxo-export [enabled]=\"true\" fileName=\"{{entity}}\"></dxo-export>\n                    <dxo-field-chooser [enabled]=\"false\"></dxo-field-chooser>\n                </dx-pivot-grid>\n            </div>\n\n            <div [hidden]='setGrid.length == 0' class=\"col m12 l12 s12\" style=\"text-align:center\">\n                <sbm-button css=\"teal-text\" design='flat' [hidden]=\"valuePerspective\" icon=\"&#xE313;\" [disabled]=\"buttonsActions.buttonNextPage.disabled\"\n                            (_onClick)=\"pageNext(buttonNext)\" title=\"Buscar Mais\"></sbm-button>\n                <sbm-button css=\"teal-text\" design='flat' [hidden]=\"valuePerspective\" (_onClick)=\"getAll()\" title=\"Buscar tudo\"\n                            text=\"Buscar tudo\" [disabled]=\"buttonsActions.buttonGetAll.disabled\"></sbm-button>\n            </div>\n            <div [hidden]='setGrid.length == 0'  class=\"grid-count-registers\">{{setGrid?.length}} de {{countRegister}} registros</div>\n\n\n            <div class=\"filter-empty\" [hidden]='setGrid.length > 0'>\n                <h1 class=\"flow-text\">\n                    Execute o filtro para retornar sua busca...\n                </h1>\n            </div>\n\n        </div>\n        <div class=\"col l12 complementary-action-bar\">\n             <span class=\"complementary-content\">\n             <!--ng-content select='[complementary]'></ng-content-->\n             </span>\n        </div>\n    </div>\n\n    <div style=\"display: none;\" id=\"showHideColumnsContent\">\n        <sbm-list-view #sbmtable\n                       securityId='campo01'\n                       selectionMultiple='true'\n                       label='Mostrar/Ocultar Colunas'\n                       [(ngModel)]=\"showHideColumnValue\"\n                       (_onClick)='ClickShowColumn($event)'\n                       (_onRemove)='ClickHideColumn($event)'>\n\n            <sbm-list-option *ngFor=\"let data of colunas, let i = index\" [value]='i'>{{data.caption}}</sbm-list-option>\n\n        </sbm-list-view>\n    </div>\n\n    <div style=\"display: none;\" id=\"saveLayoutContent\">\n        <div class=\"row\">\n            <sbm-input-text label=\"Digite um nome\" [require]=\"true\" [(ngModel)]=\"name_search\"></sbm-input-text>\n            <sbm-checkbox label=\"Pesqusa Padr\u00E3o\" [(ngModel)]=\"default_search\"></sbm-checkbox>\n            <div class=\"col s12 m12 l12\">\n                <sbm-button css=\"right\" text=\"Salvar\" (_onClick)=\"saveLayout({'name_search': name_search, 'default_search': default_search})\"></sbm-button>\n            </div>\n        </div>\n    </div>\n\n    <div style=\"display: none;\" id=\"sbmPivotContentConfig\">\n        <dx-pivot-grid-field-chooser\n                #pivotGridChooser\n                [dataSource]=\"pivotGrid\"\n                [width]=\"350\"\n                [height]=\"400\"\n                [layout]=\"{\n             key: 0,\n             name: 'Layout0'\n             }\">\n            <dxo-texts allFields='Colunas'\n                       columnFields='Coluna'\n                       dataFields='Valor'\n                       rowFields='Linhas'\n                       filterFields='Filtro'></dxo-texts>\n        </dx-pivot-grid-field-chooser>\n    </div>\n\n    <div [hidden]=\"!valuePerspective\" style=\"float:right;margin:5px\">\n        <a class=\"btn-floating btn-small waves-effect waves-light\" id=\"sbmPivotConfig\">\n            <!--i id=\"icon-button-show-pivot\" class=\"material-icons\">&#xE314;</i-->\n            <i class=\"material-icons\">&#xE5D4;</i>\n        </a>\n    </div>\n</div>\n\n<div #formCrud class=\"row z-depth-1\" [hidden]='formControlHidden'>\n    <div class=\"col l12\">\n        <form #crudFrom #f='ngForm' (ngSubmit)='addFormControls(f)'>\n            <!--ng-content select='[crud-form]'></ng-content-->\n            <ng-content></ng-content>\n            <div class='col l12 alert alert-danger' id='msgValidations' [hidden]='noErrosForm'></div>\n            <div class='col l12 s12 m12 actions-crud-form'>\n                <a class='waves-effect waves-light btn red'  (click)='cancel()'>Cancelar</a>\n                <a class='waves-effect waves-light btn light-blue darken-4' [ngClass]=\"{'disabled':servicePending}\"\n                   (click)='addFormControls(f, true)'>Salvar e Continuar</a>\n                <a class='waves-effect waves-light btn green darken-4' [ngClass]=\"{'disabled':servicePending}\" (click)='addFormControls(f,\n             false)'>Salvar</a>\n            </div>\n        </form>\n    </div>\n</div>\n    ",
            },] },
];
/** @nocollapse */
Crud2Component.ctorParameters = function () { return [
    { type: req_http_service_1.ReqHttpService, },
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
    { type: router_1.Router, },
    { type: router_1.ActivatedRoute, },
    { type: core_1.ElementRef, },
]; };
Crud2Component.propDecorators = {
    'masterDetailComp': [{ type: core_1.ContentChildren, args: [master_detail_component_1.MasterDetailComponent, { descendants: true },] },],
    'inputTextComp': [{ type: core_1.ContentChildren, args: [input_text_component_1.InputTextComponent, { descendants: true },] },],
    'inputTelefoneComp': [{ type: core_1.ContentChildren, args: [input_telefone_component_1.InputTelefoneComponent, { descendants: true },] },],
    'inputPasswordComp': [{ type: core_1.ContentChildren, args: [input_password_component_1.InputPasswordComponent, { descendants: true },] },],
    'inputNumberComp': [{ type: core_1.ContentChildren, args: [input_number_component_1.InputNumberComponent, { descendants: true },] },],
    'inputMaskComp': [{ type: core_1.ContentChildren, args: [input_mask_component_1.InputMaskComponent, { descendants: true },] },],
    'inputCepComp': [{ type: core_1.ContentChildren, args: [input_cep_component_1.InputCepComponent, { descendants: true },] },],
    'inputCnpjComp': [{ type: core_1.ContentChildren, args: [input_cnpj_component_1.InputCnpjComponent, { descendants: true },] },],
    'inputCpfComp': [{ type: core_1.ContentChildren, args: [input_cpf_component_1.InputCpfComponent, { descendants: true },] },],
    'inputEmailComp': [{ type: core_1.ContentChildren, args: [input_email_component_1.InputEmailComponent, { descendants: true },] },],
    'radioComp': [{ type: core_1.ContentChildren, args: [radio_component_1.RadioComponent, { descendants: true },] },],
    'listViewComp': [{ type: core_1.ContentChildren, args: [list_view_component_1.ListViewComponent, { descendants: true },] },],
    'dateBoxComp': [{ type: core_1.ContentChildren, args: [datebox_component_1.DateboxComponent, { descendants: true },] },],
    'uploadComp': [{ type: core_1.ContentChildren, args: [upload_component_1.UploadComponent, { descendants: true },] },],
    'autoCompleteComp': [{ type: core_1.ContentChildren, args: [autocomplete_component_1.AutocompleteComponent, { descendants: true },] },],
    'checkBoxComp': [{ type: core_1.ContentChildren, args: [checkbox_component_1.CheckboxComponent, { descendants: true },] },],
    'moneyComp': [{ type: core_1.ContentChildren, args: [money_component_1.MoneyComponent, { descendants: true },] },],
    'textareaComp': [{ type: core_1.ContentChildren, args: [textarea_component_1.TextareaComponent, { descendants: true },] },],
    'multiSelectComp': [{ type: core_1.ContentChildren, args: [multiselect_component_1.MultiselectComponent, { descendants: true },] },],
    'selectComp': [{ type: core_1.ContentChildren, args: [select_component_1.SelectComponent, { descendants: true },] },],
    'crudFormComponent': [{ type: core_1.ContentChildren, args: [CrudFormComponent, { descendants: true },] },],
    '_crudFrom': [{ type: core_1.ViewChild, args: ['crudFrom',] },],
    '_buttonNext': [{ type: core_1.ViewChild, args: ['buttonNext',] },],
    '_buttonAll': [{ type: core_1.ViewChild, args: ['buttonAll',] },],
    '_loader': [{ type: core_1.ViewChild, args: ['loader',] },],
    'parametersEl': [{ type: core_1.ViewChild, args: ['parameters',] },],
    'formCurdEl': [{ type: core_1.ViewChild, args: ['formCrud',] },],
    '_inputPerspec': [{ type: core_1.ViewChild, args: ['inputPerspec',] },],
    'gridResultCrud': [{ type: core_1.ViewChild, args: ['gridResultCrud',] },],
    'sbmLayout': [{ type: core_1.ViewChild, args: ['sbmLayout',] },],
    'sbmFiltroTabela': [{ type: core_1.ViewChild, args: ['filtroTabela',] },],
    'sbmPivotGridChooser': [{ type: core_1.ViewChild, args: ['pivotGridChooser',] },],
    'pivotGridEl': [{ type: core_1.ViewChild, args: ['pivotGridEl',] },],
    'entity': [{ type: core_1.Input },],
    'urlBase': [{ type: core_1.Input },],
    'pathFilter': [{ type: core_1.Input },],
    'table': [{ type: core_1.Input },],
    'masterDetail': [{ type: core_1.Input },],
    'perspective': [{ type: core_1.Input },],
    'selectItems': [{ type: core_1.Output },],
    'clickedNew': [{ type: core_1.Output },],
    'clickedEdit': [{ type: core_1.Output },],
    'clickedCancel': [{ type: core_1.Output },],
    'onModels': [{ type: core_1.Output },],
    'models': [{ type: core_1.Input },],
};
exports.Crud2Component = Crud2Component;
