"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var moment = require("moment");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var DateboxComponent = (function (_super) {
    __extends(DateboxComponent, _super);
    function DateboxComponent(el, _sharedService, _http, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this.el = el;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._translateService = _translateService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.css = 'sbm-input';
        _this.styleCss = '';
        _this.defaultValue = null;
        _this.disabled = false;
        _this.readonly = false;
        _this.notnull = false;
        _this.onClick = '';
        _this.onChange = '';
        _this._onClick = new core_1.EventEmitter();
        _this._onChange = new core_1.EventEmitter();
        _this._columns = 'col l12 m12 s12 input-field crud-form-dynamic';
        _this._min = null;
        _this._max = null;
        _this.displayFormat = exports.DateboxConstDisplayFormat.datetime;
        _this.isNotMasterDetail = true;
        _this.inputValid = true;
        _this.randomId = '';
        _this.textDateBox = {
            dateMin: '',
            dateMax: ''
        };
        _this._label = '';
        _this.blur = function (date) {
            if (typeof date == 'string') {
                if (_this.regex(date)) {
                    if (date && date != '') {
                        var _splitDate = date.split('/');
                        var newDateConcat = _splitDate[2].slice(0, 4) + '-' + _splitDate[1] + '-' + _splitDate[0] + ' ' + _splitDate[2].slice(5, 11);
                        var newDate = new Date(newDateConcat);
                        _this.valueEvent = newDate;
                        _this.value = newDate;
                        _this._onChange.emit(_this.valueEvent);
                        if (_this.onChange != '') {
                            window[_this.onChange](_this.valueEvent);
                        }
                    }
                }
                else {
                    _this.valueEvent = null;
                    _this.value = null;
                }
            }
            else if (typeof date == 'object') {
                _this.valueEvent = date;
                _this._onChange.emit(_this.valueEvent);
                if (_this.onChange != '') {
                    window[_this.onChange](_this.valueEvent);
                }
            }
        };
        sbmDateboxComponent.push(_this);
        return _this;
    }
    Object.defineProperty(DateboxComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12 input-field crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateboxComponent.prototype, "min", {
        get: function () {
            return this._min;
        },
        set: function (val) {
            var minDate = moment().subtract(parseInt(val), 'days').format("YYYY-MM-DD HH:mm:ss");
            this._min = minDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateboxComponent.prototype, "max", {
        get: function () {
            return this._max;
        },
        set: function (val) {
            var maxDate = moment().add(parseInt(this.min), 'days').format("YYYY-MM-DD HH:mm:ss");
            this._max = maxDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateboxComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateboxComponent.prototype, "type", {
        get: function () {
            return this._type;
        },
        set: function (value) {
            var typeDate = { 'date': 'date', 'time': 'time', 'datetime': 'both' };
            this.typeDisplay = typeDate[value];
            if (value == 'datetime') {
                this.displayFormat = exports.DateboxConstDisplayFormat.datetime;
            }
            if (value == 'date') {
                this.displayFormat = exports.DateboxConstDisplayFormat.date;
            }
            if (value == 'time') {
                this.displayFormat = exports.DateboxConstDisplayFormat.time;
            }
        },
        enumerable: true,
        configurable: true
    });
    DateboxComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    DateboxComponent.prototype.ngAfterViewInit = function () {
        var me = this;
        $(this.datebox.nativeElement).attr('style', this.styleCss);
        this.valueChangeSubscription = this.onChangeValue.subscribe(function (ret) {
            if (ret) {
                $(me.el.nativeElement).find('label').addClass('active');
                me.blur(ret);
            }
        });
        if (this.typeDisplay == 'both') {
            $(this.datebox.nativeElement).mask('00/00/0000 00:00');
        }
        else if (this.typeDisplay == 'date') {
            $(this.datebox.nativeElement).mask('00/00/0000');
        }
        else if (this.typeDisplay == 'time') {
            $(this.datebox.nativeElement).mask('00:00');
        }
    };
    DateboxComponent.prototype.closeDateBox = function (date) {
        this.valueEvent = date;
        $("label[for='" + this.randomId + "']").addClass("active");
        this._onClick.emit(date);
        if (this.onClick != '') {
            window[this.onClick](date);
        }
    };
    DateboxComponent.prototype.keyup = function ($event) {
        // console.log($event)
    };
    DateboxComponent.prototype.regex = function (value) {
        var regexTime = /^([0-9]|0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$/;
        var regexData = /^([0-2]\d|[3][0-1])\/([0]\d|[1][0-2])\/([1-2]\d{3})$/;
        var regexDataTime = /^([0-2]\d|[3][0-1])\/([0]\d|[1][0-2])\/([1-2]\d{3})\s([0-1]\d|[2][0-3])\:([0-5]\d)$/;
        if (this.typeDisplay == 'both') {
            return regexDataTime.test(value);
        }
        else if (this.typeDisplay == 'date') {
            return regexData.test(value);
        }
        else if (this.typeDisplay == 'time') {
            return regexTime.test(value);
        }
    };
    DateboxComponent.prototype.ngOnDestroy = function () {
        this.valueChangeSubscription.unsubscribe();
    };
    return DateboxComponent;
}(abstract_ngmodel_1.AbstractNgModel));
DateboxComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-datebox',
                template: "\n        <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n        <input \n            #datebox\n            #component=\"ngModel\"\n            id=\"{{randomId}}\" \n            type=\"text\" \n            [style]=\"styleCss\"\n            [disabled]=\"disabled\" \n            [readonly]=\"readonly\"\n            [required]=\"notnull\"\n            [pickerType]=\"typeDisplay\" \n            [hourTime]=\"'24'\" \n            locale=\"pt-br\"\n            [autoClose]=\"true\"\n            [onlyCurrentMonth]=\"false\"\n            [showSeconds]=\"false\"\n            [locale]=\"'pt-br'\" \n            [mode]=\"'dropdown'\" \n            [minMoment]=\"min\"\n            [maxMoment]=\"max\"\n            class=\"{{css}}\"\n            (keyup)=\"keyup($event)\" \n            (onChange)=\"closeDateBox($event)\" \n            [(ngModel)]=\"value\" \n            [value]=\"valueEvent | date: displayFormat\"\n            (blur)=\"blur(datebox.value)\" \n            dateTimePicker \n        />\n\n        <span *ngIf=\"!component.valid\" class=\"msgError\">\n            <p class=\"msgError\" *ngIf=\"component['errors']['required']\">\n                Campo Obrigat\u00F3rio\n            </p> \n            <!--p class=\"msgError\" *ngIf=\"component['errors']['date']\">\n                Data Inv\u00E1lida\n            </p-->\n        </span>\n    ",
                styles: ["\n        .ng-invalid {\n            border-bottom: 1px solid #F44336 !important;\n            box-shadow: 0 1px 0 0 #F44336 !important;\n        }\n    "],
                host: {
                    '[class]': 'columns',
                    '[ngClass]': 'options ? options.className : ""'
                },
                providers: [abstract_ngmodel_1.MakeProvider(DateboxComponent)]
            },] },
];
/** @nocollapse */
DateboxComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: sharedService_1.SharedService, },
    { type: http_1.Http, },
    { type: core_2.TranslateService, },
]; };
DateboxComponent.propDecorators = {
    'datebox': [{ type: core_1.ViewChild, args: ['datebox',] },],
    'component': [{ type: core_1.ViewChild, args: ['component',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input },],
    'defaultValue': [{ type: core_1.Input },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'onClick': [{ type: core_1.Input },],
    'onChange': [{ type: core_1.Input },],
    '_onClick': [{ type: core_1.Output },],
    '_onChange': [{ type: core_1.Output },],
    'columns': [{ type: core_1.Input },],
    'min': [{ type: core_1.Input },],
    'max': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'type': [{ type: core_1.Input },],
};
exports.DateboxComponent = DateboxComponent;
exports.DateboxConstDisplayFormat = {
    date: 'dd/MM/yyyy',
    time: 'HH:mm',
    datetime: 'dd/MM/yyyy HH:mm'
};
var DateboxEnumType;
(function (DateboxEnumType) {
    DateboxEnumType[DateboxEnumType["date"] = 0] = "date";
    DateboxEnumType[DateboxEnumType["time"] = 1] = "time";
    DateboxEnumType[DateboxEnumType["datetime"] = 2] = "datetime";
})(DateboxEnumType = exports.DateboxEnumType || (exports.DateboxEnumType = {}));
