"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var DragAndDropComponent = (function (_super) {
    __extends(DragAndDropComponent, _super);
    function DragAndDropComponent(_sharedService, _translateService, _http) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this._http = _http;
        _this.droppedItems = [];
        _this.items = [];
        _this.securityId = '';
        _this.id = '';
        _this.textdrop = 'Drag';
        _this.textdrag = 'Drag';
        _this.keepItems = false;
        _this.design = 'simple';
        _this.itemSrc = 'assets';
        _this.itemLink = 'principal';
        _this.itemIcon = 'grade';
        _this.itemText = 'title';
        _this.itemDesc = 'title';
        _this._columns = 'col l12 s12 m12';
        return _this;
    }
    Object.defineProperty(DragAndDropComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (val) {
            this._dataSource = val;
            this.changeDataSorce(val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DragAndDropComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12";
        },
        enumerable: true,
        configurable: true
    });
    DragAndDropComponent.prototype.changeDataSorce = function (val) {
        if (typeof val == 'object') {
            this.items = val;
        }
        else {
        }
    };
    DragAndDropComponent.prototype.onItemDrop = function (e) {
        var _this = this;
        if (this.droppedItems.length > 0) {
            this.droppedItems.forEach(function (item) {
                console.log(JSON.stringify(item), JSON.stringify(e));
                if (JSON.stringify(item) != JSON.stringify(e['dragData'])) {
                    _this.droppedItems.push(e.dragData);
                }
            });
        }
        else {
            this.droppedItems.push(e.dragData);
        }
        if (!this.keepItems) {
            this.items.forEach(function (item, index) {
                if (JSON.stringify(item) == JSON.stringify(e['dragData'])) {
                    _this.items.splice(index, 1);
                }
            });
        }
        this.value = this.droppedItems;
        console.log(e);
    };
    DragAndDropComponent.prototype.onItemDropData = function (e) {
        var _this = this;
        console.log(e);
        if (this.droppedItems.length > 0) {
            this.droppedItems.forEach(function (item, index) {
                console.log(JSON.stringify(item), JSON.stringify(e));
                if (JSON.stringify(item) == JSON.stringify(e['dragData'])) {
                    _this.droppedItems.splice(index, 1);
                }
            });
        }
        if (!this.keepItems) {
            this.items.push(e['dragData']);
        }
        this.value = this.droppedItems;
    };
    DragAndDropComponent.prototype.dragEnd = function (e) {
        // console.log(e);
    };
    DragAndDropComponent.prototype.dragEndData = function (e) {
        // console.log(e);
    };
    DragAndDropComponent.prototype.ngOnInit = function () {
        this.validar(this.securityId);
    };
    DragAndDropComponent.prototype.ngAfterViewInit = function () {
        switch (this.design) {
            case 'avatar':
                break;
            case 'secundary':
                break;
            default:
                break;
        }
    };
    return DragAndDropComponent;
}(abstract_ngmodel_1.AbstractNgModel));
DragAndDropComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-drag-and-drop',
                template: "\n    <div class=\"col s12 m6 l6 xl6\">\n      <div class=\"card\" droppable (onDrop)=\"onItemDropData($event)\">\n        <div class=\"card-content\">\n            <span class=\"card-title\">{{textdrag}}</span>\n            <div class=\"content-drag-drop\">\n              <ul class=\"collection\">\n                <li draggable (onDragEnd)=\"dragEnd($event)\" *ngFor=\"let item of items\" [dragData]=\"item\" class=\"collection-item {{design=='avatar' ? 'avatar' : ''}}\">\n                  <img *ngIf=\"design=='avatar'\" [src]=\"item[itemSrc]\" [alt]=\"item[itemSrc]\" class=\"circle\">\n                  <span *ngIf=\"design!='avatar'; else elseBlock\">{{item[itemText]}}</span>\n                  <ng-template #elseBlock>\n                    <span class=\"title\">{{item[itemText]}}</span>\n                    <p>{{item[itemDesc]}}</p>\n                  </ng-template>               \n                  <a *ngIf=\"design=='avatar' || design=='secundary'\" [routerLink]=\"item[itemLink]\" class=\"secondary-content\"><i class=\"material-icons\">{{item[itemIcon]}}</i></a>\n                </li>\n              </ul>\n            </div>\n        </div>\n      </div>\n    </div>\n    <div class=\"col s12 m6 l6 xl6\">  \n      <div class=\"card\" droppable (onDrop)=\"onItemDrop($event)\">\n        <div class=\"card-content\">\n            <span class=\"card-title\">{{textdrop}}</span>\n            <div class=\"content-drag-drop\">\n              <ul class=\"collection\">\n                  <li draggable (onDragEnd)=\"dragEndData($event)\" *ngFor=\"let item of droppedItems\" [dragData]=\"item\" class=\"collection-item {{design=='avatar' ? 'avatar' : ''}}\">\n                    <img *ngIf=\"design=='avatar'\" [src]=\"item[itemSrc]\" [alt]=\"item[itemSrc]\" class=\"circle\">\n                    <span *ngIf=\"design!='avatar'; else elseBlock\">{{item[itemText]}}</span>\n                    <ng-template #elseBlock>\n                      <span class=\"title\">{{item[itemText]}}</span>\n                      <p>{{item[itemDesc]}}</p>\n                    </ng-template>               \n                    <a *ngIf=\"design=='avatar' || design=='secundary'\" [routerLink]=\"item[itemLink]\" class=\"secondary-content\"><i class=\"material-icons\">{{item[itemIcon]}}</i></a>\n                  </li>\n              </ul>\n            </div>\n        </div>\n      </div>\n    </div>\n  ",
                styles: ["\n    \n  "],
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(DragAndDropComponent)]
            },] },
];
/** @nocollapse */
DragAndDropComponent.ctorParameters = function () { return [
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
]; };
DragAndDropComponent.propDecorators = {
    'securityId': [{ type: core_1.Input },],
    'id': [{ type: core_1.Input },],
    'textdrop': [{ type: core_1.Input },],
    'textdrag': [{ type: core_1.Input },],
    'keepItems': [{ type: core_1.Input },],
    'design': [{ type: core_1.Input },],
    'itemSrc': [{ type: core_1.Input },],
    'itemLink': [{ type: core_1.Input },],
    'itemIcon': [{ type: core_1.Input },],
    'itemText': [{ type: core_1.Input },],
    'itemDesc': [{ type: core_1.Input },],
    'dataSource': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.DragAndDropComponent = DragAndDropComponent;
