"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var req_http_service_1 = require("../../services/req-http.service");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var DragComponent = (function (_super) {
    __extends(DragComponent, _super);
    function DragComponent(_reqHttpService, _sharedService, _translateService, _http) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._reqHttpService = _reqHttpService;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this._http = _http;
        _this.droppedItems = [];
        _this.items = [];
        _this.itemsHide = [];
        _this.callBackDrag = new core_1.EventEmitter();
        _this.securityId = '';
        _this.id = '';
        _this.title = '';
        _this.emptyMessage = 'Vazio';
        _this.textdrag = 'Drag';
        _this.keepItems = false;
        _this._design = 'simple';
        _this.itemSrc = 'assets';
        _this.itemLink = 'principal';
        _this.itemIcon = 'null';
        _this.itemTitle = 'title';
        _this.itemDesc = 'title';
        _this.reqIndex = 'data';
        _this.itemDisable = 'visible';
        _this.dropScope = ['drop1'];
        _this.dragScope = 'drag1';
        _this.disabled = false;
        _this._columns = 'col l12 s12 m12';
        return _this;
    }
    Object.defineProperty(DragComponent.prototype, "design", {
        get: function () {
            return this._design;
        },
        set: function (val) {
            if (val == 'avatar' || val == 'blocks') {
                this._design = val;
            }
            else {
                this._design = 'simple';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DragComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (val) {
            this._dataSource = val;
            this.changeDataSorce(val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DragComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12";
        },
        enumerable: true,
        configurable: true
    });
    DragComponent.prototype.reqService = function (url) {
        var _this = this;
        this._reqHttpService.xhrGet(url).subscribe(function (ret) {
            _this.dataSource = ret.res[_this.reqIndex];
        });
    };
    DragComponent.prototype.changeDataSorce = function (val) {
        var _this = this;
        if (typeof val == 'object') {
            val.map(function (item, index) {
                item['dragScope'] = _this.dragScope;
                item['index'] = index;
                item['drag_visible'] = true;
                // item['instanceDrag'] = this;
            });
            this.itemsHide = val.filter(function (itm) { return (itm['drag_visible']); });
            this.items = val;
        }
        else {
            this.reqService(val);
        }
    };
    DragComponent.prototype.dragEnd = function (e) {
        //empty
    };
    DragComponent.prototype.onItemDrop = function (e) {
        //empty
    };
    DragComponent.prototype.ngOnInit = function () {
        this.validar(this.securityId);
    };
    DragComponent.prototype.ngAfterViewInit = function () {
    };
    return DragComponent;
}(abstract_ngmodel_1.AbstractNgModel));
DragComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-drag',
                template: "\n      <div class=\"card\" [ngClass]=\"{'dragDisabled': disabled}\" droppable (onDrop)=\"onItemDrop($event)\" [dropScope]=\"dropScope\">\n        <div class=\"card-content\">\n            <span class=\"card-title\" *ngIf=\"title != ''\">{{title}}</span>\n            <div class=\"content-drag-drop\">\n              <ul class=\"collection\" *ngIf=\"design=='avatar' || design=='simple'\"> \n                <li draggable (onDragEnd)=\"dragEnd(item)\" *ngFor=\"let item of items\" [dragData]=\"{'item': item, 'instance': this}\" [dragScope]=\"item.dragScope\"\n                class=\"collection-item {{design=='avatar' ? 'avatar' : ''}} {{item[itemDisable] ? '' : 'li-no-selection' }}\" \n                    [dragEnabled]=\"item[itemDisable]\" [hidden]=\"!item.drag_visible\">\n                  <img *ngIf=\"design=='avatar'\" [src]=\"item[itemSrc]\" [alt]=\"item[itemSrc]\" class=\"circle\">\n                  <span class=\"title\">{{item[itemTitle]}}</span>\n                  <p>{{item[itemDesc]}}</p>          \n                  <!--<a *ngIf=\"design=='avatar' || design=='secundary'\" [routerLink]=\"item[itemLink]\" class=\"secondary-content\"><i class=\"material-icons\">{{item[itemIcon]}}</i></a>-->\n                </li>\n                <li *ngIf=\"itemsHide.length == 0\" class=\"collection-item collection-item-empty {{design=='avatar' ? \n                'avatar'\n                 : ''}}\">{{emptyMessage}}</li>\n              </ul>\n              <div class=\"col l12 s 12 m12\" *ngIf=\"design=='blocks'\">\n                <div class=\"row\">\n                    <div class=\"col s12 m4 l3 xl3 block\" draggable (onDragEnd)=\"dragEnd(item)\" *ngFor=\"let item of items\" \n                    [dragData]=\"{'item': item, 'instance': this}\" [dragScope]=\"item.dragScope\" [hidden]=\"!item.drag_visible\">\n                        <div class=\"card-panel card-blocks grey darken-4\">\n                          <span class=\"white-text\">\n                            <p class=\"icon\"><i class=\"material-icons\">{{item[itemIcon]}}</i></p>\n                            <p>{{item[itemTitle]}}</p>\n                          </span>\n                        </div>\n                    </div>\n                </div>\n              </div>\n            </div>\n        </div>\n      </div>\n    ",
                styles: ["\n        .block {\n            padding: 1px;\n        }\n        .card-blocks {\n            /*display:inline-block;*/\n            height: 150px;\n            padding: 10px;\n            margin: 1px;   \n            -webkit-transition: all 200ms ease-in;\n            -webkit-transform: scale(1); \n            -ms-transition: all 200ms ease-in;\n            -ms-transform: scale(1); \n            -moz-transition: all 200ms ease-in;\n            -moz-transform: scale(1);\n            transition: all 200ms ease-in;\n            transform: scale(1);  \n        }\n        \n        .card-blocks:hover {\n            box-shadow: 0px 0px 40px #000000;\n            z-index: 1965;\n            -webkit-transition: all 200ms ease-in;\n            -webkit-transform: scale(1.5);\n            -ms-transition: all 200ms ease-in;\n            -ms-transform: scale(1.5);   \n            -moz-transition: all 200ms ease-in;\n            -moz-transform: scale(1.5);\n            transition: all 200ms ease-in;\n            transform: scale(1.05);            \n        }\n        \n        .card-blocks p.icon {\n            text-align: center;\n            line-height: 50px;\n        }\n        \n        .card-blocks p.icon i {\n            font-size: 2.6rem;\n        }\n        \n        .dragDisabled{\n            pointer-events: none;\n            opacity: 0.4;   \n        }\n    "],
                host: {
                    '[class]': 'columns',
                    '[ngClass]': "{'dragDisabled': disabled}"
                },
                providers: [abstract_ngmodel_1.MakeProvider(DragComponent)]
            },] },
];
/** @nocollapse */
DragComponent.ctorParameters = function () { return [
    { type: req_http_service_1.ReqHttpService, },
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
]; };
DragComponent.propDecorators = {
    'securityId': [{ type: core_1.Input },],
    'id': [{ type: core_1.Input },],
    'title': [{ type: core_1.Input },],
    'emptyMessage': [{ type: core_1.Input },],
    'textdrag': [{ type: core_1.Input },],
    'keepItems': [{ type: core_1.Input },],
    'design': [{ type: core_1.Input },],
    'itemSrc': [{ type: core_1.Input },],
    'itemLink': [{ type: core_1.Input },],
    'itemIcon': [{ type: core_1.Input },],
    'itemTitle': [{ type: core_1.Input },],
    'itemDesc': [{ type: core_1.Input },],
    'reqIndex': [{ type: core_1.Input },],
    'itemDisable': [{ type: core_1.Input },],
    'dropScope': [{ type: core_1.Input },],
    'dragScope': [{ type: core_1.Input },],
    'disabled': [{ type: core_1.Input },],
    'dataSource': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.DragComponent = DragComponent;
