"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var DropComponent = (function (_super) {
    __extends(DropComponent, _super);
    function DropComponent(_sharedService, _translateService, _http) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._droppedItems = [];
        _this.items = [];
        _this.instanceDrag = [];
        _this.callDrop = new core_1.EventEmitter();
        _this.callBackRemove = new core_1.EventEmitter();
        _this.isDropped = false;
        _this.securityId = '';
        _this.id = '';
        _this.title = '';
        _this.emptyMessage = 'Vazio';
        _this.keepItems = false;
        _this._design = 'simple';
        _this.itemSrc = 'assets';
        _this.itemLink = 'principal';
        _this.itemIcon = 'grade';
        _this.itemTitle = 'title';
        _this.itemDesc = 'title';
        _this.dropScope = ['drop1'];
        _this.dropEnabled = true;
        _this._columns = 'col l12 s12 m12';
        return _this;
    }
    Object.defineProperty(DropComponent.prototype, "droppedItems", {
        get: function () {
            return this._droppedItems;
        },
        set: function (val) {
            this._droppedItems = val;
            // this.value = this._droppedItems;
        },
        enumerable: true,
        configurable: true
    });
    ;
    ;
    Object.defineProperty(DropComponent.prototype, "design", {
        get: function () {
            return this._design;
        },
        set: function (val) {
            if (val == 'avatar' || val == 'blocks') {
                this._design = val;
            }
            else {
                this._design = 'simple';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DropComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12";
        },
        enumerable: true,
        configurable: true
    });
    DropComponent.prototype.removeIndexes = function (array) {
        var newValue = [];
        array.forEach(function (item) {
            var keys = Object.keys(item);
            var object = {};
            keys.forEach(function (key) {
                if (key != 'dragScope' && key != 'index' && key != 'drag_visible') {
                    object[key] = item[key];
                }
            });
            newValue.push(object);
        });
        return newValue;
    };
    DropComponent.prototype.dragEnd = function (e, instanceDrag) {
        var _this = this;
        var items = instanceDrag['instance']['items'];
        items.forEach(function (item) {
            if (JSON.stringify(item) == JSON.stringify(e)) {
                instanceDrag['instance']['items'][e['index']]['drag_visible'] = true;
            }
        });
        instanceDrag['instance'].itemsHide = instanceDrag['instance'].items.filter(function (itm) { return (itm['drag_visible']); });
        this.droppedItems.forEach(function (item, index) {
            if (JSON.stringify(item) == JSON.stringify(e)) {
                _this.droppedItems.splice(index, 1);
                _this.instanceDrag.splice(index, 1);
            }
        });
        this.value = this.droppedItems;
    };
    DropComponent.prototype.onItemDrop = function (e) {
        // this.callDrop.emit({'dropItem': e, 'dropped': true});
        this.isDropped = true;
        var element = e;
        if (this.droppedItems.length > 0) {
            var newItem = this.droppedItems.filter(function (item) { return JSON.stringify(item) == JSON.stringify(element['dragData']['item']); });
            if (newItem.length == 0) {
                this.droppedItems.push(element['dragData']['item']);
                this.instanceDrag.push(element['dragData']);
            }
        }
        else {
            this.droppedItems.push(element['dragData']['item']);
            this.instanceDrag.push(element['dragData']);
        }
        if (e['dragData']['instance']) {
            if (!e['dragData']['instance']['keepItems']) {
                e['dragData']['instance'].items[e['dragData']['item']['index']].drag_visible = false;
                e['dragData']['instance'].itemsHide = e['dragData']['instance'].items.filter(function (itm) { return (itm['drag_visible']); });
            }
        }
        this.value = this.removeIndexes(this.droppedItems);
    };
    DropComponent.prototype.removeItem = function ($item) {
        this.callBackRemove.emit($item);
    };
    DropComponent.prototype.ngOnInit = function () {
        this.validar(this.securityId);
    };
    DropComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.onChangeValue.subscribe(function (val) {
            if (typeof val === 'object') {
                if (val.length === 0) {
                    if (_this.instanceDrag.length > 0) {
                        _this.instanceDrag.forEach(function (drag) {
                            if (drag['instance'].items.length > 0) {
                                drag['instance'].items.forEach(function (item, index) {
                                    item['drag_visible'] = true;
                                });
                                drag['instance'].itemsHide = drag['instance'].items.filter(function (itm) { return (itm['drag_visible']); });
                            }
                        });
                    }
                    _this.droppedItems = [];
                }
            }
        });
    };
    return DropComponent;
}(abstract_ngmodel_1.AbstractNgModel));
DropComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-drop',
                template: "\n      <div class=\"card\" droppable (onDrop)=\"onItemDrop($event)\" [dropScope]=\"dropScope\" [dropEnabled]=\"dropEnabled\">\n        <div class=\"card-content\">\n            <span class=\"card-title\" *ngIf=\"title != ''\">{{title}}</span>\n            <div class=\"content-drag-drop\">\n              <ul class=\"collection\" *ngIf=\"design=='avatar' || design=='simple'\">\n                  <li draggable *ngFor=\"let item of droppedItems; index as i\" [dragData]=\"{item: item}\" [dragScope]=\"item.dragScope\" (onDragEnd)=\"dragEnd(item, instanceDrag[i])\"\n                  class=\"collection-item {{design=='avatar' ? 'avatar' : ''}} {{item[itemDisable] ? '' : 'li-no-selection' }}\">\n                    <img *ngIf=\"design=='avatar'\" [src]=\"item[itemSrc]\" [alt]=\"item[itemSrc]\" class=\"circle\">\n                    <span class=\"title\">{{item[itemTitle]}}</span>\n                    <p>{{item[itemDesc]}}</p>               \n                    <!--<a *ngIf=\"design=='avatar' || design=='secundary'\" [routerLink]=\"item[itemLink]\" class=\"secondary-content\"><i class=\"material-icons\">{{item[itemIcon]}}</i></a>-->\n                  </li>\n                  <li *ngIf=\"droppedItems.length == 0\" class=\"collection-item collection-item-empty {{design=='avatar' ? 'avatar' : ''}}\">{{emptyMessage}}</li>\n              </ul>\n              <div class=\"col l12 s 12 m12\" *ngIf=\"design=='blocks'\">\n                <div class=\"row\">\n                    <div class=\"col s12 m4 l3 xl3 block\" draggable *ngFor=\"let item of droppedItems; index as i\" [dragData]=\"{item: item}\" \n                    [dragScope]=\"item.dragScope\" (onDragEnd)=\"dragEnd(item, instanceDrag[i])\">\n                        <div class=\"card-panel card-blocks grey darken-4\">\n                          <span class=\"white-text\">\n                            <p class=\"icon\"><i class=\"material-icons\">{{item[itemIcon]}}</i></p>\n                            <p>{{item[itemTitle]}}</p>\n                          </span>\n                        </div>\n                    </div>\n                </div>\n              </div>\n            </div>\n        </div>\n      </div>\n    ",
                styles: ["\n        .block {\n            padding: 1px;\n        }\n        .card-blocks {\n            /*display:inline-block;*/\n            height: 150px;\n            padding: 10px;\n            margin: 1px;   \n            -webkit-transition: all 200ms ease-in;\n            -webkit-transform: scale(1); \n            -ms-transition: all 200ms ease-in;\n            -ms-transform: scale(1); \n            -moz-transition: all 200ms ease-in;\n            -moz-transform: scale(1);\n            transition: all 200ms ease-in;\n            transform: scale(1);  \n        }\n        \n        .card-blocks:hover {\n            box-shadow: 0px 0px 40px #000000;\n            z-index: 1965;\n            -webkit-transition: all 200ms ease-in;\n            -webkit-transform: scale(1.5);\n            -ms-transition: all 200ms ease-in;\n            -ms-transform: scale(1.5);   \n            -moz-transition: all 200ms ease-in;\n            -moz-transform: scale(1.5);\n            transition: all 200ms ease-in;\n            transform: scale(1.05);            \n        }\n        \n        .card-blocks p.icon {\n            text-align: center;\n            line-height: 50px;\n        }\n        \n        .card-blocks p.icon i {\n            font-size: 2.6rem;\n        }\n    "],
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(DropComponent)]
            },] },
];
/** @nocollapse */
DropComponent.ctorParameters = function () { return [
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
]; };
DropComponent.propDecorators = {
    'securityId': [{ type: core_1.Input },],
    'id': [{ type: core_1.Input },],
    'title': [{ type: core_1.Input },],
    'emptyMessage': [{ type: core_1.Input },],
    'keepItems': [{ type: core_1.Input },],
    'design': [{ type: core_1.Input },],
    'itemSrc': [{ type: core_1.Input },],
    'itemLink': [{ type: core_1.Input },],
    'itemIcon': [{ type: core_1.Input },],
    'itemTitle': [{ type: core_1.Input },],
    'itemDesc': [{ type: core_1.Input },],
    'dropScope': [{ type: core_1.Input },],
    'dropEnabled': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.DropComponent = DropComponent;
