"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var notification_component_1 = require("../notification/notification.component");
var req_http_service_1 = require("../../services/req-http.service");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var FiltersComponent = (function () {
    function FiltersComponent(_reqHttpService, _sharedService, _translateService, _http) {
        this._reqHttpService = _reqHttpService;
        this._sharedService = _sharedService;
        this._translateService = _translateService;
        this._http = _http;
        this.entity = '';
        this.buttonExport = false;
        this.onFilter = '';
        this.onSelectFilter = '';
        this.searchSaved = false;
        this.grid = true;
        this.type = 'Filtro';
        this._onFilter = new core_1.EventEmitter();
        this._onSelectFilter = new core_1.EventEmitter();
        this.filterModel = [];
        this._columns = 'col l12 s12 m12 z-depth-1';
        this.selectedFilter = false;
        this.filtroTabela = [];
        this.crudLayoutGrid = [];
        this._showHideParameters = false;
        this.setGrid = [];
        this._filterModel = [];
        this.showParameters = {
            icon: 'keyboard_arrow_left'
        };
        this.url = '';
    }
    Object.defineProperty(FiltersComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12 z-depth-1";
        },
        enumerable: true,
        configurable: true
    });
    FiltersComponent.prototype.showHideParameters = function () {
        this._showHideParameters = !this._showHideParameters;
        if (this._showHideParameters) {
            this.showParameters.icon = 'keyboard_arrow_right';
            $(this.parameters.nativeElement).addClass('l1').removeClass('l4');
            $(this.content.nativeElement).addClass('l11').removeClass('l8');
        }
        else {
            this.showParameters.icon = 'keyboard_arrow_left';
            $(this.parameters.nativeElement).addClass('l4').removeClass('l1');
            $(this.content.nativeElement).addClass('l8').removeClass('l11');
        }
    };
    FiltersComponent.prototype.exportExcell = function () {
        var _this = this;
        this._reqHttpService.xhrDownload("/sabium/api/filtro/runner/export", this.retornoParametros['parameters']).subscribe(function (ret) {
            var file = new Blob([ret], { type: 'application/zip' });
            saveAs(file, _this.entity + ".zip");
        });
    };
    FiltersComponent.prototype.getFiltroTabela = function () {
        var _this = this;
        this._reqHttpService.xhrGet("/sabium/api/filtro/tabela/" + this.entity).subscribe(function (ret) {
            _this.filtroTabela = ret.res['data'];
        });
        this.filtroTabela = [{
                "codigo": "PRODUTO1",
                "nome": "Produtos por nome",
                "sql": "select p.id,\n       p.codigo,\n       p.descricao,\n       u.descricao unidade,\n       m.descricao marca,\n       d.descricao departamento\nfrom produto p\njoin unidade u on (p.unidade_id = u.id)\njoin marca   m on (p.marca_id = m.id)\njoin departamento d on (p.departamento_id = d.id)\nwhere p.descricao like :produto",
                "versao": "1.0.0",
                "entrada": [
                    {
                        "tipo": "STRING",
                        "nome": "produto",
                        "rotulo": "produto",
                        "obrigatorio": true,
                        "valor_padrao": "CADEIRA%"
                    }
                ],
                "saida": [
                    {
                        "nome": "codigo",
                        "rotulo": "Codigo",
                        "tipo": "STRING"
                    },
                    {
                        "nome": "departamento",
                        "rotulo": "Departamento",
                        "tipo": "STRING"
                    },
                    {
                        "nome": "descricao",
                        "rotulo": "Produto",
                        "tipo": "STRING"
                    },
                    {
                        "nome": "id",
                        "rotulo": "Identificador",
                        "tipo": "INTEIRO"
                    },
                    {
                        "nome": "marca",
                        "rotulo": "Marca",
                        "tipo": "STRING"
                    },
                    {
                        "nome": "unidade",
                        "rotulo": "Unidade",
                        "tipo": "STRING"
                    }
                ],
                "filtro_gerenciado_por": "SABIUM",
                "versao_corrente": true,
                "usuario_criacao": null,
                "data_criacao": null,
                "numero_registro_pagina": null
            }];
        if (this.searchSaved) {
            this._reqHttpService.xhrGet("/sabium-gerenciador/pesquisa/tabela/" + this.entity).subscribe(function (ret) {
                _this.crudLayoutGrid = ret.res;
            });
        }
    };
    FiltersComponent.prototype.retornoParametro = function (retorno) {
        retorno['parameters']['codigo'] = this._filterCod;
        this.retornoParametros = retorno;
    };
    FiltersComponent.prototype.executarFiltro = function () {
        var _this = this;
        this._onFilter.emit(this.retornoParametros['parameters']);
        if (this.grid) {
            var notification_1 = new notification_component_1.NotificationComponent();
            this._reqHttpService.xhrPost("/sabium/api/filtro/runner/", this.retornoParametros['parameters']).subscribe(function (ret) {
                _this.setGrid = [
                    {
                        'name': 'Paulo',
                        'sobrenone': 'Modesto',
                        'idade': '18'
                    }
                ];
            }, function (err) {
                notification_1.show("Erro na Chamada do Servi\u00E7o (#" + err.res.status + " - " + err.res.statusText + ")");
            });
        }
        this.setGrid = [
            {
                'name': 'Paulo',
                'sobrenone': 'Modesto',
                'idade': '18'
            }
        ];
    };
    FiltersComponent.prototype.selectSearch = function (search) {
        console.log(search);
    };
    FiltersComponent.prototype.selectFilter = function (event) {
        this.dataSource = event.entrada;
        this._onSelectFilter.emit(event);
        if (this.onSelectFilter != '') {
            window[this.onSelectFilter](event);
        }
        this.url = event.url;
        this.selectedFilter = true;
        this._filterCod = event.codigo;
    };
    FiltersComponent.prototype.ngAfterViewInit = function () {
    };
    FiltersComponent.prototype.ngOnInit = function () {
        this.getFiltroTabela();
    };
    return FiltersComponent;
}());
FiltersComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-filter',
                template: "\n        <div #parameters class=\"col s12 m4 l4\"> \n            <sbm-button design=\"floating\" [icon]=\"showParameters.icon\" class=\"left btn-show-hide\" (_onClick)=\"showHideParameters()\"></sbm-button>\n        \n            <sbm-accordion *ngIf=\"searchSaved; else filterSimple\"  columns=\"10\" [hidden]=\"_showHideParameters\">\n                <sbm-accordion-group icon=\"&#xE8B6;\" index=\"layouts\" label='Pesquisas Salvas'>\n                    <div class=\"row\">\n                        <div class=\"search-saved\">\n                            <div class=\"collection\" *ngIf=\"crudLayoutGrid.length > 0; else elseBlock\">\n                                <a *ngFor=\"let layout of crudLayoutGrid\" (click)=\"selectSearch(layout)\" class=\"collection-item\">{{layout['nome']}}</a>\n                            </div>\n                            <ng-template #elseBlock>\n                                <div class=\"collection\">\n                                    <a class=\"collection-item disabled\" [ngStyle]=\"{'pointer-events': 'none', 'opacity': '0.8'}\">Vazio</a>\n                                </div>\n                            </ng-template> \n                        </div>\n                    </div>\n                </sbm-accordion-group>\n                <sbm-accordion-group icon=\"&#xE152;\" index=\"filters\" label='Filtros' [active]=\"true\">\n                    <div class=\"row\">\n                        <sbm-select securityId=\"campo01\" id='campo13' [dataSource]='filtroTabela'\n                        label='Selecione um filtro' [text]=\"['nome']\" [(ngModel)]=\"filterModel\"\n                        (_onClick)='selectFilter($event)'></sbm-select>\n                        <div *ngIf='selectedFilter'>\n                            <sbm-parameters [dataSource]='dataSource' (onSave)='retornoParametro($event)'></sbm-parameters>\n                            <div class=\"col l12 s12 m12 xl12\">\n                                <sbm-button css=\"right\" design=\"floating\" color=\"black-text grey darken-2\" (_onClick)=\"executarFiltro()\" title=\"Executar\" icon=\"&#xE8B6;\"></sbm-button>\n                                <sbm-button *ngIf=\"buttonExport\" (_onClick)=\"exportExcell()\" css=\"right\" design=\"floating\" color=\"black-text grey darken-2\" css='hide-on-med-and-down' title=\"Exportar Excel\" icon=\"&#xE2C4;\"></sbm-button>\n                            </div>\n                        </div>\n                    </div>\n                </sbm-accordion-group>\n            </sbm-accordion>\n            <ng-template #filterSimple>\n                <div class=\"col l10 m10 s10\" [hidden]=\"_showHideParameters\">\n                    <div class=\"row\">\n                        <sbm-select securityId=\"campo01\" id='campo13' [dataSource]='filtroTabela'\n                        label='Selecione um filtro' [text]=\"['nome']\" [(ngModel)]=\"filterModel\"\n                        (_onClick)='selectFilter($event)'></sbm-select>\n                        <div *ngIf='selectedFilter'>\n                            <sbm-parameters [dataSource]='dataSource' (onSave)='retornoParametro($event)'></sbm-parameters>\n                            <div class=\"col l12 s12 m12 xl12\">\n                                <sbm-button css=\"right\" design=\"floating\" color=\"black-text grey darken-2\" (_onClick)=\"executarFiltro()\" title=\"Executar\" icon=\"&#xE8B6;\"></sbm-button>\n                                <sbm-button *ngIf=\"buttonExport\" (_onClick)=\"exportExcell()\" css=\"right\" design=\"floating\" color=\"black-text grey darken-2\" css='hide-on-med-and-down' title=\"Exportar Excel\" icon=\"&#xE2C4;\"></sbm-button>\n                            </div>\n                        </div>\n                    </div>\n                </div>\n            </ng-template> \n        </div>\n        <div #content class=\"col s12 m8 l8\">\n            <dx-data-grid \n                *ngIf=\"grid; else ngContent\"\n                #gridResultCrud \n                style=\"width:100%;height: 500px\" \n                id=\"gridContainer\"\n                [dataSource]=\"setGrid\"\n                [allowColumnReordering]=\"false\"\n                [allowColumnResizing]=\"true\"\n                [showRowLines]=\"true\"\n                [showBorders]=\"true\"\n                [rowAlternationEnabled]=\"true\"\n                [columnAutoWidth]=\"false\"\n                noDataText=\"Filtre para ver os registros\"\n                [searchPanel]='{\n                    visible: true,\n                    width: 240,\n                    placeholder: \"Procurar...\"\n                }'\n                [paging]='{\n                    pageSize: 10\n                }'\n                [groupPanel]='{\n                    visible: true,\n                    emptyPanelText: \"Arraste uma coluna aqui para agrupar\"\n                }'\n                [selection]='{\n                    de: \"multiple\"\n                }' \n            >\n                <dxo-export [enabled]=\"false\" fileName=\"{{entity}}\" [allowExportSelectedData]=\"true\"\n                            [texts]=\"{'exportAll': 'Exportar Tudo', 'exportSelectedRows': 'Exportar selecionados', 'exportTo': 'Exportar excel'}\"></dxo-export>\n                <dxo-scrolling mode=\"virtual\"></dxo-scrolling>\n                <dxo-header-filter [visible]=\"true\"></dxo-header-filter>\n                <dxo-filter-row [visible]=\"true\"></dxo-filter-row>\n                <!--dxi-column *ngFor=\"let item of colunas\" [dataField]=\"item.dataField\" [caption]=\"item.caption\" [formItem]=\"item.formItem\"\n                            [visible]=\"true\"></dxi-column-->\n                <dxo-summary>\n                    <dxi-group-item\n                            summaryType=\"count\"\n                            displayFormat=\"{0} registros\">\n                    </dxi-group-item>\n                </dxo-summary>\n            </dx-data-grid>\n\n            <ng-template #ngContent>\n                <ng-content></ng-content>\n            </ng-template> \n        </div>\n    ",
                styles: ["\n        .btn-show-hide {\n            margin-top: 0;\n        }\n        sbm-accordion {\n            /*margin: 0 15px !important;*/\n        }\n    "],
                host: {
                    '[class]': 'columns',
                },
            },] },
];
/** @nocollapse */
FiltersComponent.ctorParameters = function () { return [
    { type: req_http_service_1.ReqHttpService, },
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
]; };
FiltersComponent.propDecorators = {
    'parameters': [{ type: core_1.ViewChild, args: ['parameters',] },],
    'content': [{ type: core_1.ViewChild, args: ['content',] },],
    'entity': [{ type: core_1.Input },],
    'buttonExport': [{ type: core_1.Input, args: ['export',] },],
    'onFilter': [{ type: core_1.Input, args: ['onfilter',] },],
    'onSelectFilter': [{ type: core_1.Input, args: ['onselectfilter',] },],
    'searchSaved': [{ type: core_1.Input, args: ['searchsaved',] },],
    'grid': [{ type: core_1.Input, args: ['grid',] },],
    'type': [{ type: core_1.Input, args: ['type',] },],
    '_onFilter': [{ type: core_1.Output },],
    '_onSelectFilter': [{ type: core_1.Output },],
    'filterModel': [{ type: core_1.Input, args: ['filtermodel',] },],
    'columns': [{ type: core_1.Input },],
};
exports.FiltersComponent = FiltersComponent;
