"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var req_http_service_1 = require("../../services/req-http.service");
var abstractFormComponents_1 = require("./abstractFormComponents");
var FormComponent = (function (_super) {
    __extends(FormComponent, _super);
    function FormComponent(_reqHttpService) {
        var _this = _super.call(this) || this;
        _this._reqHttpService = _reqHttpService;
        _this.submit = '';
        _this.reqReturn = '';
        _this.method = null;
        _this.service = null;
        _this.isArray = true;
        _this.valign = '';
        _this.halign = '';
        _this._submit = new core_1.EventEmitter();
        _this._reqReturn = new core_1.EventEmitter();
        _this.noErrosForm = true;
        return _this;
    }
    FormComponent.prototype.submitForm = function ($data) {
        _super.prototype.addFormControls.call(this, $data);
        // console.log(this.inputTextComp)
        if ($data.valid) {
            this._submit.emit(_super.prototype.getObject.call(this));
            if (this.submit != '') {
                window[this.submit](_super.prototype.getObject.call(this));
            }
            if (this.method && this.service) {
                this.reqSend($data.value);
            }
        }
    };
    FormComponent.prototype.reqSend = function (data) {
        var _this = this;
        if (this.method.toUpperCase() == 'POST') {
            this._reqHttpService.xhrPost(this.service, (this.isArray ? new Array(data) : data)).subscribe(function (ret) {
                _this._reqReturn.emit(ret);
            }, function (err) {
                _this._reqReturn.emit(err);
            });
        }
        else if (this.method.toUpperCase() == 'PUT') {
            this._reqHttpService.xhrPut(this.service, (this.isArray ? new Array(data) : data)).subscribe(function (ret) {
                _this._reqReturn.emit(ret);
            }, function (err) {
                _this._reqReturn.emit(err);
            });
        }
    };
    FormComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            $(_this.crudForm.nativeElement).children().each(function (index, element) {
                $(element).addClass(_this.halign);
            });
            // console.log(this.inputTextComp);
        });
    };
    FormComponent.prototype.ngOnDestroy = function () {
        // this.FormSubscription.unsubscribe();
    };
    return FormComponent;
}(abstractFormComponents_1.AbstractFormComponents));
FormComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-form',
                template: "\n        <form #crudForm #f='ngForm' (ngSubmit)=\"submitForm(f)\">\n            <ng-content></ng-content>\n        </form>\n    "
            },] },
];
/** @nocollapse */
FormComponent.ctorParameters = function () { return [
    { type: req_http_service_1.ReqHttpService, },
]; };
FormComponent.propDecorators = {
    'crudForm': [{ type: core_1.ViewChild, args: ['f',] },],
    'submit': [{ type: core_1.Input },],
    'reqReturn': [{ type: core_1.Input, args: ['reqreturn',] },],
    'method': [{ type: core_1.Input },],
    'service': [{ type: core_1.Input },],
    'isArray': [{ type: core_1.Input },],
    'valign': [{ type: core_1.Input },],
    'halign': [{ type: core_1.Input },],
    '_submit': [{ type: core_1.Output },],
    '_reqReturn': [{ type: core_1.Output },],
};
exports.FormComponent = FormComponent;
