"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var sharedService_1 = require("../../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var req_http_service_1 = require("../../../services/req-http.service");
var PieComponent = (function () {
    function PieComponent(_el, _sharedService, _translateService, reqHttp) {
        this._el = _el;
        this._sharedService = _sharedService;
        this._translateService = _translateService;
        this.reqHttp = reqHttp;
        this._dataSource = [];
        this.argumentField = 'arg';
        this.valueField = 'value';
        this.width = '100%';
        this.height = 400;
        this.export = true;
        this.texts = true;
        this.indexData = 'data';
        this.onClick = '';
        this.onLegentClick = '';
        this._onClick = new core_1.EventEmitter();
        this._onLegentClick = new core_1.EventEmitter();
        this._legendsOrientation = 'vertical';
        this._type = 'pie';
        this._label = '';
        this._columns = 'col l12 m12 s12';
        sbmGraphPieComponent.push(this);
    }
    Object.defineProperty(PieComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (val) {
            if (typeof val == 'object') {
                this._dataSource = val;
            }
            else {
                this.reqService(val);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieComponent.prototype, "legendsOrientation", {
        get: function () {
            return this._legendsOrientation;
        },
        set: function (val) {
            if (val == 'horizontal' || val == 'vertical') {
                this._legendsOrientation = val;
            }
            else {
                this._legendsOrientation = 'vertical';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieComponent.prototype, "type", {
        get: function () {
            return this._type;
        },
        set: function (val) {
            if (val == 'pie' || val == 'donut') {
                this._type = val;
            }
            else {
                this._type = 'pie';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " m12 s12";
        },
        enumerable: true,
        configurable: true
    });
    PieComponent.prototype.reqService = function (url) {
        var _this = this;
        if (url != '') {
            this.reqHttp.xhrGet(url).subscribe(function (ret) {
                if (typeof ret.res[_this.indexData] == 'object') {
                    if (ret.res[_this.indexData].length > 0) {
                        _this.dataSource = ret.res[_this.indexData];
                    }
                }
            });
        }
    };
    PieComponent.prototype.pointClickHandler = function ($event) {
        this._onClick.emit($event);
        this.toggleVisibility($event.target);
        if (this.onClick != '') {
            window[this.onClick]($event);
        }
    };
    PieComponent.prototype.legendClickHandler = function ($event) {
        this._onLegentClick.emit($event);
        var arg = $event.target, item = $event.component.getAllSeries()[0].getPointsByArg(arg)[0];
        this.toggleVisibility(item);
        if (this.onLegentClick != '') {
            window[this.onLegentClick]($event);
        }
    };
    PieComponent.prototype.toggleVisibility = function (item) {
        console.log(item);
        if (item.isVisible()) {
            item.hide();
        }
        else {
            item.show();
        }
    };
    PieComponent.prototype.customizeLabel = function (arg) {
        return arg.valueText + " (" + arg.percentText + ")";
    };
    PieComponent.prototype.ngOnInit = function () {
    };
    PieComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            _this.pie.instance.render();
            // this.pie.instance.svg()
            // $(this._el.nativeElement).find('.dxc.dxc-chart').attr('width','1300');
            // $(this._el.nativeElement).find('.dxc.dxc-chart').find('rect').attr('width','auto');
        });
    };
    return PieComponent;
}());
PieComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-pie-chart',
                template: "\n        <dx-pie-chart\n            #pie\n            [type]=\"type\"\n            [title]=\"_label\"\n            palette=\"default\"\n            [dataSource]=\"dataSource\"\n            (onPointClick)=\"pointClickHandler($event)\"\n            [resolveLabelOverlapping]=\"'shift'\"\n            (onLegendClick)=\"legendClickHandler($event)\">\n            <dxo-legend\n                [orientation]=\"legendsOrientation\"\n                itemTextPosition=\"right\"\n                horizontalAlignment=\"right\"\n                verticalAlignment=\"bottom\"></dxo-legend>\n            <dxi-series\n                [argumentField]=\"argumentField\"\n                [valueField]=\"valueField\">\n                <dxo-label [visible]=\"true\"\n                [customizeText]=\"customizeLabel\">\n                    <dxo-connector\n                        [visible]=\"texts\"\n                        [width]=\"1\"></dxo-connector>\n                </dxo-label>\n            </dxi-series>\n            <dxo-size width=\"100%\" [height]=\"height\"></dxo-size>\n            <dxo-export [enabled]=\"export\"></dxo-export>\n        </dx-pie-chart>\n    ",
                host: {
                    '[class]': 'columns'
                }
            },] },
];
/** @nocollapse */
PieComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
    { type: req_http_service_1.ReqHttpService, },
]; };
PieComponent.propDecorators = {
    'pie': [{ type: core_1.ViewChild, args: ['pie',] },],
    'dataSource': [{ type: core_1.Input },],
    'argumentField': [{ type: core_1.Input },],
    'valueField': [{ type: core_1.Input },],
    'width': [{ type: core_1.Input },],
    'height': [{ type: core_1.Input },],
    'export': [{ type: core_1.Input },],
    'texts': [{ type: core_1.Input },],
    'indexData': [{ type: core_1.Input },],
    'onClick': [{ type: core_1.Input },],
    'onLegentClick': [{ type: core_1.Input },],
    '_onClick': [{ type: core_1.Output },],
    '_onLegentClick': [{ type: core_1.Output },],
    'legendsOrientation': [{ type: core_1.Input },],
    'type': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.PieComponent = PieComponent;
