"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var custom_store_1 = require("devextreme/data/custom_store");
require("rxjs/add/operator/toPromise");
var core_2 = require("@ngx-translate/core");
var req_http_service_1 = require("../../services/req-http.service");
var sharedService_1 = require("../../models/sharedService");
var funcoes_component_1 = require("../../models/funcoes.component");
var http_1 = require("@angular/http");
var SbmGridColumn = (function () {
    function SbmGridColumn() {
        this.value = '';
        this.isEntity = false;
        this.entity = '';
        this.entityDisplay = '';
        this.label = '';
        this.dataType = '';
        this.format = '';
        this.width = 200;
        this.area = '';
    }
    return SbmGridColumn;
}());
SbmGridColumn.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-column',
                template: ""
            },] },
];
/** @nocollapse */
SbmGridColumn.ctorParameters = function () { return []; };
SbmGridColumn.propDecorators = {
    'value': [{ type: core_1.Input },],
    'isEntity': [{ type: core_1.Input },],
    'entity': [{ type: core_1.Input },],
    'entityDisplay': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'dataType': [{ type: core_1.Input },],
    'format': [{ type: core_1.Input },],
    'width': [{ type: core_1.Input },],
    'area': [{ type: core_1.Input },],
};
exports.SbmGridColumn = SbmGridColumn;
var GridComponent = (function (_super) {
    __extends(GridComponent, _super);
    function GridComponent(_reqHttpService, _sharedService, _http, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._reqHttpService = _reqHttpService;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._translateService = _translateService;
        _this.id = '';
        _this.securityId = '';
        _this.columnsGrid = [];
        _this.pagination = '5';
        _this.select = 'single';
        _this.mode = 'pagination';
        _this.grouping = false;
        _this.label = '';
        _this.onSelectData = new core_1.EventEmitter();
        _this.gridClick = new core_1.EventEmitter();
        _this._buttonAll = true;
        _this._columns = 'col l12 m12 s12 input-field crud-form-dynamic';
        _this.pagingEnable = true;
        _this.translations = {
            "pageInfo": null,
            "gridCount": null,
            "textGroup": null,
            "loadGrid": null
        };
        _this.setDataSource = function (_data) {
            _this.dxDataSource = _data;
            _this._buttonAll = false;
        };
        sbmGridComponent.push(_this);
        return _this;
    }
    Object.defineProperty(GridComponent.prototype, "dataSource", {
        get: function () {
            return this.__dataSource;
        },
        set: function (val) {
            this.__dataSource = val;
            this.setDataSource(val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12 input-field crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    GridComponent.prototype.isNotBlank = function (value) {
        return funcoes_component_1.FuncoesComponent.isNotBlank(value);
    };
    GridComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomClass = Math.floor((Math.random() * 1000) + 1);
        if (typeof this.dataSource == 'object') {
            this.dxDataSource = this.dataSource;
            this._buttonAll = false;
        }
        else {
            var me_1 = this;
            this.source = new custom_store_1.default({
                load: function (loadOptions) {
                    return me_1.reqService(loadOptions);
                }
            });
            this.dxDataSource = { store: this.source, searchValue: this.dataSource, requireTotalCount: false };
        }
    };
    GridComponent.prototype.refresh = function () {
        this.dataGrid.instance.refresh();
    };
    GridComponent.prototype.totalColumnGrid = function ($data) {
    };
    GridComponent.prototype.onContextMenuPreparing = function ($event) {
        var me = this;
        if ($event.target == "header") {
            /*$event.items.push({
                text: "Total",
                onItemClick: (function(params) {
                    me.totalColumnGrid(params);
                })
            });*/
            // console.log($event.row.data);
            // $event.component.getTotalSummaryValue([$event.row.rowIndex], true) // this code will select a row
        }
        if ($event.target == "content") {
            // $event.items = [];
            //
            // $event.items.push({text: "Teste"});
            // console.log($event.row.data);
            // $event.component.selectRows([$event.row.data], true) // this code will select a row
        }
    };
    GridComponent.prototype.getAll = function () {
        var _this = this;
        var deferred = $.Deferred();
        this._reqHttpService.xhrGet(this.dataSource).subscribe(function (ret) {
            if (ret.success) {
                deferred.resolve({
                    data: ret.res.data,
                    totalCount: ret.res.size
                });
                _this.dataGrid.dataSource = ret.res.data;
                _this.pagingEnable = false;
                _this.mode = 'infinite';
                $(_this.buttonAll.nativeElement).hide();
                _this.dataGrid.instance.refresh();
            }
            else {
                deferred.reject('Erro ao Carregar os registros');
            }
        });
    };
    GridComponent.prototype.reqService = function ($options, getAll) {
        var _this = this;
        var me = this;
        var deferred = $.Deferred();
        var params = '';
        var url = ($options.searchValue || '');
        if (url.toString().indexOf('?') != -1) {
            params += '&';
        }
        else {
            params += '?';
        }
        var prev = ($options.skip + parseInt(me.pagination)) / parseInt(me.pagination);
        params += 'p=' + (prev || 1);
        params += '&l=' + ($options.take || me.pagination);
        if ($options.sort) {
            params += '&sort=-' + $options.sort[0].selector;
            if ($options.sort[0].desc) {
                params = params.replace('&sort=-', '&sort=');
            }
        }
        if ($options.searchValue) {
            if ($options.filter) {
                params = '';
                if ($options.sort) {
                    params = '?sort=-' + $options.sort[0].selector;
                    if ($options.sort[0].desc) {
                        params = params.replace('?sort=-', '?sort=');
                    }
                }
            }
            this._reqHttpService.xhrGet($options.searchValue + params).subscribe(function (ret) {
                if (ret.success) {
                    deferred.resolve({
                        data: ret.res.data,
                        totalCount: ret.res.size
                    });
                    $(_this.buttonAll.nativeElement).show();
                }
                else {
                    deferred.reject('Erro ao Carregar os registros');
                }
            });
            return deferred.promise();
        }
        else {
            $(this.buttonAll.nativeElement).hide();
            deferred.resolve({
                data: [],
                totalCount: 0
            });
            return deferred.promise();
        }
    };
    GridComponent.prototype.changeGrid = function ($event) {
        if (this.pageIndex !== $event.component.pageIndex()) {
            this.pageIndex = $event.component.pageIndex();
            $event.component.selectRowsByIndexes(0);
        }
    };
    GridComponent.prototype.selectionData = function (event) {
        this.onSelectData.emit(event);
    };
    GridComponent.prototype.edit = function (event) {
        this.gridClick.emit(event);
    };
    return GridComponent;
}(abstract_ngmodel_1.AbstractNgModel));
GridComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-grid',
                template: "\n        <div class=\"col l12 s12 m12\" style=\"position: relative;\">\n            <dx-data-grid\n                style=\"max-height: 400px;\"\n                #dataGrid\n                class=\"sbm-grid\"\n                [dataSource]='dxDataSource'\n                [searchPanel]='{\n                    visible: true,\n                    width: 240,\n                    placeholder: \"Procurar...\"\n                }'\n                [showBorders]='true'\n                [loadPanel]='{\n                    text: translations[\"loadGrid\"]\n                }'\n                (onOptionChanged)='changeGrid($event)'\n                (onSelectionChanged)='selectionData($event)'\n                (onContentReady)=\"changeGrid($event)\"\n                (onContextMenuPreparing)=\"onContextMenuPreparing($event)\"\n            >\n                <dxi-column *ngFor=\"let item of columnsOptions\" [dataField]=\"item.value\" [dataType]=\"item.dataField\" \n                [width]=\"item.width\" [format]=\"item.format\" [caption]=\"item.label\"></dxi-column>\n                <dxo-header-filter [visible]=\"true\"></dxo-header-filter>\n                <dxo-remote-operations\n                    [sorting]=\"true\"\n                    [paging]=\"true\"\n                    [grouping]=\"false\"\n                    [filtering]=\"false\"\n                    [groupPaging]=\"false\">\n                </dxo-remote-operations>\n                <dxo-scrolling *ngIf=\"mode == 'infinite'\" mode=\"virtual\"></dxo-scrolling>\n                <dxo-selection [mode]=\"select\"></dxo-selection>\n                <dxo-group-panel *ngIf=\"mode == 'infinite' || !_buttonAll\" [visible]=\"grouping\" [emptyPanelText]=\"translations['textGroup']\"></dxo-group-panel>\n                <dxo-grouping #expand [autoExpandAll]=\"true\"></dxo-grouping>\n                <dxo-paging *ngIf=\"pagingEnable\" [pageSize]=\"pagination\"></dxo-paging>\n                <dxo-pager\n                    [infoText]=\"translations.pageInfo\"\n                    [showInfo]=\"true\">\n                </dxo-pager>\n                <dxo-summary *ngIf=\"mode == 'infinite'\">\n                    <dxi-total-item\n                        [column]=\"columnsOptions.last.value\"\n                        summaryType=\"count\"\n                        [displayFormat]=\"translations['gridCount']\"\n                        >\n                    </dxi-total-item>\n                </dxo-summary>\n            </dx-data-grid>\n            \n            <span class=\"sbm-grid-buttonGetAll\" [hidden]=\"!_buttonAll\">\n                <a #buttonAll class=\"waves-effect waves-light btn\" (click)=\"getAll()\" style=\"display: none;\">Buscar Tudo</a>\n            </span>\n        </div>\n    ",
                styles: ["\n        .sbm-grid-buttonGetAll {\n            position: absolute;\n            margin-top: -50px;\n        }\n        .sbm-link-all {\n            text-decoration: underline;\n            cursor: pointer;\n        }\n    "],
                host: {
                    '[class]': 'columns'
                }
            },] },
];
/** @nocollapse */
GridComponent.ctorParameters = function () { return [
    { type: req_http_service_1.ReqHttpService, },
    { type: sharedService_1.SharedService, },
    { type: http_1.Http, },
    { type: core_2.TranslateService, },
]; };
GridComponent.propDecorators = {
    'columnsOptions': [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return SbmGridColumn; }),] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'dataSource': [{ type: core_1.Input },],
    'pagination': [{ type: core_1.Input },],
    'select': [{ type: core_1.Input },],
    'mode': [{ type: core_1.Input },],
    'grouping': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'onSelectData': [{ type: core_1.Output },],
    'gridClick': [{ type: core_1.Output },],
    'dataGrid': [{ type: core_1.ViewChild, args: ['dataGrid',] },],
    'buttonAll': [{ type: core_1.ViewChild, args: ['buttonAll',] },],
    'columns': [{ type: core_1.Input },],
};
exports.GridComponent = GridComponent;
