"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/map");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var req_http_service_1 = require("../../../services/req-http.service");
var InputCepComponent = (function (_super) {
    __extends(InputCepComponent, _super);
    function InputCepComponent(_http, _reqHttp, _sharedService, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._http = _http;
        _this._reqHttp = _reqHttp;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this.id = '';
        _this.securityId = '';
        _this.placeholder = 'Informe um valor';
        _this.css = 'sbm-input';
        _this.styleCss = '';
        _this.disabled = false;
        _this.readonly = false;
        _this.notnull = false;
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.onClick = '';
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this._onClick = new core_1.EventEmitter();
        _this._attribute = '';
        _this._columns = 'input-field col l12 m12 s12 sbm-input-cep crud-form-dynamic';
        _this.isNotMasterDetail = true;
        _this.msgError = 'Cep Inválido';
        _this.randomId = '';
        _this.labelWidth = '';
        _this.inputValid = true;
        _this.validationsMsg = {
            require: null,
            zipNotFound: null,
            zipCodeInvalid: null,
        };
        _this._label = '';
        sbmInputCepComponent.push(_this);
        return _this;
    }
    Object.defineProperty(InputCepComponent.prototype, "attribute", {
        get: function () {
            return this._attribute;
        },
        set: function (val) {
            this._attribute = val;
            this.name = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputCepComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputCepComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field suffix col l" + value + " sbm-input-cep m12 s12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    InputCepComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    InputCepComponent.prototype.ngAfterViewInit = function () {
        $(this.inputCep.nativeElement).mask('00.000-000');
        $(this.inputCep.nativeElement).attr('style', this.styleCss);
    };
    InputCepComponent.prototype.itemClicado = function () {
        var _this = this;
        var url = 'http://cep.republicavirtual.com.br/web_cep.php?cep=' + this.value + '&formato=json';
        // this.disabled = true;
        this._http.get(url).map(function (res) { return res.json(); }).subscribe(function (retorno) {
            _this._onClick.emit(retorno);
            if (_this.onClick != '') {
                window[_this.onClick](retorno);
            }
            // this.disabled = false;
        });
    };
    InputCepComponent.prototype.blur = function ($event) {
        this._onBlur.emit($event);
        if (this.onBlur != '') {
            window[this.onBlur]($event);
        }
    };
    InputCepComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    return InputCepComponent;
}(abstract_ngmodel_1.AbstractNgModel));
InputCepComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-input-cep',
                template: "\n        <input \n            #inputCep \n            #component=\"ngModel\" \n            [name]=\"name\"\n            id=\"{{randomId}}\" \n            type=\"text\" \n            class=\"sbm-text-field {{css}}\" \n            [hidden]=\"!exibirComponente\" \n            [style]='styleCss' \n            [disabled]=\"disabled\" \n            [readonly]=\"readonly\"\n            [required]=\"notnull\"\n            (blur)=\"blur($event)\"\n            (keyup)='keyup($event)' \n            [(ngModel)]=\"value\" \n            sbmCep\n        >\n        <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n\n        <span class=\"suffix\">\n            <a class=\"btn btn-floating waves-effect sbm-inputcep-search\"\n\n            [ngClass]=\"{'disabled': disabled}\"\n            (click)='itemClicado()'><i class=\"material-icons\">search</i></a>\n        </span>\n        \n        <span *ngIf=\"!component.valid\" class=\"msgError\">\n            <p class=\"msgError\" *ngIf=\"component['errors']['required'] && component.touched\">\n                Campo Obrigat\u00F3rio\n            </p>\n            <p class=\"msgError\" *ngIf=\"component['errors']['cep'] && component.touched\">\n                Cep inv\u00E1lido\n            </p>\n        </span>\n    ",
                styles: ["\n       .smb-input-cep-busca {\n            color: #383838; \n            right: 10px;\n            top: 20px;\n            cursor: pointer;\n            position: absolute;\n        }\n        .ng-invalid:not(.ng-untouched) {\n            border-bottom: 1px solid #F44336 !important;\n            box-shadow: 0 1px 0 0 #F44336 !important;\n        }\n    "],
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(InputCepComponent)]
            },] },
];
/** @nocollapse */
InputCepComponent.ctorParameters = function () { return [
    { type: http_1.Http, },
    { type: req_http_service_1.ReqHttpService, },
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
]; };
InputCepComponent.propDecorators = {
    'inputCep': [{ type: core_1.ViewChild, args: ['inputCep',] },],
    'component': [{ type: core_1.ViewChild, args: ['component',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input, args: ['securityid',] },],
    'name': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input, args: ['stylecss',] },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'onBlur': [{ type: core_1.Input, args: ['onblur',] },],
    'onKeyup': [{ type: core_1.Input, args: ['onkeyup',] },],
    'onClick': [{ type: core_1.Input, args: ['onclick',] },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    '_onClick': [{ type: core_1.Output },],
    'attribute': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.InputCepComponent = InputCepComponent;
