"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
var InputEmailComponent = (function (_super) {
    __extends(InputEmailComponent, _super);
    function InputEmailComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.placeholder = 'Informe um valor';
        _this.css = 'sbm-input';
        _this.notnull = false;
        _this.styleCss = '';
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.disabled = false;
        _this.readonly = false;
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this._attribute = '';
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this.isNotMasterDetail = true;
        _this.msgError = 'Campo Incorreto';
        _this.randomId = '';
        _this.labelWidth = '';
        _this.inputValid = true;
        _this._label = '';
        sbmInputEmailComponent.push(_this);
        return _this;
    }
    Object.defineProperty(InputEmailComponent.prototype, "attribute", {
        get: function () {
            return this._attribute;
        },
        set: function (val) {
            this._attribute = val;
            this.name = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputEmailComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputEmailComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " m12 s12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    InputEmailComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    InputEmailComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            $(_this.inputEmail.nativeElement).attr('style', _this.styleCss);
        });
    };
    InputEmailComponent.prototype.blur = function (retorno) {
        this._onBlur.emit(retorno);
        if (this.onBlur != '') {
            window[this.onBlur](retorno);
        }
    };
    InputEmailComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    return InputEmailComponent;
}(abstract_ngmodel_1.AbstractNgModel));
InputEmailComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-input-email',
                template: "\n        <input \n        #inputEmail \n        #component=\"ngModel\" \n        id=\"{{randomId}}\" \n        [name]=\"name\" \n        type=\"email\" \n        class=\"sbm-text-field {{css}}\" \n        [hidden]=\"!exibirComponente\" \n        [style]='styleCss' \n        [disabled]=\"disabled\" \n        [readonly]=\"readonly\"\n        [required]=\"notnull\"\n        (keyup)='keyup($event)' \n        (blur)=\"blur($event)\"\n        [(ngModel)]=\"value\" \n        email\n        >\n\n        <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n        \n        <span *ngIf=\"!component.valid\" class=\"msgError\">\n            <p class=\"msgError\" *ngIf=\"component['errors']['required'] && component.touched\">\n                Campo Obrigat\u00F3rio\n            </p>\n            <p class=\"msgError\" *ngIf=\"component['errors']['email'] && component.touched\">\n                Email inv\u00E1lido\n            </p>\n        </span>\n    ",
                styles: ["\n        .ng-invalid:not(.ng-untouched) {\n            border-bottom: 1px solid #F44336 !important;\n            box-shadow: 0 1px 0 0 #F44336 !important;\n        }\n    "],
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(InputEmailComponent)]
            },] },
];
/** @nocollapse */
InputEmailComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
    { type: sharedService_1.SharedService, },
]; };
InputEmailComponent.propDecorators = {
    'inputEmail': [{ type: core_1.ViewChild, args: ['inputEmail',] },],
    'component': [{ type: core_1.ViewChild, args: ['component',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input, args: ['securityid',] },],
    'name': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'styleCss': [{ type: core_1.Input, args: ['stylecss',] },],
    'onBlur': [{ type: core_1.Input, args: ['onblur',] },],
    'onKeyup': [{ type: core_1.Input, args: ['onkeyup',] },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    'attribute': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.InputEmailComponent = InputEmailComponent;
