"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var funcoes_component_1 = require("./../../../models/funcoes.component");
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
var InputNumberComponent = (function (_super) {
    __extends(InputNumberComponent, _super);
    function InputNumberComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.step = '';
        _this.css = 'sbm-input';
        _this.styleCss = '';
        _this.digitAlign = 'right';
        _this.spinButtons = true;
        _this.placeholder = 'Informe Um Valor';
        _this.notnull = false;
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.disabled = false;
        _this.readonly = false;
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this._attribute = '';
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this.isNotMasterDetail = true;
        _this.inputValid = true;
        _this.msgError = 'Campo Incorreto';
        _this.randomId = '';
        _this.dir = 'ltr';
        _this._label = '';
        sbmInputNumberComponent.push(_this);
        return _this;
    }
    Object.defineProperty(InputNumberComponent.prototype, "attribute", {
        get: function () {
            return this._attribute;
        },
        set: function (val) {
            this._attribute = val;
            this.name = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputNumberComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputNumberComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " m12 s12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    InputNumberComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        var value = $(this.inputNumber.nativeElement).val();
        var valueInt = parseInt($event.key);
        if (Number.isNaN(valueInt)) {
            $(this.inputNumber.nativeElement).val(value.replace($event.key, ''));
        }
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
            // sbmExecuteFunctions($event, this._onKeyup);
        }
    };
    InputNumberComponent.prototype.blur = function ($event) {
        this._onBlur.emit($event);
        var value = $event.target.value;
        if (parseInt(value) < this.min) {
            $(this.inputNumber.nativeElement).val(this.min);
        }
        if (parseInt(value) > this.max) {
            $(this.inputNumber.nativeElement).val(this.max);
        }
        if (this.onBlur != '') {
            window[this.onBlur]($event);
        }
    };
    InputNumberComponent.prototype.ngAfterViewInit = function () {
        //add Validator step with setValidators
        this.component.control.setValidators([funcoes_component_1.FuncoesComponent.stepValidation(this.inputNumber.nativeElement)]);
        //add Validator step with setValidators
        var me = this;
        $(this.inputNumber.nativeElement).attr('style', this.styleCss);
        if (this.digitAlign == 'right') {
            $(this.inputNumber.nativeElement).css('text-align', 'right');
            // this.dir = 'ltr';
        }
        else if (this.digitAlign == 'left') {
            $(this.inputNumber.nativeElement).css('text-align', 'left');
            // this.dir = 'rtl';
        }
        else if (this.digitAlign == 'center') {
            $(this.inputNumber.nativeElement).css('text-align', 'center');
            // this.dir = 'ltr';
        }
    };
    InputNumberComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    return InputNumberComponent;
}(abstract_ngmodel_1.AbstractNgModel));
InputNumberComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-input-number',
                template: "\n        <input \n            #inputNumber \n            #component=\"ngModel\" \n            id=\"{{randomId}}\" \n            [name]=\"name\" \n            type=\"number\" \n            class=\"sbm-text-field {{css}}\" \n            [min]=\"min\" \n            [max]=\"max\" \n            [hidden]=\"!exibirComponente\" \n            [style]='styleCss' \n            [dir]=\"dir\" \n            [step]=\"step\" \n            [disabled]=\"disabled\" \n            [readonly]=\"readonly\"\n            [required]=\"notnull\"\n            [ngClass]=\"{'no-spinButtons': spinButtons}\"\n            (blur)=\"blur($event)\"\n            (keyup)='keyup($event)' \n            [(ngModel)]=\"value\" \n        >\n        <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n        \n        <span *ngIf=\"!component.valid\" class=\"msgError\">\n            <p class=\"msgError\" *ngIf=\"component['errors']['required'] && component.touched\">\n                Campo Obrigat\u00F3rio\n            </p>\n            <p class=\"msgError\" *ngIf=\"component['errors']['step'] && component.touched\">\n                {{component['errors']['step']}}\n            </p>\n        </span>\n\n        <span *ngIf=\"!inputValid\" class=\"msgError\">{{msgError}}</span>\n    ",
                styles: ["\n        .ng-invalid:not(.ng-untouched) {\n            border-bottom: 1px solid #F44336 !important;\n            box-shadow: 0 1px 0 0 #F44336 !important;\n        }\n    "],
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(InputNumberComponent)]
            },] },
];
/** @nocollapse */
InputNumberComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
    { type: sharedService_1.SharedService, },
]; };
InputNumberComponent.propDecorators = {
    'inputNumber': [{ type: core_1.ViewChild, args: ['inputNumber',] },],
    'component': [{ type: core_1.ViewChild, args: ['component',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input, args: ['securityid',] },],
    'name': [{ type: core_1.Input },],
    'min': [{ type: core_1.Input },],
    'max': [{ type: core_1.Input },],
    'step': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input, args: ['stylecss',] },],
    'digitAlign': [{ type: core_1.Input, args: ['digitalign',] },],
    'spinButtons': [{ type: core_1.Input, args: ['spinbuttons',] },],
    'placeholder': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'onBlur': [{ type: core_1.Input, args: ['onblur',] },],
    'onKeyup': [{ type: core_1.Input, args: ['onkeyup',] },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    'attribute': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.InputNumberComponent = InputNumberComponent;
