"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
var InputPasswordComponent = (function (_super) {
    __extends(InputPasswordComponent, _super);
    function InputPasswordComponent(_sharedService, _http, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._translateService = _translateService;
        _this.id = '';
        _this.securityId = '';
        _this.placeholder = 'Informe um valor';
        _this.css = 'sbm-input';
        _this.notnull = false;
        _this.maxLength = '';
        _this.minLength = '';
        _this.styleCss = '';
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.disabled = false;
        _this.readonly = false;
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this._attribute = '';
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this.isNotMasterDetail = true;
        _this.inputValid = true;
        _this.msgError = 'Campo Incorreto';
        _this.randomId = '';
        _this.labelWidth = '';
        _this._label = '';
        _this.validationsMsg = {
            require: null,
            minLength: null,
            maxLength: null
        };
        sbmInputPasswordComponent.push(_this);
        return _this;
    }
    Object.defineProperty(InputPasswordComponent.prototype, "attribute", {
        get: function () {
            return this._attribute;
        },
        set: function (val) {
            this._attribute = val;
            this.name = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputPasswordComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputPasswordComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " s12 m12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    InputPasswordComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    InputPasswordComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            $(_this.inputPassword.nativeElement).attr('style', _this.styleCss);
            _this.OnChangeValue = _this.onChangeValue.subscribe(function (ret) {
                Materialize.updateTextFields();
            });
        });
    };
    InputPasswordComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    InputPasswordComponent.prototype.blur = function (retorno) {
        this._onBlur.emit(retorno);
        if (this.onBlur != '') {
            window[this.onBlur](retorno);
        }
    };
    InputPasswordComponent.prototype.ngOnDestroy = function () {
        this.OnChangeValue.unsubscribe();
    };
    return InputPasswordComponent;
}(abstract_ngmodel_1.AbstractNgModel));
InputPasswordComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-input-password',
                template: "\n         <input id=\"{{randomId}}\" \n            #inputPassword \n            #component=\"ngModel\"\n            [name]=\"name\"\n            type=\"password\" \n            class=\"sbm-text-field {{css}}\" \n            [maxlength]=\"maxLength\"  \n            [minlength]=\"minLength\"\n            [hidden]=\"!exibirComponente\" \n            [attr.style]='styleCss'\n            [disabled]=\"disabled\"\n            [readonly]=\"readonly\"\n            (blur)=\"blur($event)\"\n            (keyup)='keyup($event)' \n            [(ngModel)]=\"value\" \n            [required]=\"notnull\"\n          >\n          <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n          \n          <span *ngIf=\"!component.valid\" class=\"msgError\">\n            <p class=\"msgError\" *ngIf=\"component['errors']['required'] && component.touched\">\n                Campo Obrigat\u00F3rio\n            </p>\n            <p class=\"msgError\" *ngIf=\"component['errors']['minlength'] && component.touched\">\n                O Campo deve Conter no m\u00EDnimo {{minLength}}\n            </p> \n            <p class=\"msgError\" *ngIf=\"component['errors']['maxlength'] && component.touched\">\n                O Campo deve Conter no m\u00E1ximo {{maxLength}}\n            </p>\n          </span>\n    ",
                styles: ["\n        .ng-invalid:not(.ng-untouched) {\n            border-bottom: 1px solid #F44336 !important;\n            box-shadow: 0 1px 0 0 #F44336 !important;\n        }\n    "],
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(InputPasswordComponent)]
            },] },
];
/** @nocollapse */
InputPasswordComponent.ctorParameters = function () { return [
    { type: sharedService_1.SharedService, },
    { type: http_1.Http, },
    { type: core_2.TranslateService, },
]; };
InputPasswordComponent.propDecorators = {
    'inputPassword': [{ type: core_1.ViewChild, args: ['inputPassword',] },],
    'component': [{ type: core_1.ViewChild, args: ['component',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input, args: ['securityid',] },],
    'name': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'maxLength': [{ type: core_1.Input, args: ['maxlength',] },],
    'minLength': [{ type: core_1.Input, args: ['minlength',] },],
    'styleCss': [{ type: core_1.Input, args: ['stylecss',] },],
    'onBlur': [{ type: core_1.Input, args: ['onblur',] },],
    'onKeyup': [{ type: core_1.Input, args: ['onkeyup',] },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    'attribute': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.InputPasswordComponent = InputPasswordComponent;
