"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var funcoes_component_1 = require("../../../models/funcoes.component");
var http_1 = require("@angular/http");
var InputTextComponent = (function (_super) {
    __extends(InputTextComponent, _super);
    function InputTextComponent(_el, _http, _sharedService, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._el = _el;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this.id = '';
        _this.securityId = 'securityId';
        _this.placeholder = 'Informe um valor';
        _this.css = 'sbm-input';
        _this.notnull = false;
        _this.maxLength = '';
        _this.minLength = '';
        _this.pattern = '';
        _this.styleCss = '';
        _this.digitText = 'Mm';
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.disabled = false;
        _this.readonly = false;
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this._attribute = '';
        _this._label = '';
        _this._columns = 'input-field col l12 m12 s12';
        _this.inputValid = true;
        _this.msgError = 'Campo Incorreto';
        _this.isNotMasterDetail = true;
        _this.randomId = '';
        _this.validationsMsg = {
            require: null,
            minLength: null,
            maxLength: null,
            pattern: null,
        };
        sbmInputTextComponent.push(_this);
        return _this;
    }
    Object.defineProperty(InputTextComponent.prototype, "attribute", {
        get: function () {
            return this._attribute;
        },
        set: function (val) {
            this._attribute = val;
            this.name = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputTextComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputTextComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " m12 s12";
        },
        enumerable: true,
        configurable: true
    });
    InputTextComponent.prototype.isNotBlank = function (value) {
        return funcoes_component_1.FuncoesComponent.isNotBlank(value);
    };
    InputTextComponent.prototype.regex = function (value) {
        var me = this;
        var SETRegex = function (val) {
            return new RegExp("\\b" + me.pattern + "\\b");
        };
        var regexText = SETRegex(value);
        return regexText.test(value);
    };
    InputTextComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    InputTextComponent.prototype.blur = function (retorno) {
        this._onBlur.emit(retorno);
        if (this.onBlur != '') {
            window[this.onBlur](retorno);
        }
    };
    InputTextComponent.prototype.viewSetAttr = function () {
        var _this = this;
        if (this.maxLength != '') {
            $(this.inputText.nativeElement).attr('data-length', this.maxLength);
            $(this.inputText.nativeElement).characterCounter();
            $(this._el.nativeElement).find('span.character-counter').css({
                'float': 'righ',
                'font-size': '12px',
                'background-color': '#e53935',
                'color': '#fff',
                'margin': '5px',
                'border-radius': '5px',
                'right': '0px',
                'z-index': '9999',
                'height': '18px',
                'position': 'absolute',
            });
        }
        //emit ngModel
        this.SubscriptionComp = this.component.valueChanges.subscribe(function (ret) {
            Materialize.updateTextFields();
        });
        //set Style
        $(this._el.nativeElement).find('input').attr('style', this.styleCss);
        //emiter value and digitText ('M', 'm')
        this.subscriptionValue = this.onChangeValue.subscribe(function (value) {
            if (_this.digitText == 'M') {
                _this.value = value.toUpperCase();
            }
            else if (_this.digitText == 'm') {
                _this.value = value.toLowerCase();
            }
        });
    };
    InputTextComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            _this.viewSetAttr();
        });
    };
    InputTextComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    InputTextComponent.prototype.ngOnDestroy = function () {
        this.subscriptionValue.unsubscribe();
        this.SubscriptionComp.unsubscribe();
    };
    return InputTextComponent;
}(abstract_ngmodel_1.AbstractNgModel));
InputTextComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-input-text',
                template: "      \n          <input\n            #inputText \n            #component=\"ngModel\" \n            id=\"{{randomId}}\" \n            [name]=\"name\"\n            type=\"text\" \n            class=\"sbm-text-field {{css}} curmudgeon\" \n            [maxlength]=\"maxLength\" \n            [minlength]=\"minLength\" \n            [hidden]=\"!exibirComponente\" \n            [pattern]=\"pattern\" \n            [disabled]=\"disabled\" \n            [readonly]=\"readonly\"\n            (keyup)='keyup($event)' \n            (blur)=\"blur($event)\" \n            [(ngModel)]=\"value\" \n            [required]=\"notnull\"\n          >\n          <label class=\"sbm-label truncate\" for=\"{{randomId}}\" [attr.title]=\"_label\">{{_label}}</label>\n          \n          <span *ngIf=\"!component.valid\" class=\"msgError\">\n            <p class=\"msgError\" *ngIf=\"component['errors']['required'] && component.touched\">\n                Campo Obrigat\u00F3rio\n            </p>\n            <p class=\"msgError\" *ngIf=\"component['errors']['pattern'] && component.touched\">\n                Pattern Inv\u00E1lido {{pattern}}\n            </p>\n            <p class=\"msgError\" *ngIf=\"component['errors']['minlength'] && component.touched\">\n                O Campo deve Conter no m\u00EDnimo {{minLength}}\n            </p>\n            <p class=\"msgError\" *ngIf=\"component['errors']['maxlength'] && component.touched\">\n                O Campo deve Conter no m\u00E1ximo {{maxLength}}\n            </p>\n          </span>\n    ",
                host: {
                    '[class]': 'columns',
                },
                styles: ["\n        .ng-invalid:not(.ng-untouched) {\n            border-bottom: 1px solid #F44336 !important;\n            box-shadow: 0 1px 0 0 #F44336 !important;\n        }\n    "],
                providers: [abstract_ngmodel_1.MakeProvider(InputTextComponent)]
            },] },
];
/** @nocollapse */
InputTextComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: http_1.Http, },
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
]; };
InputTextComponent.propDecorators = {
    'inputText': [{ type: core_1.ViewChild, args: ['inputText',] },],
    'component': [{ type: core_1.ViewChild, args: ['component',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input, args: ['securityid',] },],
    'name': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'maxLength': [{ type: core_1.Input, args: ['maxlength',] },],
    'minLength': [{ type: core_1.Input, args: ['minlength',] },],
    'pattern': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input, args: ['stylecss',] },],
    'digitText': [{ type: core_1.Input },],
    'onBlur': [{ type: core_1.Input, args: ['onblur',] },],
    'onKeyup': [{ type: core_1.Input, args: ['onkeyup',] },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    'attribute': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.InputTextComponent = InputTextComponent;
