"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
require("rxjs/add/operator/map");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
//
var MoneyComponent = (function (_super) {
    __extends(MoneyComponent, _super);
    function MoneyComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.securityId = '';
        _this.id = '';
        _this.prefix = 'R$';
        _this.decimal = ',';
        _this.thousands = '.';
        _this.decimalDigits = '2';
        _this.digitAlign = 'right';
        _this.placeholder = 'Digite um valor';
        _this.styleCss = '';
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.css = 'sbm-input';
        _this.notnull = ',';
        _this.disabled = false;
        _this.readonly = false;
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this._attribute = '';
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this.isNotMasterDetail = true;
        _this._options = {};
        _this._valueChecked = true;
        _this.inputValid = true;
        _this.msgInvalid = false;
        _this.randomId = '';
        _this.labelWidth = '';
        _this.msgError = 'Campo Inválido';
        _this._label = '';
        sbmInputMoneyComponent.push(_this);
        return _this;
    }
    Object.defineProperty(MoneyComponent.prototype, "attribute", {
        get: function () {
            return this._attribute;
        },
        set: function (val) {
            this._attribute = val;
            this.name = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MoneyComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MoneyComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " s12 m12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    MoneyComponent.prototype.blur = function ($event) {
        this._onBlur.emit($event);
        if (this.onBlur != '') {
            window[this.onBlur]($event);
        }
    };
    MoneyComponent.prototype.ngAfterViewInit = function () {
        $(this.money.nativeElement).attr('style', this.styleCss);
        if (this.digitAlign == 'right') {
            $(this.money.nativeElement).css('direction', 'rtl');
        }
        else if (this.digitAlign == 'left') {
            $(this.money.nativeElement).css('direction', 'ltr');
        }
        else if (this.digitAlign == 'center') {
            $(this.money.nativeElement).css('direction', 'ltr');
        }
    };
    MoneyComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    MoneyComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this._options = {
            prefix: this.prefix + ' ',
            thousands: this.thousands,
            decimal: this.decimal,
            align: this.digitAlign,
            precision: this.decimalDigits
        };
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    return MoneyComponent;
}(abstract_ngmodel_1.AbstractNgModel));
MoneyComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-money',
                template: "\n        <input #inputMoney\n            #money\n            #component=\"ngModel\"\n            id=\"{{randomId}}\"\n            [name]=\"name\" \n            type=\"text\" \n            class=\"sbm-text-field {{css}}\"\n            [options]=\"_options\"\n            [style]=\"styleCss\"\n            [disabled]=\"disabled\"\n            [readonly]=\"readonly\"\n            [required]=\"notnull\"\n            (blur)=\"blur($event)\"\n            (keyup)=\"keyup($event)\"\n            [(ngModel)]=\"value\"\n            currencyMask\n        >\n        <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n        \n        <span *ngIf=\"!component.valid\" class=\"msgError\">\n            <p class=\"msgError\" *ngIf=\"component['errors']['required'] && component.touched\">\n                Campo Obrigat\u00F3rio\n            </p>\n        </span>\n    ",
                styles: ["\n        .ng-invalid:not(.ng-untouched) {\n            border-bottom: 1px solid #F44336 !important;\n            box-shadow: 0 1px 0 0 #F44336 !important;\n        }\n    "],
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(MoneyComponent)],
            },] },
];
/** @nocollapse */
MoneyComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
    { type: sharedService_1.SharedService, },
]; };
MoneyComponent.propDecorators = {
    'money': [{ type: core_1.ViewChild, args: ['money',] },],
    'component': [{ type: core_1.ViewChild, args: ['component',] },],
    'securityId': [{ type: core_1.Input, args: ['secutityid',] },],
    'name': [{ type: core_1.Input },],
    'id': [{ type: core_1.Input },],
    'prefix': [{ type: core_1.Input },],
    'decimal': [{ type: core_1.Input },],
    'thousands': [{ type: core_1.Input },],
    'decimalDigits': [{ type: core_1.Input, args: ['decimaldigits',] },],
    'digitAlign': [{ type: core_1.Input, args: ['digitalign',] },],
    'placeholder': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input, args: ['stylecss',] },],
    'onBlur': [{ type: core_1.Input, args: ['onblur',] },],
    'onKeyup': [{ type: core_1.Input, args: ['onkeyup',] },],
    'css': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    'attribute': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.MoneyComponent = MoneyComponent;
