"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
var TextareaComponent = (function (_super) {
    __extends(TextareaComponent, _super);
    function TextareaComponent(_el, _translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._el = _el;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.maxLength = '';
        _this.minLength = '';
        _this.placeholder = 'Informe um valor';
        _this.css = 'sbm-textarea';
        _this.styleCss = '';
        _this.digitText = 'Mm';
        _this.notnull = false;
        _this.disabled = false;
        _this.readonly = false;
        _this.onBlur = '';
        _this.onKeyup = '';
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this._attribute = '';
        _this._columns = 'input-field col l12 s12 m12 crud-form-dynamic';
        _this.isNotMasterDetail = true;
        _this.inputValid = true;
        _this.msgError = 'Campo Incorreto';
        _this.randomId = '';
        _this.labelWidth = '';
        _this._label = '';
        sbmTextareaComponent.push(_this);
        return _this;
    }
    Object.defineProperty(TextareaComponent.prototype, "attribute", {
        get: function () {
            return this._attribute;
        },
        set: function (val) {
            this._attribute = val;
            this.name = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextareaComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextareaComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " s12 m12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    TextareaComponent.prototype.blur = function ($event) {
        this._onBlur.emit($event);
        if (this.onBlur != '') {
            window[this.onBlur]($event);
        }
    };
    TextareaComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    TextareaComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        if (this.maxLength != '') {
            $(this.textarea.nativeElement).attr('data-length', this.maxLength);
        }
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    TextareaComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(this.textarea.nativeElement).attr('style', this.styleCss);
        $(document).ready(function () {
            $(_this._el.nativeElement).find('span.character-counter').css({
                'float': 'righ',
                'font-size': '12px',
                'background-color': '#e53935',
                'color': '#fff',
                'margin': '5px',
                'border-radius': '5px',
                'right': '0px',
                'z-index': '9999',
                'height': '18px',
                'position': 'absolute',
            });
        });
    };
    return TextareaComponent;
}(abstract_ngmodel_1.AbstractNgModel));
TextareaComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-textarea',
                template: "        \n        <textarea \n            #textarea \n            #component=\"ngModel\" \n            id=\"{{randomId}}\" \n            [name]=\"name\" \n            [maxlength]=\"maxLength\" \n            [minlength]=\"minLength\" \n            class=\"sbm-text-field {{css}}\" \n            [style]=\"styleCss\" \n            [rows]=\"height\" \n            [attr.data-length]=\"maxLength\"\n            [disabled]=\"disabled\" \n            [readonly]=\"readonly\"\n            [required]=\"notnull\"\n            (blur)=\"blur($event)\"\n            (keyup)=\"keyup($event)\" \n            [(ngModel)]=\"value\" \n        ></textarea>\n        <label class=\"truncate sbm-label\" for=\"{{randomId}}\">{{_label}}</label>\n          \n        <span *ngIf=\"!component.valid\" class=\"msgError\">\n            <p class=\"msgError\" *ngIf=\"component['errors']['required'] && component.touched\">\n                Campo Obrigat\u00F3rio\n            </p>\n            <p class=\"msgError\" *ngIf=\"component['errors']['minlength'] && component.touched\">\n                O Campo deve Conter no m\u00EDnimo {{minLength}}\n            </p>\n            <p class=\"msgError\" *ngIf=\"component['errors']['maxlength'] && component.touched\">\n                O Campo deve Conter no m\u00E1ximo {{maxLength}}\n            </p>\n        </span>\n    ",
                styles: ["\n        .ng-invalid:not(.ng-untouched) {\n            border-bottom: 1px solid #F44336 !important;\n            box-shadow: 0 1px 0 0 #F44336 !important;\n        }\n    "],
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(TextareaComponent)]
            },] },
];
/** @nocollapse */
TextareaComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
    { type: sharedService_1.SharedService, },
]; };
TextareaComponent.propDecorators = {
    'textarea': [{ type: core_1.ViewChild, args: ['textarea',] },],
    'component': [{ type: core_1.ViewChild, args: ['component',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input, args: ['securityid',] },],
    'name': [{ type: core_1.Input },],
    'maxLength': [{ type: core_1.Input, args: ['maxlength',] },],
    'minLength': [{ type: core_1.Input, args: ['minlength',] },],
    'placeholder': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input, args: ['stylecss',] },],
    'digitText': [{ type: core_1.Input, args: ['digittext',] },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'onBlur': [{ type: core_1.Input, args: ['onblur',] },],
    'onKeyup': [{ type: core_1.Input, args: ['onkeyup',] },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    'attribute': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.TextareaComponent = TextareaComponent;
