"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var array_store_1 = require("devextreme/data/array_store");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var ListOptions = (function (_super) {
    __extends(ListOptions, _super);
    function ListOptions(_sharedService, _http, _translateService, _el, _viewContainerRef, renderer) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._http = _http;
        _this._translateService = _translateService;
        _this._el = _el;
        _this._viewContainerRef = _viewContainerRef;
        _this.renderer = renderer;
        _this.idListOption = '';
        _this.value = '';
        _this.text = '';
        return _this;
    }
    ListOptions.prototype.ngOnInit = function () {
        this.idListOption = 'sbm-list-active-' + Math.floor((Math.random() * 100000) + 1);
    };
    ListOptions.prototype.ngAfterViewInit = function () {
        this.text = this._el.nativeElement.textContent.replace(/\s/g, "");
    };
    return ListOptions;
}(abstract_ngmodel_1.AbstractNgModel));
ListOptions.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-list-option',
                template: "\n        <!--ng-template #internalColumnTemplate let-item=\"item\">\n            <ng-content #el></ng-content>\n        </ng-template>\n\n        <div [hidden]=\"true\">\n            <ng-template [ngTemplateOutlet]=\"content\" [ngOutletContext]=\"{ item: item }\">\n            {{item}}</ng-template>\n        </div-->\n        <ng-content></ng-content>\n    ",
                host: {
                    '[text]': 'value'
                }
            },] },
];
/** @nocollapse */
ListOptions.ctorParameters = function () { return [
    { type: sharedService_1.SharedService, },
    { type: http_1.Http, },
    { type: core_2.TranslateService, },
    { type: core_1.ElementRef, },
    { type: core_1.ViewContainerRef, },
    { type: core_1.Renderer2, },
]; };
ListOptions.propDecorators = {
    'value': [{ type: core_1.Input },],
    'text': [{ type: core_1.Input },],
    'el': [{ type: core_1.ViewChild, args: ['el',] },],
    'columnTemplate': [{ type: core_1.ViewChild, args: ['internalColumnTemplate',] },],
};
exports.ListOptions = ListOptions;
var ListViewComponent = (function (_super) {
    __extends(ListViewComponent, _super);
    function ListViewComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.dataSource = [];
        _this.notnull = false;
        _this._dataSource = ['Valor'];
        _this.text = 'Titulo';
        _this.css = 'sbm-list-view';
        _this.label = 'Selecione';
        _this.placeholder = 'Selecione um valor';
        _this.itemsSelected = [];
        _this.isNotMasterDetail = true;
        _this._columns = 'col l12 m12 s12 crud-form-dynamic sbm-list-view';
        _this.msgError = 'Selecione um valor';
        _this.styleClass = '';
        _this.filterList = null;
        _this.checkedAll = false;
        _this.selectionMultiple = false;
        _this._onClick = new core_1.EventEmitter();
        _this._onRemove = new core_1.EventEmitter();
        _this.onClick = '';
        _this.selectedItems = [];
        _this.randomClass = 0;
        _this.setValue = true;
        _this._label = '';
        sbmListViewComponent.push(_this);
        return _this;
    }
    Object.defineProperty(ListViewComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12 crud-form-dynamic sbm-list-view";
        },
        enumerable: true,
        configurable: true
    });
    ListViewComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.validar.call(this, this.securityId);
        this.randomClass = Math.floor((Math.random() * 100000) + 1);
        this._dataSource = new array_store_1.default({
            data: [{ label: 'value', value: 'value' }],
            key: 'value'
        });
        this.onChangeValue.subscribe(function (val) {
            if (val) {
                _this.listOption.forEach(function (a, i) {
                    val.map(function (e) {
                        if (a.value == e['value']) {
                            $(_this.listOptionsEl.nativeElement).find("#" + a.idListOption).prop('checked', true);
                            $(_this.listOptionsEl.nativeElement).find("." + a.idListOption).css('background-color', '#ddd');
                        }
                    });
                });
            }
        });
    };
    ListViewComponent.prototype.keyupSearch = function () {
        var _this = this;
        this.listOption.forEach(function (a, i) {
            if (_this.value) {
                _this.value.map(function (e) {
                    if (a.value == e['value']) {
                        $(_this.listOptionsEl.nativeElement).find("#" + a.idListOption).prop('checked', true);
                        $(_this.listOptionsEl.nativeElement).find("." + a.idListOption).css('background-color', '#ddd');
                    }
                });
            }
        });
    };
    ListViewComponent.prototype.selectItem = function (item) {
        var _this = this;
        if (this.selectionMultiple) {
            var inputChecked = $(this.listOptionsEl.nativeElement).find("#" + item.idListOption).prop('checked');
            var inputCheckedText = $(this.listOptionsEl.nativeElement).find("." + item.idListOption).text();
            if (inputChecked) {
                $(this.listOptionsEl.nativeElement).find("#" + item.idListOption).prop('checked', false);
                $(this.listOptionsEl.nativeElement).find("." + item.idListOption).css('background-color', '#fff');
                this.value.map(function (a, i) {
                    if (item.value == a) {
                        _this.value.splice(i, 1);
                    }
                });
                this._onRemove.emit(item);
            }
            else {
                $(this.listOptionsEl.nativeElement).find("#" + item.idListOption).prop('checked', true);
                $(this.listOptionsEl.nativeElement).find("." + item.idListOption).css('background-color', '#ddd');
                this.value.push(item.value);
                this._onClick.emit(item);
            }
        }
        else {
            var inputCheckedText = $(this.listOptionsEl.nativeElement).find("." + item.idListOption).text();
            $(this.listOptionsEl.nativeElement).find("a").css('background-color', '#fff');
            $(this.listOptionsEl.nativeElement).find("." + item.idListOption).css('background-color', '#ddd');
            this.value = [item.value];
            this._onClick.emit(item);
        }
        if (this.onClick != '') {
            window[this.onClick](item);
        }
        return false;
    };
    ListViewComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            // Materialize.showStaggeredList('#'+this.listOptionsEl.nativeElement)
            _this.listOption.forEach(function (a, i) {
                if (_this.value) {
                    _this.value.map(function (e) {
                        if (a.value == e['value']) {
                            $(_this.listOptionsEl.nativeElement).find("#" + a.idListOption).prop('checked', true);
                            $(_this.listOptionsEl.nativeElement).find("." + a.idListOption).css('background-color', '#ddd');
                        }
                    });
                }
            });
        });
    };
    ListViewComponent.prototype.allItems = function (all, items) {
        var _this = this;
        var allTrue = $(all).prop('checked');
        if (allTrue) {
            var _data_1 = [];
            items._results.map(function (a, i) {
                var inputCheckedText = $(_this.listOptionsEl.nativeElement).find("." + a.idListOption).text();
                $(_this.listOptionsEl.nativeElement).find("#" + a.idListOption).prop('checked', true);
                $(_this.listOptionsEl.nativeElement).find("." + a.idListOption).css('background-color', '#ddd');
                _data_1.push(a.value);
            });
            this.value = _data_1;
        }
        else {
            this.noneItems();
        }
        this._onClick.emit(this.value);
        if (this.onClick != '') {
            window[this.onClick](this.value);
        }
    };
    ListViewComponent.prototype.noneItems = function () {
        $(this.listOptionsEl.nativeElement).find("input").prop('checked', false);
        $(this.listOptionsEl.nativeElement).find("a").css('background-color', '#fff');
        this.value = [];
    };
    ListViewComponent.prototype.ngAfterViewChecked = function () {
        var _this = this;
        // if (this.setValue && this.value) {
        this.listOption.forEach(function (a, i) {
            if (_this.value) {
                _this.value.map(function (e) {
                    if (a.value == e['value']) {
                        $(_this.listOptionsEl.nativeElement).find("#" + a.idListOption).prop('checked', true);
                        $(_this.listOptionsEl.nativeElement).find("." + a.idListOption).css('background-color', '#ddd');
                    }
                });
            }
        });
        // console.log(this.value)
        this.setValue = false;
        // }
    };
    return ListViewComponent;
}(abstract_ngmodel_1.AbstractNgModel));
ListViewComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-list-view',
                template: "\n        <sbm-fieldset [label]=\"label\" [title]=\"placeholder\">\n            <div class=\"row\">\n                <div class=\"col l12 m12 s12\">\n                    <sbm-input-text label=\"Buscar\" columns=\"12\" [(ngModel)]=\"filterList\" (_onKeyup)='keyupSearch()'></sbm-input-text>\n                </div>\n                <div class=\"col l12 m12 s12 \">\n                    <div class=\"collection sbm-listview-container\" #listOptionsEl>\n                        <a *ngIf=\"selectionMultiple\" class=\"collection-item\" (click)=\"allItems(selectAll, listOption)\"> \n                            <input #selectAll class=\"filled-in sbm-listview-checkbox\" type=\"checkbox\" id=\"sbmListSelectAll{{randomClass}}\"/>                \n                            <label for=\"sbmListSelectAll{{randomClass}}\" style=\"top: 8px;\">Selecionar Todos</label>\n                        </a>\n                        <a *ngFor=\"let item of listOption | sbmFilter:filterList\" class=\"collection-item {{item.idListOption}}\"> \n                        <span (click)=\"selectItem(item)\" *ngIf=\"selectionMultiple\">\n                                <input #selectItemEl class=\"filled-in sbm-listview-checkbox\" type=\"checkbox\" [id]=\"item.idListOption\"/>                \n                                <label [for]=\"item.idListOption\" style=\"top: 8px;\"></label>\n                            </span> \n                            <span (click)=\"selectItem(item)\">\n                                <!--ng-template [ngTemplateOutlet]=\"item.columnTemplate\" [ngOutletContext]=\"{ item: item }\"></ng-template-->\n                                {{item.text}}\n                            </span> \n                        </a>\n                    </div>\n                </div>\n            \n            </div>\n        </sbm-fieldset>\n    ",
                host: {
                    '[class]': 'columns',
                    '[title]': 'msgError',
                    '[style]': 'styleClass'
                },
                providers: [abstract_ngmodel_1.MakeProvider(ListViewComponent)]
            },] },
];
/** @nocollapse */
ListViewComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
    { type: sharedService_1.SharedService, },
]; };
ListViewComponent.propDecorators = {
    'listOption': [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return ListOptions; }),] },],
    'listOptionsEl': [{ type: core_1.ViewChild, args: ['listOptionsEl',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'dataSource': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'text': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'itemsSelected': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
    'selectionMultiple': [{ type: core_1.Input },],
    '_onClick': [{ type: core_1.Output },],
    '_onRemove': [{ type: core_1.Output },],
    'onClick': [{ type: core_1.Output },],
};
exports.ListViewComponent = ListViewComponent;
