"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstractForm_1 = require("../../models/abstractForm");
var SbmMasterDetailForm = (function (_super) {
    __extends(SbmMasterDetailForm, _super);
    function SbmMasterDetailForm() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.idRadioOption = '';
        _this.elementRef = '';
        _this.cancelForm = new core_1.EventEmitter();
        _this.enableTemplate = false;
        _this.formMasterDetail = new core_1.EventEmitter();
        _this.buttonText = 'Adicionar';
        return _this;
    }
    SbmMasterDetailForm.prototype.addItem = function (item) {
        _super.prototype.addFormControls.call(this, item);
        if (item.valid) {
            this.formMasterDetail.emit(item.value);
        }
        else {
            this.validModels();
        }
    };
    SbmMasterDetailForm.prototype.validModels = function () {
        // const campos = this.getAllComponents();
        if (this.inputTextComp.length > 0) {
            this.inputTextComp.forEach(function (item, index) {
                if (item.pattern.length > 0 && item.regex(item.value)) {
                    item.inputValid = false;
                    $(item.inputText.nativeElement).removeClass('valid');
                    $(item.inputText.nativeElement).addClass('invalid');
                    item.msgError = item.validationsMsg['pattern'];
                }
                if (item.minLength != '') {
                    if (item.value === undefined || item.value.length < parseInt(item.minLength)) {
                        item.inputValid = false;
                        $(item.inputText.nativeElement).removeClass('valid');
                        $(item.inputText.nativeElement).addClass('invalid');
                        item.msgError = (item.validationsMsg['minLength'] ? item.validationsMsg['minLength'].replace("%", "" + item.minLength) : '');
                    }
                }
                if (item.notnull && item.value !== undefined && item.value.length == 0) {
                    item.inputValid = false;
                    $(item.inputText.nativeElement).removeClass('valid');
                    $(item.inputText.nativeElement).addClass('invalid');
                    item.msgError = item.validationsMsg['require'];
                }
            });
        }
        if (this.inputPasswordComp.length > 0) {
            this.inputPasswordComp.forEach(function (item) {
                if (item.notnull && item.value == undefined || item.value.length == 0) {
                    item.inputValid = false;
                    $(item.inputPassword.nativeElement).removeClass('valid');
                    $(item.inputPassword.nativeElement).addClass('invalid');
                    item.msgError = 'Campo Obrigatório';
                }
                else {
                    if (item.value !== undefined && item.value.length < parseInt(item.minLength)) {
                        item.msgError = 'O campo deve ter no mínimo ' + item.minLength + ' caracteres';
                        $(item.inputPassword.nativeElement).removeClass('valid');
                        $(item.inputPassword.nativeElement).addClass('invalid');
                    }
                    else {
                        $(item.inputPassword.nativeElement).removeClass('invalid');
                        $(item.inputPassword.nativeElement).addClass('valid');
                        item.inputValid = true;
                    }
                }
            });
        }
        if (this.inputCepComp.length > 0) {
            this.inputCepComp.forEach(function (item, index) {
                if (item.notnull && item.value.length == 0) {
                    item.inputValid = false;
                    $(item.inputCep.nativeElement).removeClass('valid');
                    $(item.inputCep.nativeElement).addClass('invalid');
                    item.msgError = item.validationsMsg['require'];
                }
            });
        }
        if (this.selectComp.length > 0) {
            this.selectComp.forEach(function (item, index) {
                if (item.notnull && !item.value) {
                    item.inputValid = false;
                    item.msgError = item.validationsMsg['require'];
                }
            });
        }
    };
    SbmMasterDetailForm.prototype.getAllComponents = function () {
        return _super.prototype.getAllComponents.call(this);
    };
    SbmMasterDetailForm.prototype.cancel = function (f) {
        f.reset();
        this.cancelForm.emit({ 'cancel': true });
    };
    SbmMasterDetailForm.prototype.clearForm = function () {
        _super.prototype.clearForm.call(this);
    };
    SbmMasterDetailForm.prototype.setValue = function (attr, val) {
        _super.prototype.crudSetValue.call(this, attr, val);
    };
    SbmMasterDetailForm.prototype.ngAfterViewInit = function () {
        _super.prototype.setMasterDetailComp.call(this);
    };
    SbmMasterDetailForm.prototype.ngOnInit = function () {
        this.idRadioOption = 'sbm-radio-active-' + Math.floor((Math.random() * 1000000) + 1);
    };
    return SbmMasterDetailForm;
}(abstractForm_1.AbstractForm));
SbmMasterDetailForm.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-master-detail-form',
                template: "\n        <ng-template #internalColumnTemplate let-item=\"item\">\n            <form #crudFrom #f='ngForm'>\n                <ng-content></ng-content>\n                <div class=\"col l12 m12 s12\">\n                    <sbm-button columns=\"3\" style=\"float:right\" (_onClick)=\"addItem(f)\" [text]=\"buttonText\"></sbm-button>\n                    <sbm-button columns=\"3\" style=\"float:right\" (_onClick)=\"cancel(f)\" text=\"Cancelar\"></sbm-button>\n                </div>\n            </form>\n        </ng-template>\n    "
            },] },
];
/** @nocollapse */
SbmMasterDetailForm.ctorParameters = function () { return []; };
SbmMasterDetailForm.propDecorators = {
    'elementRef': [{ type: core_1.Input },],
    'columnTemplate': [{ type: core_1.ViewChild, args: ['internalColumnTemplate',] },],
};
exports.SbmMasterDetailForm = SbmMasterDetailForm;
