import { EventEmitter, OnInit } from '@angular/core';
import { ItemMenu } from '../../interfaces/ItemMenu';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { SharedService } from "../../models/sharedService";
import { TranslateService } from '@ngx-translate/core';
import { Http } from '@angular/http';
export declare class SubMenuComponent {
    id: string;
    securityId: string;
    value: string;
    icon: string;
}
export declare class ItemMenuComponent {
    id: string;
    securityId: string;
    label: string;
    icon: string;
    link: string;
}
export declare class MenuComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _sharedService;
    private _translateService;
    _http: Http;
    id: string;
    securityId: string;
    dataSource: ItemMenu[];
    orientation: any;
    onClick: EventEmitter<{}>;
    randomClass: number;
    dataElement: any[];
    private _dataSource;
    constructor(_sharedService: SharedService, _translateService: TranslateService, _http: Http);
    ngOnInit(): void;
    recursiveElement(_element: any): ItemMenu;
    ngAfterViewInit(): void;
    itemClicado(itemAtual: any): void;
}
export declare enum MenuEnumOrientation {
    horizontal = 0,
    vertical = 1,
}
