"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var datebox_component_1 = require("../datebox/datebox.component");
var custom_store_1 = require("devextreme/data/custom_store");
require("rxjs/add/operator/toPromise");
var MonitorComponent = (function () {
    function MonitorComponent() {
        this.dbEnumType = datebox_component_1.DateboxEnumType.date;
        /*grid custom*/
        this.columns = [];
        this.pagination = 10;
        this.select = 'single';
        this.gruping = false;
        /*grid custom*/
        this.selectedItem = [];
        this.monitorUrl = '';
        this.columnProgress = '';
        this.executeMonitorUrl = '';
        this.formInvalid = false;
        this.timeReload = [
            { textTime: 'Somente uma Vez', time: 0 },
            { textTime: '5 Segundos', time: 5000 },
            { textTime: '10 Segundos', time: 10000 },
            { textTime: '20 Segundos', time: 20000 },
        ];
        this.datas = {
            dataInicio: null,
            dataFim: null
        };
    }
    MonitorComponent.prototype.ngOnInit = function () {
        var me = this;
        this.columns.map(function (obj) {
            if (obj['dataField'].toLowerCase().indexOf(me.columnProgress.toLowerCase()) > -1) {
                obj['cellTemplate'] = 'progressBar';
            }
        });
        this.source = new custom_store_1.default({
            load: function (loadOptions) {
                var deferred = $.Deferred();
                var params = '';
                var url = (loadOptions.searchValue || '');
                // console.log(url.toString());
                if (url.toString().indexOf('?') != -1) {
                    params += '&';
                }
                else {
                    params += '?';
                }
                // let prev = (loadOptions.skip + me.pagination) / me.pagination;
                // if (prev && loadOptions.take) {
                // params += 'skip=' + (prev || 1);
                params += 'skip=' + (loadOptions.skip || 0);
                params += '&take=' + (loadOptions.take || me.pagination);
                if (loadOptions.sort) {
                    params += '&sort=-' + loadOptions.sort[0].selector;
                    if (loadOptions.sort[0].desc) {
                        params = params.replace('&sort=-', '&sort=');
                        // params += ' desc';
                    }
                }
                // }else {
                //     if (loadOptions.sort) {
                //         params += 'sort=-' + loadOptions.sort[0].selector;
                //         if (loadOptions.sort[0].desc) {
                //             params = params.replace('sort=-', 'sort=');
                //             // params += ' desc';
                //         }
                //     }
                // }
                if (loadOptions.searchValue) {
                    if (loadOptions.filter) {
                        params = '';
                        if (loadOptions.sort) {
                            params = '?sort=-' + loadOptions.sort[0].selector;
                            if (loadOptions.sort[0].desc) {
                                params = params.replace('?sort=-', '?sort=');
                                // params += ' desc';
                            }
                        }
                    }
                    var xhr_1 = new XMLHttpRequest();
                    xhr_1.open('GET', loadOptions.searchValue + params, true);
                    // xhr.setRequestHeader('Token', localStorage.getItem('token'));
                    xhr_1.onreadystatechange = function () {
                        if (xhr_1.readyState === 4) {
                            if (xhr_1.status === 200) {
                                var result = JSON.parse(xhr_1.responseText);
                                // params = {result.data, totalCount: result.size};
                                if (loadOptions.filter) {
                                    // let filterData = [];
                                    // let filterCount = 0;
                                    // let index;
                                    /*for (let i = 0; i < result.data.length; i++) {
                                     for (let key in result.data[i]) {
                                     if (result.data[i][key] != null) {
                                     if (result.data[i][key].toString().indexOf(loadOptions.filter[0][2]) != -1) {
                                     if (index != i) {
                                     filterData.push(result.data[i]);
                                     index = i;
                                     filterCount = filterData.length;
                                     }
                                     }
                                     }
                                     }
                                     }*/
                                    /*deferred.resolve({
                                     data: filterData,
                                     totalCount: filterCount
                                     });*/
                                    deferred.resolve({
                                        data: result.items,
                                        totalCount: result.totalCount
                                    });
                                }
                                else {
                                    /*deferred.resolve({
                                     data: result.data,
                                     totalCount: result.size
                                     });*/
                                    deferred.resolve({
                                        data: result.items,
                                        totalCount: result.totalCount
                                    });
                                }
                            }
                            else {
                                deferred.reject('Erro ao Carregar os registros (#' + xhr_1.status + ' ' + xhr_1.statusText + ')');
                            }
                        }
                    };
                    xhr_1.send();
                    return deferred.promise();
                }
                else {
                    deferred.resolve({
                        data: [],
                        totalCount: 0
                    });
                    return deferred.promise();
                }
            }
        });
    };
    MonitorComponent.prototype.dataInicio = function (data) {
        this.datas.dataInicio = data;
        console.log(data);
    };
    MonitorComponent.prototype.dataFim = function (data) {
        this.datas.dataFim = data;
        console.log(data);
    };
    MonitorComponent.prototype.reloadMonitor = function (event) {
        var _this = this;
        if (event.time > 0) {
            this.interval = setInterval(function () {
                _this.monitor.instance.refresh();
            }, event.time);
        }
    };
    MonitorComponent.prototype.formatDate = function (date) {
        return ['0' + date.getDate().slice(-2),
            ('0' + (date.getMonth() + 1)).slice(-2),
            date.getFullYear()].join('/') + ' 00:00';
    };
    MonitorComponent.prototype.executeMonitor = function (dataInicial, dataFinal) {
        this.executeMonitorUrl = '';
        /*let dataInicial = this.formatDate(_dataInicial);
        let dataFinal = this.formatDate(_dataFim);*/
        var params = '?';
        params += 'dataInicio=' + dataInicial + '-' + dataFinal;
        this.executeMonitorUrl = this.monitorUrl + params;
    };
    MonitorComponent.prototype.valueDivider = function (value) {
        return value / 1000;
    };
    MonitorComponent.prototype.ngDoCheck = function () {
        if (this.datas.dataInicio != null && this.datas.dataFim != null) {
            this.formInvalid = false;
        }
        else {
            this.formInvalid = true;
        }
    };
    MonitorComponent.prototype.ngOnDestroy = function () {
        clearInterval(this.interval);
    };
    return MonitorComponent;
}());
MonitorComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-monitor',
                styles: ["\n        .sbm-monitor {\n            z-index: 999;\n        }\n    "],
                template: "\n        <div class='row'>\n            <div class='col l9 sbm-monitor right'>\n                <div class='col l3'>\n                    <sbm-datebox #dataInicio label=\"Data Inicial\" securityId='campo01' (_onChange)='dataInicio($event)' type='date'\n                    ></sbm-datebox>\n                </div>\n                <div class='col l3'>\n                    <sbm-datebox #dataFim label=\"Data Final\" securityId='campo01' (_onChange)='dataFim($event)' type='date'\n                    ></sbm-datebox>\n                </div>\n                <div class='col l3'>\n                    <sbm-select securityId=\"campo01\" label='Atualizar Automaticamente' [dataSource]='timeReload'\n                                [text]='[\"textTime\"]'\n                                (_onClick)='reloadMonitor($event)'></sbm-select>\n                </div>\n        \n                <div class='col l3'>\n                    <sbm-button css=\"sbm-btn-default right\" text=\"Executar\" (_onClick)=\"executeMonitor(dataInicio.value, dataFim.value)\"></sbm-button>\n                </div>\n            </div>\n            <div class=\"col l12\">\n                <div class='monitor-grid'>\n                    <dx-data-grid\n                            #monitor\n                            [dataSource]='{store: source, searchValue: executeMonitorUrl, requireTotalCount: true}'\n                            [paging]='{\n                            pageSize: pagination\n                        }'\n                            [pager]='{\n                            showPageSizeSelector: false,\n                            allowedPageSizes: [5, 10, 20],\n                            showInfo: true,\n                            infoText: infoText,\n                            showNavigationButtons: true\n                        }'\n                            [selection]='{\n                            mode: select\n                        }'\n                            [searchPanel]='{\n                            visible: true,\n                            width: 240,\n                            placeholder: \"Procurar...\"\n                        }'\n                            [showBorders]='true'\n                            [rowAlternationEnabled]='true'\n                            (onSelectionChanged)='selectionData($event)'\n                            [groupPanel]='{\n                            visible: gruping,\n                            emptyPanelText: \"Arraste uma coluna para agrupar\"\n                        }'\n                            [remoteOperations]='{\n                            \"filtering\": true,\n                            \"paging\": true,\n                            \"sorting\": true,\n                            \"summary\": true\n                        }'\n                    >\n                        <dxi-sort-by-group-summary-info summaryItem=\"count\"></dxi-sort-by-group-summary-info>\n                        <dxi-column *ngFor='let item of columns'\n                                    [dataField]='item?.dataField'\n                                    [dataType]='item?.dataField'\n                                    [caption]='item?.caption'\n                                    [format]='item?.format'\n                                    [cellTemplate]='item?.cellTemplate'\n                        ></dxi-column>\n        \n                        <div *dxTemplate=\"let d of 'progressBar'\">\n                            <sbm-progressbar securityId='campo01' id='campo26' [(ngModel)]='d.data.SaleAmount'\n                                             valueMin='0' valueMax='100'></sbm-progressbar>\n                        </div>\n        \n                    </dx-data-grid>\n        \n                </div>\n            </div>\n        </div>\n    "
            },] },
];
/** @nocollapse */
MonitorComponent.ctorParameters = function () { return []; };
MonitorComponent.propDecorators = {
    'monitor': [{ type: core_1.ViewChild, args: ['monitor',] },],
    'columns': [{ type: core_1.Input },],
    'pagination': [{ type: core_1.Input },],
    'select': [{ type: core_1.Input },],
    'gruping': [{ type: core_1.Input },],
    'monitorUrl': [{ type: core_1.Input },],
    'columnProgress': [{ type: core_1.Input },],
};
exports.MonitorComponent = MonitorComponent;
