"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var MultiselectComponent = (function (_super) {
    __extends(MultiselectComponent, _super);
    function MultiselectComponent(_el, _translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._el = _el;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.securityId = '';
        _this.id = '';
        _this.css = 'sbm-chip';
        _this.placeholder = 'Informe o(s) valor(es)';
        _this.notnull = false;
        _this.isEmail = false;
        _this.styleCss = '';
        _this.onBlur = '';
        _this.onKeyup = '';
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this._attribute = '';
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this.isNotMasterDetail = true;
        _this.inputValid = true;
        _this._value = [];
        _this._value2 = [];
        _this._label = '';
        _this.notRender = false;
        sbmMultiSelectComponent.push(_this);
        return _this;
    }
    Object.defineProperty(MultiselectComponent.prototype, "attribute", {
        get: function () {
            return this._attribute;
        },
        set: function (val) {
            this._attribute = val;
            this.name = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiselectComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiselectComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " m12 s12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    MultiselectComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.validar.call(this, this.securityId);
        var valueInitial = {
            data: []
        };
        this.ValueChange = this.component.valueChanges.subscribe(function (ret) {
            if (!_this.component.valid) {
                $(_this.multiselect.nativeElement).addClass('invalid-multiselect');
            }
            else {
                $(_this.multiselect.nativeElement).removeClass('invalid-multiselect');
            }
            if (ret) {
                if (ret.length > 0) {
                    _this._value = [];
                    valueInitial.data = [];
                    ret.map(function (v) {
                        valueInitial.data.push({ tag: v });
                        _this._value.push({ tag: v });
                    });
                    if (!_this.notRender) {
                        $(_this.multiselect.nativeElement).material_chip(valueInitial);
                        _this.notRender = true;
                    }
                }
                else {
                    _this.notRender = true;
                }
            }
        });
    };
    MultiselectComponent.prototype.initMultiselect = function () {
        var _this = this;
        $(this.multiselect.nativeElement).on('chip.add', function (e, chip) {
            _this.addValue(chip, e);
        });
        $(this.multiselect.nativeElement).on('chip.delete', function (e, chip) {
            _this.deleteItem(chip, e);
        });
        $(this.multiselect.nativeElement).material_chip();
        $(this.multiselect.nativeElement).find('input').blur(function () {
            _this.blur($(_this.multiselect.nativeElement).material_chip('data'), $(_this.multiselect.nativeElement));
        });
        $(this.multiselect.nativeElement).find('input').keyup(function () {
            _this.keyup($(_this.multiselect.nativeElement));
        });
    };
    MultiselectComponent.prototype.ngAfterViewInit = function () {
        this.initMultiselect();
    };
    MultiselectComponent.prototype.addValue = function (value, e) {
        this._value.push(value);
        var a = [];
        this._value.map(function (i) {
            a.push(i.tag);
        });
        this.value = a;
    };
    MultiselectComponent.prototype.deleteItem = function (chip, e) {
        var _this = this;
        this._value.map(function (v, i) {
            if (v.tag == chip.tag) {
                _this._value.splice(i, 1);
            }
        });
        var a = [];
        this._value.map(function (i) {
            a.push(i.tag);
        });
        this.value = a;
    };
    MultiselectComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    MultiselectComponent.prototype.blur = function (data, element) {
        this._onBlur.emit(data);
        if (this.onBlur != '') {
            window[this.onBlur](data);
        }
    };
    MultiselectComponent.prototype.ngOnDestroy = function () {
        this.ValueChange.unsubscribe();
        this.notRender = false;
    };
    return MultiselectComponent;
}(abstract_ngmodel_1.AbstractNgModel));
MultiselectComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-multiselect',
                template: "        \n        <input id=\"sbm-multiselect-49874123364498742\" #component=\"ngModel\" type=\"text\" class=\"sbm-text-field\" \n        [name]=\"name\" [(ngModel)]=\"value\" [required]=\"notnull\" [hidden]=\"true\"/>\n        <div [hidden]=\"!exibirComponente\" #multiselect class=\"sbm-multiselect {{css}}\"></div>\n        <label class=\"sbm-label truncate\">{{label}}</label>\n\n        <span *ngIf=\"!component.valid\" class=\"msgError\">\n            <p class=\"msgError\" *ngIf=\"component['errors']['required']\">\n                Campo Obrigat\u00F3rio\n            </p>\n        </span>\n    ",
                styles: ["\n        .sbm-multiselect {\n            margin: 0 !important;\n        }\n    "],
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(MultiselectComponent)],
            },] },
];
/** @nocollapse */
MultiselectComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
    { type: sharedService_1.SharedService, },
]; };
MultiselectComponent.propDecorators = {
    'multiselect': [{ type: core_1.ViewChild, args: ['multiselect',] },],
    'component': [{ type: core_1.ViewChild, args: ['component',] },],
    'securityId': [{ type: core_1.Input, args: ['securityid',] },],
    'name': [{ type: core_1.Input },],
    'id': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'isEmail': [{ type: core_1.Input, args: ['isemail',] },],
    'styleCss': [{ type: core_1.Input, args: ['stylecss',] },],
    'onBlur': [{ type: core_1.Input, args: ['onblur',] },],
    'onKeyup': [{ type: core_1.Input, args: ['onkeyup',] },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    'attribute': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.MultiselectComponent = MultiselectComponent;
