"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var req_http_service_1 = require("../../services/req-http.service");
var crud2_component_1 = require("../crud2/crud2.component");
var ParametersComponent = (function () {
    function ParametersComponent(_reqHttpService) {
        this._reqHttpService = _reqHttpService;
        this.onSave = new core_1.EventEmitter();
        this.withShadingOptionsVisible = {};
        this.columns = [
            { dataField: 'rotulo', caption: 'Chave' },
            { dataField: 'tipo', caption: 'Valor', cellTemplate: 'cellTemplate' }
        ];
        this.returnParameter = {
            'parametros': []
        };
        this.modelParameter = {};
        this.value = '';
    }
    Object.defineProperty(ParametersComponent.prototype, "models", {
        get: function () {
            return this.modelsForm;
        },
        set: function (val) {
            this.modelsForm = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ParametersComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSourceSelect;
        },
        set: function (value) {
            if (value) {
                this._dataSourceSelect = value;
                this._dataSource = value;
                $(document).ready(function () {
                    Materialize.updateTextFields();
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    ParametersComponent.prototype.reloadModel = function () {
        if (this.dataSource !== undefined) {
            for (var _i = 0, _a = this.dataSource; _i < _a.length; _i++) {
                var item = _a[_i];
                if (item.tipo == 'TABELA') {
                    this.modelParameter[item.nome] = [];
                    this.withShadingOptionsVisible[item.nome] = false;
                }
                else {
                    this.modelParameter[item.nome] = item.valor_padrao;
                }
                // this.returnParameter.codigo = this._dataSource.codigo;
            }
        }
    };
    ParametersComponent.prototype.ngOnInit = function () {
        var _this = this;
        crud2_component_1.Crud2Component.emitChangeFilter.subscribe(function (ret) {
            _this.reloadModel();
        });
        this.reloadModel();
    };
    ParametersComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            _this.blurParametro();
        });
    };
    ParametersComponent.prototype.ngOnChanges = function () {
        if (this._dataSource) {
            this.returnParameter.parametros = [];
            // this.returnParameter.codigo = this._dataSource.codigo;
        }
    };
    ParametersComponent.prototype.blurParametro = function (event) {
        if (event === void 0) { event = null; }
        if (this.dataSource !== undefined) {
            this.returnParameter.parametros = [];
            var _array_1 = [];
            for (var _i = 0, _a = this.dataSource; _i < _a.length; _i++) {
                var item = _a[_i];
                var itemModel = {};
                if (item.tipo == 'TABELA') {
                    this.modelParameter[item.nome].map(function (a) {
                        _array_1.push(a.value);
                    });
                    itemModel = {
                        'nome': item.nome,
                        'valor': (_array_1.join())
                    };
                }
                else {
                    itemModel = {
                        'nome': item.nome,
                        'valor': (this.modelParameter[item.nome])
                    };
                    if (item.hasOwnProperty('codigo')) {
                        itemModel['codigo'] = item.codigo;
                    }
                }
                this.returnParameter.parametros.push(itemModel);
            }
            this.onSave.emit({ parameters: this.returnParameter });
            this.models = this.returnParameter;
            localStorage.setItem('__SBM-PARAMETER-CURRENT', JSON.stringify(this.modelParameter));
        }
    };
    ParametersComponent.prototype.openPopover = function (item) {
        WebuiPopovers.show(".sbmTable" + item.nome, {
            url: "#sbmTable" + item.nome,
            placement: 'bottom',
            width: 400,
            animation: 'pop',
            closeable: true,
            async: {
                type: 'GET',
                before: function (that, xhr, settings) { },
                success: function (that, data) { },
                error: function (that, xhr, data) { } //executed after error ajax request
            },
        });
    };
    ParametersComponent.prototype.toggleWiithShadingOptions = function (item, listOption) {
        var _this = this;
        var jsonItems = JSON.parse(localStorage.getItem("SBM_PARAMETERS_TABLE-" + item.nome));
        // if (!jsonItems) {
        this.modelParameter[item.nome] = [];
        this._reqHttpService.xhrGet("/sabium/api/" + item.nome).subscribe(function (ret) {
            _this.dataTable = ret.res.data;
            // localStorage.setItem(`SBM_PARAMETERS_TABLE-${item.nome}`, JSON.stringify(ret.res.data));
            WebuiPopovers.show(".sbmTable" + item.nome, {
                url: "#sbmTable" + item.nome,
                placement: 'bottom',
                width: 400,
                animation: 'pop',
                closeable: true,
                async: {
                    type: 'GET',
                    before: function (that, xhr, settings) { },
                    success: function (that, data) { },
                    error: function (that, xhr, data) { } //executed after error ajax request
                },
            });
            var jsonValue = JSON.parse(localStorage.getItem('__SBM-PARAMETER-CURRENT'));
            if (jsonValue) {
                setTimeout(function () {
                    var _loop_1 = function (a) {
                        listOption.listOption.forEach(function (b) {
                            if (a.value == b.value) {
                                listOption.selectItem(b);
                            }
                        });
                        // this.modelParameter[item.nome] = jsonValue[item.nome];
                    };
                    for (var _i = 0, _a = jsonValue[item.nome]; _i < _a.length; _i++) {
                        var a = _a[_i];
                        _loop_1(a);
                    }
                }, 1000);
            }
        });
        // }else {
        //     this.dataTable = jsonItems;
        //     WebuiPopovers.show(`.sbmTable${item.nome}`,{
        //         url: `#sbmTable${item.nome}`,
        //         placement: 'bottom',
        //         width: 400,
        //         animation: 'pop',
        //         closeable:true,
        //     });
        // }
        this.withShadingOptionsVisible[item.nome] = !this.withShadingOptionsVisible[item.nome];
    };
    ParametersComponent.prototype.cliqueParameters = function (event, nome) {
        this.modelParameter[nome] = event;
        this.onSave.emit(this.returnParameter);
    };
    ParametersComponent.prototype.saveParameters = function (retorno) {
        this.onSave.emit(retorno);
    };
    ParametersComponent.prototype.ngOnDestroy = function () {
        localStorage.removeItem('__SBM-PARAMETER-CURRENT');
    };
    return ParametersComponent;
}());
ParametersComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-parameters',
                template: "\n        <span *ngFor=\"let item of dataSource\">\n            <sbm-input-text *ngIf='item.tipo == \"STRING\"' [label]=\"item.rotulo\" [require]=\"item.obrigatorio\"\n            id='campo1' securityId=\"campo01\" [(ngModel)]='modelParameter[item.nome]'\n            (_onBlur)='blurParametro()'></sbm-input-text>\n            \n            <sbm-input-number *ngIf='item.tipo == \"INTEIRO\"' [label]=\"item.rotulo\" [require]=\"item.obrigatorio\"\n            id='campo1' securityId=\"campo01\" [(ngModel)]='modelParameter[item.nome]'\n            (_onBlur)='blurParametro()'></sbm-input-number>\n                            \n            <sbm-datebox *ngIf='item.tipo == \"DATA\"' [label]=\"item.rotulo\" [require]=\"item.obrigatorio\"\n             type='date' (_onClick)='blurParametro($event)' [(ngModel)]='modelParameter[item.nome]'></sbm-datebox>\n            \n            <sbm-datebox *ngIf='item.tipo == \"DATA_HORA\"' [label]=\"item.rotulo\" [require]=\"item.obrigatorio\"\n            type='datetime' (_onClick)='blurParametro($event)' [(ngModel)]='modelParameter[item.nome]'></sbm-datebox>\n            \n            <sbm-money *ngIf='item.tipo == \"MOEDA\"' [label]=\"item.rotulo\" [require]=\"item.obrigatorio\"\n             id='campo2' securityId=\"campo01\" [(ngModel)]='modelParameter[item.nome]'\n             (_onBlur)='blurParametro()'></sbm-money>\n             \n            <span *ngIf='item.tipo == \"TABELA\"' class=\"col l12 m12 s12\" style=\"padding: 5px;\">\n                <a class=\"waves-effect waves-light btn sbmTable{{item.nome}}\" style=\"width: 100%;\" (click)=\"toggleWiithShadingOptions(item, sbmtable)\">\n                <i class=\"material-icons right\">more_horiz</i> {{item.rotulo}}\n                </a>\n                \n                <div style=\"display: none;\" id=\"sbmTable{{item.nome}}\">\n                   <sbm-list-view #sbmtable\n                        [require]=\"item.obrigatorio\"\n                        securityId='campo01'\n                        selectionMultiple='true'\n                        label='{{item.rotulo}}'\n                        [(ngModel)]='modelParameter[item.nome]'\n                        (_onClick)='blurParametro()'>\n                        \n                        <sbm-list-option *ngFor=\"let data of dataTable\" [value]='data.id'>{{data.id}} - {{data[item.campo]}}</sbm-list-option>\n                                \n                    </sbm-list-view>\n                </div>\n            </span>\n        </span>    \n        \n        <!--sbm-input-number label=\"Itens por pagina\" [(ngModel)]='itemsPerPage' digitAlign=\"left\" (_onBlur)='blurParametro()'></sbm-input-number-->\n    "
            },] },
];
/** @nocollapse */
ParametersComponent.ctorParameters = function () { return [
    { type: req_http_service_1.ReqHttpService, },
]; };
ParametersComponent.propDecorators = {
    'models': [{ type: core_1.Input },],
    'dataSource': [{ type: core_1.Input, args: ['dataSource',] },],
    'onSave': [{ type: core_1.Output },],
};
exports.ParametersComponent = ParametersComponent;
