"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var datebox_component_1 = require("../datebox/datebox.component");
var grid_component_1 = require("../grid/grid.component");
var req_http_service_1 = require("../../services/req-http.service");
var RelatoriosComponent = (function () {
    function RelatoriosComponent(_reqHttpService) {
        this._reqHttpService = _reqHttpService;
        this.dbEnumType = datebox_component_1.DateboxEnumType.date;
        this.formInvalid = false;
        this.timeReload = [
            { textTime: 'Somente uma Vez', time: 0 },
            { textTime: '5 Segundos', time: 5000 },
            { textTime: '10 Segundos', time: 10000 },
            { textTime: '20 Segundos', time: 20000 },
        ];
        this.reportUrl = '';
        this.downloadUrl = '';
        this.onSelectItem = new core_1.EventEmitter();
        this.executeReportUrl = '';
    }
    RelatoriosComponent.prototype.ngOnInit = function () {
        this.executeReportUrl = this.reportUrl;
    };
    RelatoriosComponent.prototype.reloadReport = function (event) {
        var _this = this;
        if (event.time > 0) {
            setInterval(function () {
                _this.report.refresh();
            }, event.time);
        }
    };
    RelatoriosComponent.prototype.formatDate = function (date) {
        return [('0' + date.getDate()).slice(-2),
            ('0' + (date.getMonth() + 1)).slice(-2),
            date.getFullYear()].join('/') + ' 00:00';
    };
    RelatoriosComponent.prototype.executeReport = function (dataInicial, dataFinal) {
        this.executeReportUrl = '';
        // let dataInicial = this.formatDate(this.dates.dataInicio);
        // let dataFinal = this.formatDate(this.dates.dataFim);
        // let params = '?';
        // params += 'dataInicio=' + dataInicial+' 00:00' + '-' + dataFinal+' 00:00';
        // params += '&dataFinal=' + dataFinal.toISOString();
        // params += '&situacaoExecucao=' + data.situacaoExecucao;
        // params += 'id=51';
        this.executeReportUrl = this.reportUrl;
        this._reqHttpService.xhrGet(this.executeReportUrl).subscribe(function (ret) {
            console.log(ret);
        });
        this.report.refresh();
    };
    RelatoriosComponent.prototype.downloadReport = function (event) {
        this.onSelectItem.emit(event);
        /*let alertComponent = new AlertComponent();
         alertComponent.show('Download relatório', 'Sim', 'Deseja fazer o download do relatório', 'info', true, 'Cancelar').then(ret => {
         if (ret) {
         let downloadUrl = this.downloadUrl.replace('{1}', event.selectedRowsData[0].id);

         this._reqHttpService.xhrDownload(downloadUrl).subscribe(ret => {
         let file = new Blob(['\ufeff', ret], {type: 'application/pdf'});
         saveAs(file, 'relatorio.pdf');
         console.log(file);

         let fileURL = URL.createObjectURL(file);
         window.open(fileURL);
         });
         }
         });*/
    };
    RelatoriosComponent.prototype.ngDoCheck = function () {
        // if (this.dates.dataInicio != null && this.dates.dataFim != null) {
        //     this.formInvalid = false;
        // } else {
        //     this.formInvalid = true;
        // }
    };
    return RelatoriosComponent;
}());
RelatoriosComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-relatorios',
                styles: ["\n        .sbm-report {\n            z-index: 999;\n        }\n    "],
                template: "\n        <div class='row'>\n            <div class='col l9 m9 s12 sbm-report right'>\n                <div class='col l3'>\n                    <sbm-datebox #dataInicio label=\"Data Inicial\" securityId='campo01' type='date' min='30'\n                                 max='60'\n                    ></sbm-datebox>\n                </div>\n                <div class='col l3'>\n                    <sbm-datebox #dataFim label=\"Data Final\" securityId='campo01' type='date' min='30'\n                                 max='60'\n                    ></sbm-datebox>\n                </div>\n                <div class='col l3'>\n                    <sbm-select securityId=\"campo01\" label='Atualizar Automaticamente' [dataSource]='timeReload'\n                                [text]='[\"textTime\"]'\n                                (_onClick)='reloadReport($event)'></sbm-select>\n                </div>\n                <div class='col l3'>\n                    <button class='btn btn-sucess' (click)=\"executeReport(dataInicio.value, dataFim.value)\">Executar</button>\n                </div>\n            </div>\n            <div class=\"col l12 m12 s12\">\n                <div class='report-grid'>\n                    <sbm-grid #report id='campo25'\n                              securityId='campo01'\n                              [dataSource]=''\n                              pagination='10'\n                              [gruping]='false'\n                              (onSelectData)='downloadReport($event)'\n                    ></sbm-grid>\n                </div>\n            </div>\n        </div>\n    "
            },] },
];
/** @nocollapse */
RelatoriosComponent.ctorParameters = function () { return [
    { type: req_http_service_1.ReqHttpService, },
]; };
RelatoriosComponent.propDecorators = {
    'report': [{ type: core_1.ViewChild, args: ['report',] },],
    '_columns': [{ type: core_1.ContentChildren, args: [grid_component_1.SbmGridColumn,] },],
    'columns': [{ type: core_1.Input },],
    'reportUrl': [{ type: core_1.Input },],
    'downloadUrl': [{ type: core_1.Input },],
    'onSelectItem': [{ type: core_1.Output },],
};
exports.RelatoriosComponent = RelatoriosComponent;
