"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var parameters_component_1 = require("../parameters/parameters.component");
var req_http_service_1 = require("../../services/req-http.service");
var ReportComponent = (function () {
    function ReportComponent(_req) {
        var _this = this;
        this._req = _req;
        this.name = '';
        this.description = '';
        this.assync = false;
        this.pdfBase64 = '';
        this.showExecuteResult = false;
        this.showScheduleResult = false;
        this._req.xhrGet('http://10.10.20.112/pdf.php').subscribe(function (ret) { return _this.pdfBase64 = ret.res['data']; });
    }
    Object.defineProperty(ReportComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (value) {
            var _this = this;
            if (typeof value === 'string') {
                this._req.xhrGet(value).subscribe(function (ret) {
                    if (ret.success) {
                        _this.dataSource = ret.res;
                    }
                }, function (err) {
                    console.error('Ocorreu um erro na chamada do serviço =>', err);
                });
            }
            else {
                this._dataSource = value;
                this.name = value.nome;
                this.description = value.descricao;
                this.assync = value.assincrono;
                // rest retorna errado
                var parametros_1 = [];
                if (value.versao.length > 0) {
                    value.versao[0].parametro.map(function (item) {
                        item['tipo'] = item['tipoParametro'];
                        parametros_1.push(item);
                    });
                }
                //
                this.parameters = parametros_1;
            }
        },
        enumerable: true,
        configurable: true
    });
    ReportComponent.prototype.ngOnInit = function () { };
    ReportComponent.prototype.executeReport = function () {
        if (this.reportParameters.models !== undefined && this.reportParameters.models.parametros.length > 0 && this.dataSource != null) {
            /*
            let params = [{
              codigoRelatorio: this.dataSource.codigo,
              versaoRelatorio: this.dataSource.versao[0].id,
              parametros: this.reportParameters.models.parametros
            }];
            this._req.xhrPost('/sabium/relatorio/execucao', params).subscribe(ret => {
              if (ret.success) {
                this.showExecuteResult = true;
                if (this.assync) {
      
                } else {
                }
                console.log('sucesso');
              }
            }, (err: any) => {
              console.error('Ocorreu um erro na chamada do serviço =>', err);
            });*/
            this.showExecuteResult = true;
            this.showScheduleResult = false;
        }
    };
    ReportComponent.prototype.openSchedule = function () {
        this.showExecuteResult = false;
        this.showScheduleResult = true;
    };
    return ReportComponent;
}());
ReportComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-report',
                template: "\n    <div class=\"report-container\">\n      <div class=\"row\">\n        <div class=\"col m12\">\n          <h2>{{name}}</h2>\n          <p>{{description}}</p>\n        </div>\n      </div>\n      <div class=\"row\">\n        <sbm-accordion columns=\"4\" [hidden]=\"_showHideParameters\">\n          <sbm-accordion-group icon=\"&#xE02F;\" [active]=\"true\" label=\"Par\u00E2metros\">\n            <sbm-parameters [dataSource]=\"parameters\"></sbm-parameters>\n            <div class=\"row\">\n              <div class=\"col m6\">\n                <sbm-button text=\"Executar\" color=\"green\" css=\"btn-block\" (_onClick)=\"executeReport()\"></sbm-button>\n                </div>\n              <div class=\"col m6\">\n                <sbm-button text=\"Agendar\" color=\"blue\" css=\"btn-block\" (_onClick)=\"openSchedule()\"></sbm-button>\n              </div>\n            </div>\n          </sbm-accordion-group>\n        </sbm-accordion>\n        <div class=\"col m8 report\">\n          <div class=\"report-result card-panel\" *ngIf=\"showExecuteResult && assync\">\n            Pedido de relat\u00F3rio est\u00E1 sendo executado.\n          </div>\n          <div class=\"report-result card-panel\" *ngIf=\"showExecuteResult && !assync\">\n            <sbm-pdf [data]=\"pdfBase64\"></sbm-pdf>\n          </div>\n          <div class=\"shedule-result card-panel\" *ngIf=\"showScheduleResult\">\n            Agendamento\n          </div>\n        </div>\n      </div>\n    </div>\n  ",
                styles: ["\n    h2 {\n      font-size:2rem;\n      border-bottom:1px solid #9e9e9e;\n      padding-bottom:8px;\n    }\n    p {\n      margin-top:-16px;\n      color:#9e9e9e;\n    }\n    .report-parameters {\n      padding-bottom:20px;\n    }\n  "]
            },] },
];
/** @nocollapse */
ReportComponent.ctorParameters = function () { return [
    { type: req_http_service_1.ReqHttpService, },
]; };
ReportComponent.propDecorators = {
    'dataSource': [{ type: core_1.Input },],
    'reportParameters': [{ type: core_1.ViewChild, args: [parameters_component_1.ParametersComponent,] },],
};
exports.ReportComponent = ReportComponent;
