"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var TabComponent = (function (_super) {
    __extends(TabComponent, _super);
    function TabComponent(_translateService, _http, _viewContainerRef, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._viewContainerRef = _viewContainerRef;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.randomId = '';
        _this.active = false;
        _this.disabled = false;
        _this._text = '';
        return _this;
    }
    Object.defineProperty(TabComponent.prototype, "text", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._text = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._text = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._text = val;
                }
            }
            else {
                this._text = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    TabComponent.prototype.ngOnInit = function () {
        this.randomId = 'sbm-tab-generated-' + (Math.floor((Math.random() * 100000) + 1));
        _super.prototype.validar.call(this, this.securityId);
    };
    return TabComponent;
}(abstract_ngmodel_1.AbstractNgModel));
TabComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-tab',
                template: "\n        <div [id]=\"randomId\" class=\"\" [hidden]=\"!active\">\n            <ng-content></ng-content>\n        </div>\n    "
            },] },
];
/** @nocollapse */
TabComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
    { type: core_1.ViewContainerRef, },
    { type: sharedService_1.SharedService, },
]; };
TabComponent.propDecorators = {
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'text': [{ type: core_1.Input, args: ['label',] },],
    'active': [{ type: core_1.Input },],
    'disabled': [{ type: core_1.Input },],
};
exports.TabComponent = TabComponent;
