"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var core_2 = require("@ngx-translate/core");
var UploadComponent = (function (_super) {
    __extends(UploadComponent, _super);
    function UploadComponent(_sharedService, _http, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._translateService = _translateService;
        _this._label = '';
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.multiple = false;
        _this.notnull = false;
        _this.inputValid = true;
        _this.msgError = 'Campo Incorreto';
        _this.validationsMsg = {
            require: null
        };
        _this._columns = 'col s12 m12 l12 sbm-columns';
        _this.onUpload = new core_1.EventEmitter();
        _this.isNotMasterDetail = true;
        _this._translateService.onLangChange.subscribe(function (ret) {
            _this.validationsMsg['require'] = ret.translations['i18n']['sabium-framework']['validations.fieldRequire'];
            _this.validationsMsg['minLength'] = ret.translations['i18n']['sabium-framework']['validations.fieldMinLength'];
            _this.validationsMsg['maxLength'] = ret.translations['i18n']['sabium-framework']['validations.fieldMaxLength'];
            _this.validationsMsg['pattern'] = ret.translations['i18n']['sabium-framework']['validations.pattern'];
            _this.msgError = ret.translations['i18n']['sabium-framework']['validations.require'];
        });
        return _this;
    }
    Object.defineProperty(UploadComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UploadComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " m12 s12 sbm-columns";
        },
        enumerable: true,
        configurable: true
    });
    UploadComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    UploadComponent.prototype.clearValue = function () {
        this.fileUploader.instance.option('value', '');
        this.inputValid = true;
    };
    UploadComponent.prototype.valueChanged = function ($data) {
        var _this = this;
        var _data = [];
        for (var _i = 0, _a = $data.value; _i < _a.length; _i++) {
            var item = _a[_i];
            var reader = new FileReader();
            reader.onload = function (readerEvt) {
                var binaryString = btoa(readerEvt.target['result']);
                if (_this.multiple) {
                    _data.push(binaryString);
                }
                else {
                    _this.value = binaryString;
                }
            };
            reader.readAsBinaryString(item);
        }
        if (this.multiple) {
            this.value = _data;
        }
        this.onUpload.emit($data.value);
    };
    return UploadComponent;
}(abstract_ngmodel_1.AbstractNgModel));
UploadComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-upload',
                template: "\n        <dx-file-uploader\n            #fileUploader\n            [selectButtonText]='label'\n            [multiple]=\"multiple\"\n            accept=\"*\"\n            readyToUploadMessage=\"...\"\n            uploadMode=\"useForm\"\n            (onValueChanged)=\"valueChanged($event)\"\n            (onUploadStarted)=\"valueChanged($event)\"\n        ></dx-file-uploader>\n        <span *ngIf=\"!inputValid\" class=\"msgError\">{{msgError}}</span>\n    ",
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(UploadComponent)]
            },] },
];
/** @nocollapse */
UploadComponent.ctorParameters = function () { return [
    { type: sharedService_1.SharedService, },
    { type: http_1.Http, },
    { type: core_2.TranslateService, },
]; };
UploadComponent.propDecorators = {
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'multiple': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'fileUploader': [{ type: core_1.ViewChild, args: ['fileUploader',] },],
    'columns': [{ type: core_1.Input },],
    'onUpload': [{ type: core_1.Output },],
};
exports.UploadComponent = UploadComponent;
