"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var DateboxDirective = (function () {
    function DateboxDirective(sbmDatebox) {
        this.sbmDatebox = sbmDatebox;
    }
    DateboxDirective.prototype.validate = function (c) {
        var regexTime = /^([0-9]|0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$/;
        var regexData = /^([0-2]\d|[3][0-1])\/([0]\d|[1][0-2])\/([1-2]\d{3})$/;
        var regexDataTime = /^([0-2]\d|[3][0-1])\/([0]\d|[1][0-2])\/([1-2]\d{3})\s([0-1]\d|[2][0-3])\:([0-5]\d)$/;
        if (c.value) {
            if (this.pickerType == 'both') {
                if (regexDataTime.test(c.value)) {
                    return null;
                }
                else {
                    return {
                        date: true
                    };
                }
            }
            else if (this.pickerType == 'date') {
                if (regexData.test(c.value)) {
                    return null;
                }
                else {
                    return {
                        date: true
                    };
                }
            }
            else if (this.pickerType == 'time') {
                if (regexTime.test(c.value)) {
                    return null;
                }
                else {
                    return {
                        date: true
                    };
                }
            }
        }
        return null;
    };
    return DateboxDirective;
}());
DateboxDirective.decorators = [
    { type: core_1.Directive, args: [{
                selector: '[sbmDatebox]',
                providers: [
                    { provide: forms_1.NG_VALIDATORS, useExisting: core_1.forwardRef(function () { return DateboxDirective; }), multi: true }
                ]
            },] },
];
/** @nocollapse */
DateboxDirective.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core_1.Attribute, args: ['sbmDatebox',] },] },
]; };
DateboxDirective.propDecorators = {
    'pickerType': [{ type: core_1.Input, args: ['pickerType',] },],
};
exports.DateboxDirective = DateboxDirective;
