"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var forms_1 = require("@angular/forms");
var core_1 = require("@angular/core");
require("rxjs/add/operator/map");
var i18n_1 = require("./i18n");
var pt_1 = require("./i18n/pt");
var en_1 = require("./i18n/en");
var fr_1 = require("./i18n/fr");
var noop = function () {
};
var AbstractNgModel = (function () {
    function AbstractNgModel(_sharedService, _translateService, _http) {
        this._http = _http;
        this.onTouchedCallback = noop;
        this.onChangeCallback = noop;
        this.exibirComponente = false;
        this.readonly = false;
        this.onChangeValue = new core_1.EventEmitter();
        this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        this.traducao.projectName = 'sabium-framework';
        this.traducao.reqEN = en_1.reqEN;
        this.traducao.reqFR = fr_1.reqFR;
        this.traducao.reqPT = pt_1.reqPT;
        this.traducao.iniciarIdioma();
    }
    AbstractNgModel.prototype.validarMenu = function (securityId) {
        /*if (securityId == '221') {
            return false;
        }else {
            return true;
        }*/
        return true;
    };
    AbstractNgModel.prototype.validar = function (securityId) {
        this.exibirComponente = true;
        // if (securityId !== '') {
        //     /* ESTÁ FIXO */
        //     let _permissoes: any = localStorage.getItem('permissoes');
        //     let permissoes: any = JSON.parse(_permissoes);
        //
        //     if (permissoes) {
        //         // Encontra as permissões do componente atual
        //         let retPermissoes: any = permissoes.filter((resPermissoes: any) => {
        //             return resPermissoes['url'] === 'app1';
        //         });
        //
        //         let retPermissoesCampos: any = retPermissoes[0].tabelas[0].campos.filter((resCampos: any) => {
        //             return resCampos['name'] === securityId;
        //         });
        //
        //         if (retPermissoesCampos.length > 0) {
        //             if (retPermissoesCampos[0]['acao'] === 'permitido') {
        //                 this.exibirComponente = true;
        //             }
        //
        //             if (retPermissoesCampos[0]['acao'] === 'somente_leitura') {
        //                 this.exibirComponente = true;
        //                 this.readonly = true;
        //             }
        //         }
        //     }
        // } else {
        //     // throw new Error('SecurityId é uma propriedade obrigatória');
        // }
    };
    Object.defineProperty(AbstractNgModel.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (v) {
            if (v !== this.innerValue) {
                this.innerValue = v;
                this.onChangeCallback(v);
                this.onChangeValue.emit(v);
                $(document).ready(function () {
                    Materialize.updateTextFields();
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    AbstractNgModel.prototype.writeValue = function (value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
            this.onChangeValue.emit(value);
            $(document).ready(function () {
                Materialize.updateTextFields();
            });
        }
    };
    AbstractNgModel.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
        $(document).ready(function () {
            Materialize.updateTextFields();
        });
    };
    AbstractNgModel.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
        $(document).ready(function () {
            Materialize.updateTextFields();
        });
    };
    return AbstractNgModel;
}());
exports.AbstractNgModel = AbstractNgModel;
function MakeProvider(type) {
    return {
        provide: forms_1.NG_VALUE_ACCESSOR,
        useExisting: core_1.forwardRef(function () { return type; }),
        multi: true
    };
}
exports.MakeProvider = MakeProvider;
