"use strict";
/*
 *
 * Como utilizar:
 *
 * Injetar esta linha, após o @Component, e antes do "export function"
 *
 * @AutoUnsubscribe([])
 *
 *
 * Caso deseje que algum serviço continue sendo ouvido, mesmo saindo da pagina, faça:
 *
 * @AutoUnsubscribe(['item1Subscription', 'item2Subscription'])
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
function AutoUnsubscribe(blackList) {
    if (blackList === void 0) { blackList = []; }
    return function (constructor) {
        var original = constructor.prototype.ngOnDestroy;
        constructor.prototype.ngOnDestroy = function () {
            for (var prop in this) {
                var property = this[prop];
                if (!blackList.includes(prop)) {
                    if (property && (typeof property.unsubscribe === "function")) {
                        property.unsubscribe();
                    }
                }
            }
            original && typeof original === 'function' && original.apply(this, arguments);
        };
    };
}
exports.AutoUnsubscribe = AutoUnsubscribe;
