"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var FuncoesComponent = (function () {
    function FuncoesComponent() {
    }
    FuncoesComponent.isBlank = function (value) {
        if (value === undefined || value === null || value === '' || value.length === 0) {
            return true;
        }
        return false;
    };
    FuncoesComponent.isNotBlank = function (value) {
        if (this.isBlank(value)) {
            return false;
        }
        else {
            return true;
        }
    };
    FuncoesComponent.testaEmail = function (strEmail) {
        var filtro = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
        if (filtro.test(strEmail)) {
            return true;
        }
        else {
            return false;
        }
    };
    FuncoesComponent.stepValidation = function (el) {
        var ret = function (c) {
            if (c.value != null) {
                if (el.validity.stepMismatch) {
                    return {
                        step: el.validationMessage
                    };
                }
                else {
                    return null;
                }
            }
            return null;
        };
        return ret;
    };
    FuncoesComponent.validarEmail = function (c) {
        if (c.value != null) {
            if (FuncoesComponent.testaEmail(c.value)) {
                return null;
            }
            else {
                return {
                    emailInvalido: true
                };
            }
        }
        return null;
    };
    FuncoesComponent.testaCPF = function (strCPF) {
        strCPF = strCPF.replace(/[^\d]+/g, '');
        var Soma;
        var Resto;
        Soma = 0;
        if (strCPF === '00000000000') {
            return false;
        }
        for (var i = 1; i <= 9; i++) {
            Soma = Soma + parseInt(strCPF.substring(i - 1, i)) * (11 - i);
        }
        Resto = (Soma * 10) % 11;
        if ((Resto === 10) || (Resto === 11)) {
            Resto = 0;
        }
        if (Resto !== parseInt(strCPF.substring(9, 10))) {
            return false;
        }
        Soma = 0;
        for (var i = 1; i <= 10; i++) {
            Soma = Soma + parseInt(strCPF.substring(i - 1, i)) * (12 - i);
        }
        Resto = (Soma * 10) % 11;
        if ((Resto === 10) || (Resto === 11)) {
            Resto = 0;
        }
        if (Resto !== parseInt(strCPF.substring(10, 11))) {
            return false;
        }
        return true;
    };
    FuncoesComponent.validarCNPJ = function (cnpj) {
        if (cnpj == '' || cnpj == undefined || cnpj == null) {
            return false;
        }
        if (typeof (cnpj) != 'string') {
            cnpj = cnpj.toString();
        }
        cnpj = cnpj.replace(/[^\d]+/g, '');
        if (cnpj === '') {
            return false;
        }
        if (cnpj.length !== 14) {
            return false;
        }
        // Elimina CNPJs invalidos conhecidos
        if (cnpj === '00000000000000' || cnpj === '11111111111111' ||
            cnpj === '22222222222222' || cnpj === '33333333333333' ||
            cnpj === '44444444444444' || cnpj === '55555555555555' ||
            cnpj === '66666666666666' || cnpj === '77777777777777' ||
            cnpj === '88888888888888' || cnpj === '99999999999999') {
            return false;
        }
        // Valida DVs
        var tamanho = cnpj.length - 2;
        var numeros = cnpj.substring(0, tamanho);
        var digitos = cnpj.substring(tamanho);
        var soma = 0;
        var pos = tamanho - 7;
        for (var i = tamanho; i >= 1; i--) {
            soma += numeros.charAt(tamanho - i) * pos--;
            if (pos < 2) {
                pos = 9;
            }
        }
        var resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
        if (resultado != digitos.charAt(0)) {
            return false;
        }
        tamanho = tamanho + 1;
        numeros = cnpj.substring(0, tamanho);
        soma = 0;
        pos = tamanho - 7;
        for (var i = tamanho; i >= 1; i--) {
            soma += numeros.charAt(tamanho - i) * pos--;
            if (pos < 2) {
                pos = 9;
            }
        }
        resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
        if (resultado != digitos.charAt(1)) {
            return false;
        }
        return true;
    };
    return FuncoesComponent;
}());
exports.FuncoesComponent = FuncoesComponent;
