"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("rxjs/add/operator/map");
var funcoes_component_1 = require("./funcoes.component");
var i18n = (function () {
    function i18n(_translateService, _sharedService) {
        this._translateService = _translateService;
        this._sharedService = _sharedService;
        this.linguagemAtual = '';
    }
    i18n.prototype.isNotBlank = function (value) {
        return funcoes_component_1.FuncoesComponent.isNotBlank(value);
    };
    i18n.prototype.iniciarIdioma = function () {
        var idiomaPadrao = "pt";
        var colIdiomas = ["en", "fr", "pt"];
        this._translateService.addLangs(colIdiomas);
        this._translateService.setDefaultLang(idiomaPadrao);
        if (this.isNotBlank(this._sharedService.getIdioma())) {
            idiomaPadrao = this._sharedService.getIdioma();
        }
        else {
            if (colIdiomas.indexOf(idiomaPadrao) == -1) {
                idiomaPadrao = "pt";
            }
        }
        this.linguagemAtual = idiomaPadrao;
        this._translateService.setDefaultLang(this.linguagemAtual);
        if (!this.isNotBlank(this._sharedService.getIdioma())) {
            this._sharedService.setIdioma(this.linguagemAtual);
        }
        this.setTraducaoProjeto();
    };
    i18n.prototype.setTraducaoProjeto = function () {
        var me = this;
        var retorno = me.reqPT;
        switch (me.linguagemAtual) {
            case "en":
                retorno = me.reqEN;
                break;
            case "fr":
                retorno = me.reqFR;
                break;
        }
        me._sharedService.setTraducao(me.projectName, retorno);
        var traducao = me.getLanguage();
        me._translateService.setTranslation(me.linguagemAtual, traducao);
        me._translateService.use(me.linguagemAtual);
    };
    i18n.prototype.getLanguage = function () {
        var i18n = "{\"i18n\": {";
        var contRegistros = 0;
        for (var i = 0; i < localStorage.length; i++) {
            if (localStorage.key(i).indexOf("__SBM-SHARED__/i18n/") > -1) {
                var chave = localStorage.key(i).replace("__SBM-SHARED__/i18n/", "");
                if (localStorage[localStorage.key(i)] != 'undefined') {
                    i18n += "\"" + chave + "\": " + JSON.stringify(JSON.parse(localStorage[localStorage.key(i)])[0]) + ",";
                    contRegistros++;
                }
            }
        }
        if (contRegistros > 0) {
            i18n = i18n.substring(0, (i18n.length - 1));
        }
        i18n += "}}";
        return JSON.parse(i18n);
    };
    return i18n;
}());
exports.i18n = i18n;
