"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var rxjs_1 = require("rxjs");
require("rxjs/Rx");
var router_1 = require("@angular/router");
var funcoes_component_1 = require("../models/funcoes.component");
var ng2_webstorage_1 = require("ng2-webstorage");
var ReqHttpService = (function () {
    function ReqHttpService(_router) {
        this._router = _router;
    }
    ReqHttpService.prototype.isLoggedIn = function () {
        if (funcoes_component_1.FuncoesComponent.isNotBlank(localStorage.getItem('token'))) {
            return true;
        }
        else {
            localStorage.clear();
            this._router.navigate(['/login']);
            return false;
        }
    };
    ReqHttpService.salvarToken = function (token) {
        localStorage.setItem('token', token);
    };
    ReqHttpService.semServico = function (xhr) {
        var msgXhr = {
            status: xhr.status,
            responseText: xhr.responseText,
            url: xhr.responseURL
        };
        var _localStorageService = new ng2_webstorage_1.LocalStorageService();
        _localStorageService.store('error-xhr', msgXhr);
    };
    ReqHttpService.prototype.xhrGet = function (url) {
        return rxjs_1.Observable.create(function (observer) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    var codError = xhr.status.toString().slice(0, 1);
                    if (xhr.status === 200) {
                        ReqHttpService.salvarToken(this.getResponseHeader('token'));
                        observer.next({ 'success': true, 'res': (xhr.responseText == "") ? [] : JSON.parse(xhr.responseText) });
                        observer.complete();
                    }
                    else {
                        if (xhr.status === 0 || codError === '4' || codError === '5') {
                            ReqHttpService.semServico(xhr);
                        }
                        observer.error({ 'success': false, 'res': xhr });
                    }
                }
            };
            xhr.open('GET', url, true);
            xhr.setRequestHeader('Content-Type', 'application/json');
            xhr.setRequestHeader('Token', localStorage.getItem('token'));
            xhr.send();
        });
    };
    ReqHttpService.prototype.xhrPost = function (url, params) {
        return rxjs_1.Observable.create(function (observer) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    var codError = xhr.status.toString().slice(0, 1);
                    if (codError === '2') {
                        ReqHttpService.salvarToken(this.getResponseHeader('token'));
                        observer.next({ 'success': true, 'res': (xhr.responseText == "") ? [] : JSON.parse(xhr.responseText) });
                        observer.complete();
                    }
                    else {
                        if (xhr.status === 0 || codError === '4' || codError === '5') {
                            ReqHttpService.semServico(xhr);
                        }
                        observer.error({ 'success': false, 'res': xhr });
                    }
                }
            };
            xhr.open('POST', url, true);
            xhr.setRequestHeader('Content-Type', 'application/json');
            xhr.setRequestHeader('Token', localStorage.getItem('token'));
            xhr.send((params) ? JSON.stringify(params) : null);
        });
    };
    ReqHttpService.prototype.xhrPut = function (url, params) {
        return rxjs_1.Observable.create(function (observer) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    var codError = xhr.status.toString().slice(0, 1);
                    if (codError === '2') {
                        ReqHttpService.salvarToken(this.getResponseHeader('token'));
                        observer.next({ 'success': true, 'res': (xhr.responseText == "") ? [] : JSON.parse(xhr.responseText) });
                        observer.complete();
                    }
                    else {
                        if (xhr.status === 0 || codError === '4' || codError === '5') {
                            ReqHttpService.semServico(xhr);
                        }
                        observer.error({ 'success': false, 'res': xhr });
                    }
                }
            };
            xhr.open('PUT', url, true);
            xhr.setRequestHeader('Content-Type', 'application/json');
            xhr.setRequestHeader('Token', localStorage.getItem('token'));
            xhr.send(JSON.stringify(params));
        });
    };
    ReqHttpService.prototype.xhrDelete = function (url) {
        return rxjs_1.Observable.create(function (observer) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    var codError = xhr.status.toString().slice(0, 1);
                    if (codError === '2') {
                        ReqHttpService.salvarToken(this.getResponseHeader('token'));
                        observer.next({ 'success': true, 'res': (xhr.responseText == "") ? [] : JSON.parse(xhr.responseText) });
                        observer.complete();
                    }
                    else {
                        if (xhr.status === 0 || codError === '4' || codError === '5') {
                            ReqHttpService.semServico(xhr);
                        }
                        observer.error({ 'success': false, 'res': xhr });
                    }
                }
            };
            xhr.open('DELETE', url, true);
            xhr.setRequestHeader('Content-Type', 'application/json');
            xhr.setRequestHeader('Token', localStorage.getItem('token'));
            xhr.send();
        });
    };
    ReqHttpService.prototype.xhrDownload = function (url, params) {
        return rxjs_1.Observable.create(function (observer) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    var codError = xhr.status.toString().slice(0, 1);
                    if (codError === '2') {
                        if (this.getResponseHeader('token')) {
                            ReqHttpService.salvarToken(this.getResponseHeader('token'));
                        }
                        observer.next({ 'success': true, 'res': (xhr.responseText == "") ? [] : JSON.parse(xhr.responseText) });
                        observer.complete();
                    }
                    else {
                        if (xhr.status === 0 || codError === '4' || codError === '5') {
                            ReqHttpService.semServico(xhr);
                        }
                        observer.error({ 'success': false, 'res': xhr });
                    }
                }
            };
            xhr.responseType = 'arraybuffer';
            xhr.open((params ? 'POST' : 'GET'), url, true);
            xhr.setRequestHeader("Content-Type", "application/json; charset=utf8");
            xhr.setRequestHeader('Token', localStorage.getItem('token'));
            xhr.send((params ? JSON.stringify(params) : null));
        });
    };
    return ReqHttpService;
}());
ReqHttpService.decorators = [
    { type: core_1.Injectable },
];
/** @nocollapse */
ReqHttpService.ctorParameters = function () { return [
    { type: router_1.Router, },
]; };
exports.ReqHttpService = ReqHttpService;
